	PROGRAM SUMGDT2
C
C	OUTPUTS HALF-HOURLY DATA IN .GDT FILES
C	USE: SUMGDT InputFile OutputCSVfile [datatype]
C	WHERE InputFile IS FULL FILE PATH, AND .CSV is appended to Outputfile
C	Data type can optinally be given. If not given, uses D(O3-NO)
C
C	DEFAULT INPUT FILE IS I:\TMP.LIS, OUTPUT=I:\TMP.CSV
C
C	TO O3NO.CSV.  RUN LIST IS INPUT IN O3NOCSV.IN
C
	PARAMETER (MAXDAT=1000,MAXOUT=48)
C
	CHARACTER INFILE*40,OUTFIL*40,CHANID*9
	DATA CHANID/'         '/
C
	REAL T(MAXDAT),C(MAXDAT),OUTDAT(MAXOUT),OUTTIM(MAXOUT)
C
	LOGICAL ERRIND
	CHARACTER INLIN*80,CHANIN*40,RUNUIC*40,RUNID*8,
     &	 OUTCHR(MAXOUT)*12
C
	CHARACTER*2 UNCCHR(12)/"JA","FB","MR","AP","MY","JN",
     &	 "JL","AU","ST","OC","NV","DE"/
C
	CALL GETARG (1,INFILE)
	IF (INFILE(1:1).EQ.'?') THEN
		WRITE (6,*) 'OUTPUTS HALF HOURLY DATA IN .GDT FILES'
		WRITE (6,*) 'INTERPOLATES WHEN NEEDED'
		WRITE (6,*) 'USE: SUMGDT InputFile OutputCSVfile'//
     &		 ' [datatype]'
		WRITE (6,*) 'Dflt: SUMGDT I:\TMP.LIS I:\TMP.CSV '//
     &		 'D(O3-NO)'
		WRITE (6,*) 'NOTE: For UNC runs (first 2 char=month i'
     &		 //'d) "hourly" is every 100 minutes'
		CALL EXIT (2)
	ELSEIF (INFILE(1:1).EQ.' ') THEN
		INFILE='I:\TMP.LIS'
		LINFIL=10
	ELSE
		LINFIL=LNBLNK(INFILE)
	ENDIF
	CALL GETARG (2,OUTFIL)
	IF (OUTFIL(1:1).EQ.' ') THEN
		OUTFIL='I:\TMP.CSV'
		LOUTFL=10
	ELSE
		LOUTFL=LNBLNK(OUTFIL)
	ENDIF
	CALL GETARG (3,RUNID)
	IF (RUNID(1:1).NE.' ') THEN
		I=LNBLNK(RUNID)
		CHANID(1:I)=RUNID(1:I)
		LCHNID=I+1
	ELSE
		CHANID='D(O3-NO) '
		LCHNID=9
	ENDIF
C
	RUNUIC='.\'
	LRUNUC=2
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
   70	READ (1,1,END=71) INLIN
    1	FORMAT (A)
	IF (INLIN(1:4).EQ.'GDT=') THEN
		RUNUIC=INLIN(5:)
		LRUNUC=LNBLNK(RUNUIC)
	ENDIF
	GOTO 70
   71	CLOSE (UNIT=1)
C
C	OPEN INPUT FILE
C
	OPEN (UNIT=3,FILE=INFILE,STATUS='OLD',ERR=2)
	GOTO 3
    2	WRITE (6,*) 'FILE = '//INFILE(1:LINFIL)//' does not exist.'
	CALL EXIT (2)
    3	CONTINUE
C
C	OPEN OUTPUT FILE
C
	OPEN (UNIT=2,FILE=OUTFIL,STATUS='UNKNOWN')
	WRITE (2,101) CHANID(1:LNBLNK(CHANID)),(FLOAT(I)/2.0,
     &	 I=1,MAXOUT)
  101	FORMAT ('RunID,Msg,',A/',Hourly',9(',',F3.1),39(',',F4.1))
C
    5	READ (3,1,END=990) RUNID
	IF (RUNID(1:1).EQ.' ') THEN
		WRITE (2,1)
		GOTO 5
	ELSEIF (RUNID(1:1).EQ.'!') THEN
		GOTO 5
	ENDIF
	LRUNID=LNBLNK(RUNID)
 	INLIN=RUNUIC(1:LRUNUC)//RUNID(1:LRUNID)//'.GDT'
	OPEN (UNIT=1,FILE=INLIN,STATUS='OLD',ERR=4)
C
C	DETERMINE OUTPUT TIMES BASED ON WHETHER THIS IS A UNC RUN
C
	DO 102 I=1,12
	IF (RUNID(1:2).EQ.UNCCHR(I)) THEN
C
C		UNC
		DO 103 J=1,MAXOUT
  103		OUTTIM(J)=380.0+(50.0*FLOAT(J))
		GOTO 10
	ENDIF
  102	CONTINUE
C
C	NOT UNC
	DO 104 I=1,MAXOUT
  104	OUTTIM(I)=30.0*FLOAT(I)
	GOTO 10
C
    4	WRITE (6,*) 'FILE = ',INLIN(1:LRUNUC+LRUNID+4),
     &	 ' does not exist.'
	WRITE (2,1) RUNID(1:LRUNID)//',No file.'
	GOTO 5
C
C
   10	READ (1,1,END=990) INLIN
	IF (INLIN(1:3).NE.'3 0') GOTO 902
	READ (1,1,END=901) INLIN
C
	MINPRI=3
	N=0
C
C	READ NEXT CHANNEL
C	USE CHANNEL WITH PRIORITY LESS THAN MINPRI
C
  100	READ (1,1,END=119) CHANIN
	IF (CHANIN(1:LCHNID).NE.CHANID(1:LCHNID)) GOTO 100
	CALL PARSE0 (3,CHANIN,40)
	CALL PARSEI (3,IPRI,ERRIND,CHANIN)
	IF (ERRIND) IPRI=1
	IF (IPRI.GE.MINPRI) GOTO 100
C
C	READ THIS CHANNEL
C
	MINPRI=IPRI
	N=0
C
  110	READ (1,1,END=119) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 110
	IF (INLIN(1:1).EQ.'.') GOTO 100
	CALL PARSE0 (2,INLIN,80)
	CALL PARSER (1,TI,ERRIND,INLIN)
	IF (ERRIND) GOTO 100
	CALL PARSER (2,CI,ERRIND,INLIN)
	IF (ERRIND) GOTO 100
C
	IF (TI.LT.0.0) GOTO 110
	IF (N.EQ.MAXDAT) THEN
		WRITE (6,*) 'INCREASE MAXDAT'
		CLOSE (UNIT=1)
		WRITE (2,1) RUNID(1:LRUNID)//',Too many points'
		GOTO 5
	ENDIF
	N=N+1
	T(N)=TI
	C(N)=CI
	GOTO 110
C
  119	CLOSE (UNIT=1)
C
C	DONE WITH FILE
C
	IF (N.EQ.0) THEN
		WRITE (2,1) RUNID(1:LRUNID)//',Not found'
		GOTO 5
	ENDIF
C
	CALL ARALIN(OUTDAT,N,T,C,MAXOUT,OUTTIM,IND,-9.99E9)
	IF (IND.LT.0) THEN
		WRITE (2,121) RUNID(1:LRUNID),IND
  121		FORMAT (A,',Bad data (',I5,')')
		GOTO 5
	ENDIF
	DO 130 I=1,MAXOUT
	IF (OUTDAT(I).EQ.-9.99E9) THEN
		OUTCHR(I)=','
	ELSE
		WRITE (OUTCHR(I),'('','',1PE11.4)') OUTDAT(I)
	ENDIF
  130	CONTINUE
	WRITE (2,132) RUNID(1:LRUNID),
     &	 (OUTCHR(I)(1:LNBLNK(OUTCHR(I))),I=1,MAXOUT)
  132	FORMAT (A,',',48A)
C	WRITE (6,*) RUNID(1:LRUNID),' ok'
	GOTO 5
c
C	ERRORS
901	WRITE (6,*) 'Unexpected EOF reading headers'
	GOTO 900
902	WRITE (6,*) 'Unexpected format code (',INLIN(1:LNBLNK(INLIN)),
     &	 '). Expected "3 0"'
C
900	CLOSE (UNIT=1)
	WRITE (2,1) RUNID(1:LRUNID)//',Bad format.'
	GOTO 5
C
C	DONE
C
  990	CLOSE (UNIT=2)
	CLOSE (UNIT=3)
	WRITE (6,*) 'File = '//OUTFIL(1:LOUTFL)//' created.'
	CALL EXIT(0)
	END