	PROGRAM SUMCINP
C
C	** THIS VERSION DOES NOT USE USENAMES.LIS
C
C	Summarizes initial concentrations taken from .INP files
C	USE: SUMCINP [?]
C	"?": GIVE HELP MESSAGE, OTHERWISE GET INPUT FROM FOLLOWING:
C	RUN LISTING (.INP FILE NAMES) FROM I:\TMP.LIS
C	REPLACES NAMES FOUND IN E:\CHAMCALC\OLDNAMES.LIS
C	OUTPUT GOES TO I:\TMP.CSV
C
	PARAMETER (MAXSPE=200,MAXSUB=150)
	CHARACTER SPELIS(MAXSPE)*8,RUNID*8,INLIN*80,FILNAM*80,INPUIC*60
	CHARACTER SUBIN(MAXSUB)*8,SUBOUT(MAXSUB)*8
	CHARACTER NAMEIN*8,INFILE*80,OUTFIL*80,CHAR*8
	REAL CINIT(MAXSPE)
	INTEGER NSPE,NUSE,NSUB
	LOGICAL XIND
C
	PARAMETER (MAXTMP=80)
	INTEGER NTMPR
	REAL TTEMPR(MAXTMP),TEMPR(MAXTMP),TEND
C
	CALL GETARG (1,INLIN)
	IF (INLIN(1:1).EQ.'?'.OR.INLIN(2:2).EQ.'?') THEN
		WRITE (6,*) "Summarizes initial concentrations taken "
     &			,"from .INP files"
		WRITE (6,*) "USE: SUMCINP [infile outfile]"
		WRITE (6,*) "     infile = Run listing (default=i:\tm"
     &			,"p.lis"
		WRITE (6,*) "     outfile = Output data (default=i:\t"
     &			,"mp.csv"
	ELSEIF (INLIN(1:1).NE.' ') THEN
		INFILE=INLIN
		CALL GETARG(2,INLIN)
		IF (INLIN(1:1).NE.' ') THEN
			OUTFIL=INLIN
		ELSE
			OUTFIL='I:\TMP.CSV'
		ENDIF
	ELSE
		INFILE='I:\TMP.LIS'
		OUTFIL='I:\TMP.CSV'
	ENDIF
	LINFIL=LNBLNK(INFILE)
	LOUTFL=LNBLNK(OUTFIL)
C
C	GET SPECIES LIST IF NOT DEFAULT
C
C
C	GET REPLACEMENT LIST
C
	NSUB=0
	INQUIRE (FILE='\CHAMCALC\OLDNAMES.LIS',EXIST=XIND)
	IF (XIND) THEN
		OPEN (UNIT=1,FILE='\CHAMCALC\OLDNAMES.LIS')
		NSUB=0
  101		READ (1,1,END=121) INLIN
		IF (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'!'.OR.
     &		 INLIN(9:10).NE.'  '.OR.INLIN(11:11).EQ.' ') GOTO 101
		NSUB=NSUB+1
		SUBIN(NSUB)=INLIN(1:8)
		SUBOUT(NSUB)=INLIN(11:18)
		GOTO 101
  121		CLOSE (UNIT=1)
	ENDIF
C
C	GET .INP FILE LOCATION
C
	INPUIC=".\"
	LINPUC=2
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
  20	READ (1,1,END=22) INLIN
    1	FORMAT (A)
	IF (INLIN(1:4).EQ.'INP=') THEN
		INPUIC=INLIN(5:)
		LINPUC=LNBLNK(INPUIC)
	ENDIF
	GOTO 20
   22	CLOSE (UNIT=1)
C
C	GET RUN LIST FROM I:\TMP.LIS
C
	OPEN (UNIT=1,FILE=INFILE(1:LINFIL),ERR=990)
C
C	OPEN AND INITIALIZE OUTPUT FILE
C
	OPEN (UNIT=2,FILE=OUTFIL(1:LOUTFL),STATUS='UNKNOWN')
	WRITE (2,1,ERR=992) "Created by SUMINP.FOR"
	WRITE (2,1) "Initial concentrations from .INP files"
	WRITE (2,1)
	WRITE (2,1) 'RunID,Msg,Tend,Char,See Below'
C
C	READ NEXT RUNID
C
	NRUNS=0
	NSPE=2
	SPELIS(1)='TEMPR   '
	CINIT(1)=0.0
	SPELIS(2)='OHFIT   '
	CINIT(2)=0.0
	C0=C0X	! DUMMY
  200	READ (1,1,END=999) RUNID
	IF (RUNID(1:1).EQ.' '.OR.RUNID(1:1).EQ.'!') THEN
		WRITE (2,1)
		GOTO 200
	ENDIF
	LC=LNBLNK(RUNID)
	FILNAM=INPUIC(1:LINPUC)//RUNID(1:LC)//'.INP'
	OPEN (UNIT=3,FILE=FILNAM,STATUS='OLD',ERR=289)
C
	DO 201 I=1,NSPE
  201	CINIT(I)=0.0
	NTMPR=0
	TEND=0.0
	CHAR=''
C
  202	READ (3,1,END=279) INLIN
C	IF (INLIN(1:1).NE.'.') GOTO 202
  203	READ (3,1,END=279) INLIN
 2030	IF (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'!') GOTO 203
	IF (INLIN(1:8).EQ.'L#TEMPR ') THEN
 2041		READ (3,1,END=279) INLIN
		IF (INLIN(1:1).EQ.'#'.OR.INLIN(2:2).EQ.'#') GOTO 2030
		CALL PARSE0 (2,INLIN,80)
		IF (NTMPR.EQ.MAXTMP) THEN
			WRITE (6,*) 'INCREASE MAXTMP'
			GOTO 2043
		ENDIF
		NTMPR=NTMPR+1
		CALL PARSER (1,TTEMPR(NTMPR),XIND,INLIN)
		IF (XIND) GOTO 2043
		CALL PARSER (2,TEMPR(NTMPR),XIND,INLIN)
		IF (XIND) GOTO 2043
		GOTO 2041
 2043		NTMPR=0
		GOTO 203
	ELSEIF (INLIN(1:8).EQ.'C#OHFIT ') THEN
		CINIT(2)=1.0
		GOTO 203
	ELSEIF (INLIN(1:8).EQ.'L#OHFIT ') THEN
		CINIT(2)=1.0
		GOTO 203
	ELSEIF (INLIN(1:6).EQ.'@CHAR\') THEN
		LCH=LNBLNK(INLIN)
		CHAR=INLIN(7:LCH-4)
		LCH=LCH-10
	ENDIF
	CALL PARSE0 (2,INLIN,80)
	CALL PARSER (2,C0,XIND,INLIN)
	IF (XIND) GOTO 203
	CALL PARSE1 (1,NAMEIN,I,8,INLIN)
	IF (NAMEIN.EQ.'TEMPR   ') THEN
		NTMPR=1
		TTEMPR(1)=0.0
		TEMPR(1)=C0
	ELSEIF (NAMEIN.EQ.'OHFIT   ') THEN
		CINIT(2)=1.0
	ELSEIF (NAMEIN.EQ.'.TEND   ') THEN
		TEND=C0
	ELSE
		READ(NAMEIN,'(G8.0)',ERR=2031) C0X
	ENDIF
	GOTO 203
 2031	CONTINUE
	DO 220 I=1,NSUB
		IF (NAMEIN.EQ.SUBIN(I)) THEN
			NAMEIN=SUBOUT(I)
			GOTO 221
		ENDIF
  220	CONTINUE
  221	CONTINUE
	DO 210 I=1,NSPE
		IF (NAMEIN.EQ.SPELIS(I)) THEN
			CINIT(I)=C0
			GOTO 203
		ENDIF
  210	CONTINUE
	IF (NSPE.EQ.MAXSPE) GOTO 203
	NSPE=NSPE+1
	WRITE (6,*) NAMEIN,NSPE
	SPELIS(NSPE)=NAMEIN
	CINIT(NSPE)=C0
	GOTO 203
C
  279	CLOSE (UNIT=3)
	IF (NTMPR.EQ.1) THEN
		CINIT(1)=TEMPR(1)
	ELSEIF (NTMPR.GT.0.AND.TEND.GT.0.0) THEN
		TTLAST=0.0
		TLAST=TEMPR(1)
		IF (TTEMPR(1).GT.0.0) THEN
			I1=1
		ELSE
			I1=2
		ENDIF
		TSUM=0.0
		DO 280 I=I1,NTMPR
			DT=TTEMPR(I)-TTLAST
			IF (DT.GT.0.0) TSUM=TSUM+(DT*(TLAST+TEMPR(I)))
			TTLAST=TTEMPR(I)
			TLAST=TEMPR(I)
			IF (TTLAST.GT.TEND) GOTO 281
  280		CONTINUE
		CINIT(1)=0.5*TSUM/TTLAST
	ENDIF
  281	CONTINUE	
C
	WRITE (2,2791) RUNID(1:LC),TEND,CHAR(1:LCH),(CINIT(I),I=1,NSPE)
 2791	FORMAT (A,',,',F6.1,',',A,200(',',1PE10.3))
	NRUNS=NRUNS+1
	GOTO 200
C
  289	WRITE (2,1) RUNID(1:LC)//',No file'
	GOTO 200
C
  999	CLOSE (UNIT=1)
	WRITE (2,1011) (SPELIS(I)(1:LNBLNK(SPELIS(I))),I=1,NSPE)
 1011	FORMAT ('RunID,Msg,Tend,Char',200(',',A))
	CLOSE (UNIT=2)
	WRITE (6,*) 'File '//OUTFIL(1:LOUTFL)//' created with ',
     &	 NSPE,' initial concentrations for ',NRUNS,' runs'
	IF (NSPE.EQ.MAXSPE) WRITE (6,*) 'WARNING! Maximum '//
     &	 'number of output species reached'
	CALL EXIT
c
  990	WRITE (6,*) "FILE=I:\TMP.LIS DOES NOT EXIST."
	CALL EXIT
  992	WRITE (6,*) 'Unable to write to I:\TMP.CSV'
	CALL EXIT
	END