	SUBROUTINE INTMAIN (PGMNAM)
C
C --- INTMAIN.FOR     MAIN INTEGRATION PGM.
C-
C --- CALLS INTINI, MODL, OPTINI, RDCKC, STOREC, INT,
C           INTOPT
C --- UNITS USED:  1-3  (INITIALIZED FOR INPUT)
C                  OUT  (OPENED FOR OUTPUT.  CLOSED AT END)
C                  LOGU (OPEN,WRITE,CLOSE.  NO CALLS WHEN OPEN)
C                  TMP1 (OPEN, CLOSE TO DELETE)
C
C
C	SPECIFICATIONS OF ALL COMMON VARIABLES AND PARAMETERS
C
C
	INCLUDE 'MAINSPC.FOR'
C
	CHARACTER*16 PGMNAM
	LOGICAL FLAG
C
	MOD=PGMNAM
C
C	FOLLOWING NEEDED FOR F77L
C
C	CALL UNDER0(.TRUE.)
C	CALL UNDFL (FLAG)
C	CALL INVALOP(FLAG)
C
	CALL CPU_TIME(TTIME1)
	TTINT=0.0
C
C	INITIALIZE
C
	CALL INTINI
	IF (FILES(1:1).EQ.' ') GOTO 9999
C
	EOF=.FALSE.
	ABORT=.FALSE.
	NINT=0
	NTERR=0
	NRUN=0
C
C	INITIALIZE PARAMETERS AND READ IN MODEL
C
 1000	NERR=0
C
	CALL MODL
C
C	OPT INITIALIZING
C
	IF (OPT) THEN
		CALL OPTINI
		IF (ABORT) GOTO 9998
	ENDIF
C
C
C	READ INIT CONDS FOR INTEGRATIONS (RDCKD), DO THE CALC (INT)
C	AND (IF PASS=T) SAVE THE RESULTS
C
 2000	CALL RDCKC
C
	NTERR=NTERR+NERR
	IF (LAST) GOTO 2900
	IF (EOF) GOTO 2900
	IF (ERQUIT.AND.NERR.NE.0) GOTO 2900
C
	IF (PASS) CALL STOREC
	IF (NEWVCO) THEN
		NERR=0
		CALL RDVCO
		NTERR=NTERR+NERR
		NEWVCO=.FALSE.
	ENDIF
	IF (ERQUIT.AND.NERR.NE.0) GOTO 2900
C
C	RUN THE SIMULATION.  FIGURE HOW LONG IT TAKES
C
	CALL INTPRP
C
	CALL CPU_TIME (TIMINT1)
C
	CALL INTSUB
C
	CALL CPU_TIME(TIMINT)
	TTINT=TTINT+TIMINT-TIMINT1
	NINT=NINT+1
	IF (PASS) CALL CLOSEC
C
	NERR=0
	GOTO 2000
C
C       '.END' OR <EOF> IN RDCKC
C
 2900	IF (EOF.OR.(ERQUIT.AND.NTERR.NE.0)) GOTO 9000
C
	IF (OPT) THEN
		CALL INTOPT
		IF (INDOPT.NE.-3) THEN
			NERR=0
			GOTO 2000
		ENDIF
	ELSE
		GOTO 1000
	ENDIF
C
C	DONE
C
 9000	IF (NTERR.GT.0) THEN
		WRITE (ICRT,9011) NTERR
 9011		FORMAT (' INTMAIN: ',I3,' INPUT ERRORS OCCURRED')
		WRITE (ICRT,*) 'CALCULATION ABORTED'
	ENDIF
C
C	WRITE TIME INFO
C	
	CALL CPU_TIME(TTIME)
	TTIME=TTIME-TTIME1
	WRITE (OUT,9013) FILES,NINT,TTINT,TTIME
 9013	FORMAT (' INT ',A8,':',I4,' CALCS.  INT, TOT TIMES ='
     &   ,F7.2,',',F7.2,' SEC')
C
	IF (.NOT.SHOWT) THEN
		IF (NRUN.EQ.0) THEN
			WRITE (ICRT,9022) FILES,NINT,TTINT,TTIME
 9022			FORMAT (' INT ',A8,':',I4,' Calcs.  T(int)=',F7.2,
     &			 ', T(tot)=',F7.2,' sec.')
		ELSE
			WRITE (ICRT,9023) FILES,NINT,NRUN,TTINT,
     &			 TTIME
 9023			FORMAT (' INT ',A8,':',I4,' Calcs.  Last #',I4,
     &			 '.  T(int)=',F7.2,', T(tot)=',F7.2,' sec.')
		ENDIF
	ENDIF
C
	IF (OPT) WRITE (ICRT,9015) NITER
 9015	FORMAT (' ',I3,' ITERATIONS IN OPTIMIZATION.')
C
C	CLOSE FILES, DELETE SCRATCH FILES.
C
 9998	CALL INTEND
C
C	WRITE FILE WITH COEF'S IF NEEDED
C
	IF (WRITCO) THEN
		OPEN (UNIT=TMP1,FILE='VARYCO.CSV',STATUS='UNKNOWN')
		WRITE (TMP1,'(''Coefs,'',I4)') NCOEFV
		WRITE (TMP1,'(A,'','',1PG13.4)')
     &		 (COEFNM(I)(1:LNBLNK(COEFNM(I))),COEF(I),I=1,NCOEFV)
		CLOSE (UNIT=TMP1)
		WRITE (ICRT,*) 'Variable coefficients saved in File '//
     &		 '= VARYCO.CSV.'
	ENDIF
C
 9999	CONTINUE
C	CALL INVALOP(FLAG)
C	IF (FLAG) WRITE (ICRT,*) 'Invalid operation errors occurred'
C	CALL UNDFL(FLAG)
C	IF (FLAG) WRITE (ICRT,*) 'Underflow errors occurred'
	CALL EXIT (0)
	END
