C --- INT.FOR:  PART OF 'INT' SEGMENT
C --- CALLED BY INTMAIN.
C --- CALLS KCONST, PRNTC, LSODE, OPTSAV (OPTSV1), NEWST
C --- I/O : WRITES TO OUT,ICRT
C ---       READS FROM TIMEU
C
	SUBROUTINE INTSUB
C
C	SPECIFICATIONS
C
	INCLUDE 'MAINSPC.FOR'
	LOGICAL CRTOUT/.FALSE./
C
C	BUFFER FOR JMATRX
C
	REAL*4 JBUF(MAXASQ)
C
C
	IF (T0.LT.0.0.OR.DPRN.LE.0.0) THEN
                WRITE (OUT,*) 'ILLEGAL T0 =',T0,', OR DPRN =',
     &           DPRN,' IN INT.'
                STOP 'BAD T0 OR DPRN IN INT'
	ENDIF
C
C	MODIFY INITIAL CONCENTRATIONS OF SPECIES IN GROUPS
C
	IF (AIRSHD) AIRSHD=COEF(INDEF).NE.0.0
C
	CALL KCONST
C
	IF (OPT) CALL OPTSAV
C
	ABORT=.FALSE.
C
C     INITIALIZE TIME COUNTERS AND PRINT/SAVE INITIAL VALUES
C
      T=T0
      PRNT=T0
      NPT=1
      TCUR=T0
C                               !TIME FOR INTEGRATOR
      TLAST=TEND+DPRN
C
      ITOL=1
      ATOL(1)=EPS*CMIN
C
C     INITIALIZE FOR THE INTEGRATION
C
      KFLAG=1
      BUF(5)=0.0
C                              !BUF(5)=H0      (0=DEFAULT, ALL CASES)
      BUF(6)=0.0
C                              !BUF(6)=HMAX
      BUF(7)=0.0
C                              !BUF(7)=HMIN
      BUF(8)=0.0
      BUF(9)=0.0
      BUF(10)=0.0
      IBUF(5)=0
C                               !IBUF(5)=MAXORD
      IBUF(6)=MAXSTP
C                               !IBUF(6)=MAX NO. STEPS/LSODE CALL
      IBUF(7)=0
C                               !IBUF(7)=MAX NO MESSAGES FROM LSODE
      IBUF(8)=0
      IBUF(9)=0
      IBUF(10)=0
      IBUF(11)=0
C                               !IBUF(11)=NST
      IBUF(13)=0
C                               !IBUF(13)=NINV
      IOPT=1
      IF (NVCO.EQ.0) TNEXT=TEND+DPRN
C
C     PRNTC CALCULATES DERIVATIVES, STEADY STATE, BO CONC'S,
C     PRINTS AND SAVES VALUES (IF REQUIRED), INTERPOLATES
C     (IF NECESSARY).
C
      FIRST=.TRUE.              ! TELLS NEWST TO INITIALIZE BO CALC
      CALL NEWST (T,C(NA1))
C
      IF (OPT) THEN
            CALL OPTSV1              ! OPTSV1 DEFINES PRNT (NEXT TIME)
            BUF(1)=AMIN1(PRNT,TNEXT) ! POINT BEYOND WHERE INT DOESN'T GO
      ELSE
            IF (.NOT.MAXONL) CALL PRNTC
            PRNT=AMIN1(T0+DPRN,TEND)
            BUF(1)=AMIN1(TEND,TNEXT)
      ENDIF
C
      FIRST=.FALSE.
C
C     DO THE INTEGRATION, UNLESS THIS IS A 'DUMMY' CALL
C
      IF (T0.GE.TEND) RETURN
C
	IF (WRITK) THEN
		OPEN (UNIT=TMP2,FILE='WRITK.CSV',STATUS='UNKNOWN')
		WRITE (TMP2,7701) TEMP,(I,RXNLBL(I),RK(I),
     &		 I=1,NRXN)
 7701		FORMAT ('Rate constants'/'T,',F8.3//
     &		 'No,Lbl,k'/(I3,',',A,',',E12.4))
		WRITE (6,*) 'File = WRITK.CSV written'
		CLOSE (UNIT=TMP2)
		CALL EXIT
	ENDIF
C
	IF (SHOWT) THEN
		IF (CRTOUT) THEN
			WRITE (ICRT,'(1X)')
		ELSE
			CRTOUT=.TRUE.
		ENDIF
	ENDIF
C -------------------------------------------------------------
 3000 TSTP=AMIN1(PRNT,TNEXT)
      CALL LSODE (C(NA1),T,TSTP,ITOL,EPS,ATOL,4,KFLAG,
     &   IOPT,BUF,BUFLEN,IBUF,IBFLEN,MF,JBUF)
C
      ABORT=KFLAG.LT.2
      IOPT=0
C
C     IF VARIABLE COEF'S AND NEXT TIME REACHED, READ IN NEW VALUES
C
      IF (TSTP.EQ.TNEXT.AND..NOT.ABORT) THEN
          READ (TIMEU) TNEXT,(VINT(I),VSLOPE(I),I=1,NVCO)
          TLAST=TEND+DPRN
C                              ! THIS MAKES DIFFUN RE-CALC TIME-VARYING PARMS.
CD         WRITE (OUT,*) ' INT: NEW TNEXT= ',TNEXT
          IF (TSTP.LT.PRNT) THEN
C
              IF (OPT) THEN
                  BUF(1)=AMIN1(TNEXT,PRNT)
              ELSE
                  BUF(1)=AMIN1(TNEXT,TEND)
              ENDIF
C
              GOTO 3000
          ENDIF
      ENDIF
C
C     STEP TO PRNT COMPLETED (OR ABORT)
C
      NPT=NPT+1
C
      IF (OPT) THEN
          CALL NEWST (T,C(NA1))
          CALL OPTSV1
          IF (PRNT.GT.TEND) GOTO 9000
          BUF(1)=AMIN1(PRNT,TNEXT)
      ELSE
          CALL NEWST (T,C(NA1))
          IF (.NOT.MAXONL) CALL PRNTC
          PRNT=AMIN1(PRNT+DPRN,TEND)
          IF (NVCO.NE.0) THEN
              IF (ABS(PRNT-TNEXT)/PRNT.LE.1.0E-6) PRNT=TNEXT
          ENDIF
          BUF(1)=AMIN1(TEND,TNEXT)
      ENDIF
C
      IF (ABS(PRNT-TEND)/TEND.LE.1.0E-6) PRNT=TEND
      IF (ABORT) GOTO 8000
CD     WRITE (OUT,*) ' INT,AFTER PRINT: T,TEND,PRNT,TNEXT=',T,TEND,
      IF (T.GE.TEND) GOTO 9000
      GOTO 3000
C -------------------------------------------------------------
C
C     ABORT
C
 8000 WRITE (OUT,8002) T,KFLAG
 8002 FORMAT (/' INTEGRATION FAILED AT T =',1PE11.3,',  KFLAG =',I5)
      WRITE (ICRT,8002) T,KFLAG
      NTERR=NTERR+1
      TEND=T
C
C     DONE
C
 9000 IF (NPT.EQ.1) GO TO 9998
      IF (INTOUT) THEN
          WRITE (OUT,9004) NINV,NST
 9004     FORMAT(/' INTEGRATION COMPLETE:',I7,' INVERSIONS, AND',
     &    I7,' STEPS')
      ELSE
          WRITE (OUT,9005) NINV,NST
 9005     FORMAT (' ',10X,I5,' INVERSIONS AND',I7,' STEPS.')
      ENDIF
C      IF (SHOWT) WRITE (ICRT,'(1X)')
      RETURN
C
 9998 WRITE (OUT,9997)
 9997 FORMAT (/' INTEGRATION NOT ATTEMPTED')
      RETURN
      END
C --- END OF INT.FOR
