C --- PHOTKS.FOR
C     FILE ALSO INCLUDES SUBROUTINE SETPHK
C --- CALLED BY RDCKC
C --- CALLS FILNAM
C --- UNITS USED:  TMP2  (OPENS,READS,CLOSES IF IND=1)
C
      SUBROUTINE PHOTKS (IND)
C
C      CALCULATE ALL PHOTOLYSIS RATE CONSTANTS FOR
C      CONSTANT LIGHT INTENSITY.
C
C      IND:    1 = GET SDIST DATA FROM TEMPORARY DATA SET AND
C                  CALCULATE PHOTKS.  NORMALIZE, IF APPLICABLE.
C              2 = NORMALIZE ONLY
C
	INCLUDE 'MAINSPC.FOR'
C
C     CHVDAT COMMON SHARED BY SDREAD.  ANY CHANGES HERE MUST BE MATCHED THERE
C
	PARAMETER (MAXSWL=1200)
	COMMON /CHVDAT/ ASDIST(MAXSWL),BSDIST(MAXSWL),SWL(MAXSWL)
C
      LOGICAL NORMLZ
C
	REAL AP(MAXNWL,2),PWL(MAXNWL)
	REAL*8 QW1,QW2,QI1,QI2,QS1,QS2,QPHK
C
C     VALID ONLY IF VARYHV=F
C
      IF (VARYHV) THEN
          WRITE (OUT,*) 'ERROR: ILLEGAL RDCKC PHOTKS CALL WITH VARYHV=T'
          IRET=2
          RETURN
      ENDIF
C
      IRET=0
      NORMLZ=IK1.GT.0
      IF (IND.EQ.2) GOTO 50
C
C     OPEN TEMP FILE FOR READ
C
      IF (NSWL.LE.1) THEN
          WRITE (OUT,*) 'ERROR:  ATTEMPT TO CALC. PHOTKS W/O SDIST'
          IRET=2
          RETURN
      ENDIF
      IOB160=TMPUIC(1:LNBLNK(TMPUIC))//'ABSQY.TMP'
      OPEN (UNIT=TMP2,FILE=IOB160,STATUS='OLD',FORM='UNFORMATTED')
C
C     LOOP OVER PHOT TYPES.  READ IN ABSQY & CALC K
C
      DO 100 IPHOT=1,NPHOTK
          READ (TMP2) NWL,(PWL(I),AP(I,1),AP(I,2),I=1,NWL)
C
C     CALCULATE PHOTK (IF SDIST DEFINED)
C
          PHOTK=0
          IF (NWL.LE.1) GOTO 40
C  -      FIND LOWEST WAVELENGTH WHERE BOTH SDIST AND ABS,QY DEFINED.
          IP=1
          IS=1
          IF (PWL(1)-SWL(1)) 220,230,210
C  -  PWL(1) > SWL(1)
  210     IS=IS+1
          IF (IS.GT.NSWL) GOTO 40
          IF (PWL(1)-SWL(IS)) 215,230,210
  215     IPM=1
          IP=2
          IF (IP.GT.NWL) GOTO 40
          ISM=IS-1
          WL1=PWL(1)
          GOTO 310
C  -    SWL(1) > PWL(1)
  220     IP=IP+1
          IF (IP.GT.NWL) GOTO 40
          IF (PWL(IP)-SWL(1)) 220,230,225
  225     ISM=1
          IS=2
          IF (IS.GT.NSWL) GOTO 40
          IPM=IP-1
          WL1=SWL(1)
          GOTO 310
C  -    SWL(IS) = PWL(IP),  IS OR IP = 1
  230     IPM=IP
          ISM=IS
          IP=IP+1
          IS=IS+1
          WL1=PWL(IPM)
C  -     MAIN LOOP.  QUIT WHEN SDIST OR ABS,QY NOT DEFINED.
C
  300     IF (IS.GT.NSWL) GOTO 40
          IF (IP.GT.NWL) GOTO 40
C
  310     IF (PWL(IP)-SWL(IS)) 330,340,320
C  -    PWL > SWL
  320     WL2=SWL(IS)
          ISM2=IS
          IPM2=IPM
          IS=IS+1
          GOTO 350
C  -    SWL > PWL
  330     WL2=PWL(IP)
          IPM2=IP
          ISM2=ISM
          IP=IP+1
          GOTO 350
C  -    SWL = PWL
  340     WL2=SWL(IS)
          ISM2=IS
          IPM2=IP
          IS=IS+1
          IP=IP+1
C  -     CALCULATE AREA OF PRODUCT AND ADD TO PHOTK
C
  350     IF (WL1.EQ.WL2) GOTO 352
C
C	PRECISION PROBLEMS?
C          WL1SQ=WL1*WL1
C          WL2SQ=WL2*WL2
C          PHOTK=PHOTK+AP(IPM,1)*ASDIST(ISM)*(WL2-WL1) +
C     &     0.5*(AP(IPM,1)*BSDIST(ISM)+ASDIST(ISM)*AP(IPM,2))*
C     &     (WL2SQ-WL1SQ)+ AP(IPM,2)*BSDIST(ISM)*
C     &     (WL2SQ*WL2-WL1SQ*WL1)/3.0
C
C    -	FROM PHK (PHOTK)
	QW1=WL1
	QW2=WL2
	QI1=ASDIST(ISM)
	QI2=AP(IPM,1)
	QS1=BSDIST(ISM)
	QS2=AP(IPM,2)
	QPHK=(QI1*QI2*(QW2-QW1))+(0.5*((QI1*QS2)+(QI2*QS1))*((QW2*QW2)
     &	 -(QW1*QW1)))+((QS1*QS2*((QW2**3)-(QW1**3)))/3.0)
	AVGWL=AVGWL+(0.5*QPHK*(WL1+WL2))
	PHOTK=PHOTK+QPHK
C    -	END INSERT
C
          WL1=WL2
  352     ISM=ISM2
          IPM=IPM2
          GOTO 300
C
C      PHOTK CALCULATED.  DEFINE APPROPRIATE RATE CONSTANTS.
C
   40     COEF(IPHRK(IPHOT))=PHOTK
C
  100 CONTINUE
C
C     END LOOP OVER PHOT TYPES
      CLOSE (UNIT=TMP2)
C
C
C      NORMALIZE SO REACTION IK1 HAS PHOTK = PK1
C
   50	IF (NSWL.LE.1) GOTO 900
	IF (.NOT.NORMLZ) GOTO 60
	F=COEF(IPHRK(IK1))
	IF (F.EQ.0.0) THEN
		WRITE (OUT,51) COEFNM(IPHRK(IK1))
   51		FORMAT (/' ATTEMPT TO NORMALIZE PHOTKS USING PHOT ',
     &		 A4/' WHOSE RATE IS ZERO WITH THIS SDIST.')
	       IRET=2
	       RETURN
	ENDIF
	F=PK1/F
	IF (INTOUT) WRITE (OUT,53) COEFNM(IPHRK(IK1)),PK1,F
   53	FORMAT ('0PHOTOLYSIS RATES NORMALIZED TO GIVE PHOT(',A8,
     &	 ') =',1PG11.3,'.  FACTOR =',G11.3)
	DO 54 I=1,NPHOTK
   54	COEF(IPHRK(I))=COEF(IPHRK(I))*F
C
       IK1=0
       PK1=0.0
C
C      WRITE NEW PHOTKS
C
   60  IF (INTOUT) THEN
		WRITE (OUT,61)
   61 	        FORMAT (' ')
	        DO 65 I=1,NPHOTK
   65  	        WRITE (OUT,66) PHOTNM(I),COEF(IPHRK(I))
   66  	        FORMAT (' ',5X,'PHOT (',A8,') =',1PE11.3)
       ENDIF
C
 900	CONTINUE
C
C	SET ALL TO ZERO AND RETURN IF CHEMISTRY TURNED OFF
C
	IF (NOCHEM) THEN
		DO 7001 I=1,NPHOTK
 7001		COEF(IPHRK(I))=0.0
		IF (INTOUT) WRITE (OUT,*) ' ALL PHOTKS SET TO ZERO.'
	ENDIF
	RETURN
	END
C
C-----------------------------------------------------------------------
C --- SETPHK
C --- CALLED BY RDCKC
C --- CALLS PHOTKS
C --- UNITS USED:  TMP2 USED BY PHOTKS (OPENS,READS,CLOSES IF IND=1)
C
       SUBROUTINE SETPHK
C
C     SUBROUTINE TO GET SDISTS, CALCULATE PHOT K'S, AND PRINT
C     THEM (IF APPLICABLE) (VARYHV=F ONLY)
C
       INCLUDE 'MAINSPC.FOR'
C
C
      IF (INTOUT) WRITE (OUT,1031)
 1031 FORMAT ('+')
      IF (NEWSD) THEN
          IF (SDFIL.EQ.'*ERROR*') THEN
              WRITE (ICRT,*) 'Invalid Sdist specified.  See .OUT file.'
              NERR=NERR+1
              RETURN
          ENDIF
          NEWSD=.FALSE.
          CALL PHOTKS (1)
          IF (PKSET) THEN
              WRITE (OUT,*) 'ERROR.  PREVIOUSLY MODIFIED',
     &                   ' PHOT. K RE-CALCULATED'
              NERR=NERR+1
              PKSET=.FALSE.
          ENDIF
          IF (IRET.EQ.2) THEN
              NERR=NERR+1
              RETURN
          ENDIF
      ELSE
          IF (IK1.NE.0) THEN
              CALL PHOTKS (2)
              IF (IRET.EQ.2) THEN
                  NERR=NERR+1
                  RETURN
              ENDIF
              IF (PKSET) THEN
                  WRITE (OUT,*) 'ERROR.  PREVIOUSLY ',
     &            'MODIFIED PHOT. K RE-NORMALIZED'
                  NERR=NERR+1
                  PKSET=.FALSE.
              ENDIF
          ENDIF
      ENDIF
      RETURN
      END
C --- END OF PHOTKS.FOR
