C --- XQKODE.FOR.
C
C --- **NOTE** THIS VERSION FOR INT SUBRS IN FORTRAN ONLY
C
C --- CALLED BY INT AND ITS SUBROUTINES
C --- DIFFUN CALLS NEWPHK,NEWRK
C --- UNITS USED: TMP1: (READS AND CLOSES.  MUST BE OPEN UPON ENTRY)
C
C -------------------------------------------------------------------------
C ---                           U=UCSDCRAY
C --- SEGSUB CALLS ('B' VERS.): NEWPHK,NEWRK
C
C       ENTRY           USE
C       ------          -----------
C       KCONST          EXECUTES CONSTR CODE
C       KBLDUP          EXECUTES BLDUP CODE
C       DIFFUN          CALLS NEWPHK AND/OR NEWRK IF NEEDED, THEN
C                       EXECUTES DIFFUN CODE
C       KSXTRA          EXECUTES SXTRA CODE (PRINT/SAVE INSERTED CODE)
C
C ===================================================================
C     CONSTR INTERFACE
C
	SUBROUTINE KCONST
C -------------------------------------------------------------------
C
	INCLUDE 'MAINSPC.FOR'
C -------------------------------------------------------------------
C
C --- CALC TIME-VARYING COEFS
	IF (NVCO.GT.0) THEN
        	DO 20 IV=1,NVCO
		IF (IVCOEF(IV).LE.NCOEFV) THEN
			COEF(IVCOEF(IV))=VINT(IV)+VSLOPE(IV)*T0
		ELSE
			C(IVCOEF(IV)-NCOEFV)=VINT(IV)+VSLOPE(IV)*T0
		ENDIF
   20		CONTINUE
	ENDIF
C
	IF (FORM3) THEN
		CALL CONSTR3	! IN XQKODE3.FOR
	ELSE
		CALL CONSTR(C,0,0,COEF,0,0,0,T0,TEMP)
	ENDIF
	RETURN
	END
C ===============================================================
C
C	BLDUP INTERFACE
C
	SUBROUTINE KBLDUP(TIMARG,DYARG)
	REAL DYARG(*)
	INCLUDE 'MAINSPC.FOR'
	IF (FORM3) THEN
		CALL BLDUP3 (TIMARG,DYARG)
	ELSE
		CALL BLDUP(C,0,R,COEF,DYARG,0,0,TIMARG,TEMP)
	ENDIF
	RETURN
	END
C ===============================================================
C
C	DIFFUN INTERFACE
C
	SUBROUTINE DIFFUN (TIMARG,DYARG)
	REAL DYARG(*)
C ---------------------------------------------------------------
C
	INCLUDE 'MAINSPC.FOR'
C
C ---------------------------------------------------------------
C
      IF (TIMARG.NE.TLAST) THEN
          TLAST=TIMARG
          IF (NVCO.GT.0) THEN
C                                               ! CALC TIME-VARYING COEFS
              DO 10 IV=1,NVCO
                  IF (IVCOEF(IV).LE.NCOEFV) THEN
                      COEF(IVCOEF(IV))=VINT(IV)+VSLOPE(IV)*TIMARG
                  ELSE
                      C(IVCOEF(IV)-NCOEFV)=VINT(IV)+VSLOPE(IV)*TIMARG
                  ENDIF
   10         CONTINUE
              IF (IVHT.NE.0) THEN
C                                              ! CALC ENTRAINMENT RATE
                  IF (VSLOPE(IVHT).GT.0.0) THEN
                      COEF(INDER)=VSLOPE(IVHT)/COEF(INDHT)
                  ELSE
                      COEF(INDER)=0.0
                  ENDIF
              ENDIF
              IF (IVTPR.NE.0) THEN
                  IF (COEF(INDTPR).NE.TEMP) THEN
                      TEMP=COEF(INDTPR)
                  ENDIF
              ENDIF
          ENDIF
C
C         END IF BLOCK FOR NVCO GT 0.  UPDATE PHOTKS, IF VARYHV=T
C
          IF (VARYHV) CALL NEWPHK (TIMARG)
          CALL NEWRK (0)
C
      ENDIF
C
	IF (NOCHEM) THEN
		DO 7002 I=1,NRK
 7002		RK(I)=0.0
	ENDIF
C
	IF (FORM3) THEN
		CALL DIFFUN3 (TIMARG,DYARG)
	ELSE
		CALL DIFUN(C,RK,R,COEF,DYARG,C(NA1),C(NS1),TIMARG,TEMP)
	ENDIF
C
C
      RETURN
      END
C ===============================================================
C
C     SXTRA INTERFACE (FOR EXTRA PRINT/SAVE CODE)
C
	SUBROUTINE KSXTRA (TIMARG)
C
	INCLUDE 'MAINSPC.FOR'
C
C
      CALL SXTRA(C,RK,R,COEF,DY,0,0,TIMARG,TEMP)
      RETURN
      END
C --- END OF XQKODE.FOR
