	PROGRAM CDA2CSV
C
C	PRODUCES A .CSV FILE FROM A .CDA FILE, WITH TIMES IN COLUMNS
C	OUTPUT TO TMP.CSV BY  DEFAULT
C
C	MODELING.PRM OPTIONS:
C
	PARAMETER (MAXCHN=12000,MAXNPT=250)
	CHARACTER*16 NAME(MAXCHN)
	REAL*4 T(MAXNPT),DATA(MAXCHN,MAXNPT)
	CHARACTER INPNAM*8,PRMNAM*8,OUTFIL*80,INFILE*80,DATCAL*16
C
	LOGICAL ERRIND
	CHARACTER CDTUIC*60,INLIN*80,RUNLBL*80,MODLBL*16
	CHARACTER FILNAM*80,INPFIL*8,PRMFIL*8,MODFIL*8
C
C	READ COMMAND LINE
C
	CALL GETARG(1,INLIN)
	IF (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'?') THEN
		WRITE (6,*) 'Produces a CSV file from a CDA file, '
     &		 //'with times in columns'
		WRITE (6,*) 'Use: CDA2CSV2 runid [modelid] [outfile]'
		WRITE (6,*) '     runid = Run ID'
		WRITE (6,*) '     modelid = model (.PRM) location'
     &		 //' (default=CALCS)'
		WRITE (6,*) '     outfile = CSV output file (defa'
     &		 //'ult is TMP, so file is .\TMP.CSV'
		CALL EXIT
	ENDIF
C
	CALL GETARG (2,PRMFIL)
	IF (PRMFIL(1:1).EQ.' ') THEN
		PRMFIL='CALCS'
		L=5
	ELSE
		L=LNBLNK(PRMFIL)
	ENDIF
	LINFIL=LNBLNK(INLIN)
	INFILE=PRMFIL(1:L)//'\'//INLIN(1:LINFIL)
	LINFIL=L+LINFIL+1
C
	CALL GETARG(3,INLIN)
	IF (INLIN(1:1).NE.' ') THEN
		LOUTFL=LNBLNK(INLIN)
		OUTFIL=INLIN(1:LOUTFL)//'.CSV'
		LOUTFL=LOUTFL+4
	ELSE
		OUTFIL='TMP.CSV'
		LOUTFL=7
	ENDIF
C
C	GET PARMS FROM MODELING.PRM
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
C
	CDTUIC=' '
C
   10	READ (1,'(A)',END=18) INLIN
	IF (INLIN(1:4).EQ.'CAL=') THEN
		CDTUIC=INLIN(5:)
	ENDIF
	IF (CDTUIC(1:1).EQ.' ') CDTUIC='.\'
	LCDTUC=LNBLNK(CDTUIC)
	GOTO 10
C
  18	CLOSE (UNIT=1)
C
C	OPEN INPUT FILE AND READ INITIAL RECORDS.
C
	FILNAM=CDTUIC(1:LCDTUC)//INFILE(1:LINFIL)//'.CDA'
	LFIL=LNBLNK(FILNAM)
C
	OPEN (UNIT=1,FILE=FILNAM,ERR=900,STATUS='OLD',ACTION='READ')
	READ (1,101,ERR=910) INLIN(1:2),N,INPFIL,PRMFIL,MODFIL,DATCAL,
     &	 RUNLBL
	IF (N.GT.MAXCHN) STOP 'INCREASE MAXCHN IN CDA2CSV2'
	IF (INLIN(1:2).NE.'A8') THEN
		WRITE (6,*) 'This program only supports CDA files with '
     &		 //'format code "A8".'
		GOTO 990
	ENDIF
	READ (1,102,ERR=912,END=912) (NAME(I),I=1,N)
	NPT=0
  20	NPT=NPT+1
	READ (1,103,END=29) T(NPT),(DATA(I,NPT),I=1,N)
	IF (NPT.LT.MAXNPT) GOTO 20
  29	NPT=NPT-1
  30	CLOSE (UNIT=1)
C
	IF (NPT.EQ.0) THEN
		WRITE (6,*) 'No time profile data in file = '
     &		 //FILNAM(1:LFIL)
		CALL EXIT(1)
	ENDIF
  101	FORMAT(A2,I5,3(1X,A8),1X,A16,1X,A)
  102	FORMAT (8A11)
  103	FORMAT (F10.2/(1PE10.3,7E11.3))
C
C	OPEN AND WRITE OUTPUT FILE
C
	OPEN (UNIT=2,FILE=OUTFIL,STATUS='UNKNOWN')
C
	WRITE (2,141) INPFIL,PRMFIL,DATCAL,RUNLBL,MODFIL,N,NPT,
     &	 (T(I),I=1,NPT)
  141	FORMAT ('Calc,',A8,',',A8,',',A16/'Label,',A/'Model,',A/
     &   'Species,',I5/'Times,',I5//'Channel',250(',',F10.2))
C
	DO 200 I=1,N
	LFIL=LNBLNK(NAME(I))
  200	WRITE (2,201) NAME(I)(1:LFIL),(DATA(I,J),J=1,NPT)
  201	FORMAT (A,250(',',1PE10.3))
C
	CLOSE (UNIT=2)
	WRITE (6,*) 'File = '//OUTFIL(1:LOUTFL)//' created.'
	CALL EXIT
C
C	ERRORS
C
  900	WRITE (6,*) 'File = '//FILNAM(1:LFIL)//' does not exist.'
	GOTO 990
  910	WRITE (6,*) 'Error reading headers from file = '
     &	 //FILNAM(1:LFIL)	
	GOTO 990
  912	WRITE (6,*) 'Error reading names from file = '
     &	 //FILNAM(1:LFIL)	
	GOTO 990
  914	WRITE (6,*) 'Error reading data from file = '
     &	 //FILNAM(1:LFIL)	

C
  990	CALL EXIT (2)
	END
