	PROGRAM INTRATE
C
C	SUMMARIZES INTEGRATED REACTION RATE RESULTS FROM A CALCULATION
C
C	P1 = CALC .CDA FILE NAME (OR calcset\runid) if no parm file
C	P2 = PARAMETER FILE (OPTIONAL) - TO GET MOD= AND CAL= LOCATIONS
C	P3 = TIME (OPTIONAL) - DEFAULT IS END
C
	PARAMETER (MAXCHN=1000)
	CHARACTER*11 NAME(MAXCHN)
	REAL T,DATA(MAXCHN),DATA0(MAXCHN),TEND
C
	LOGICAL ERRIND,FIRST
	CHARACTER CDTUIC*60,MODUIC*60,INLIN*80,RUNLBL*80,MODLBL*16
	CHARACTER FILNAM*80,NOCHR*6,PRMFIL*20,TYPLBL*8
C
C	FUNCTION TO SEE HOW MANY RECORDS IT TAKES TO READ I1 DATA
C	VALUES AT I2 VALUES PER RECORD
	NSKPRC(I1,I2)=1+((I1-1)/I2)
C
	CHARACTER*8 FORM,FORMOK/'MV:4/89'/
	PARAMETER (MAXCHR=1024)
	CHARACTER CHARXN(MAXCHR)*1
	LOGICAL NOCONT
C
C	READ COMMAND LINE AND GET RUN ID
C
	CALL GETARG (1,FILNAM)
	IF (FILNAM(1:1).EQ.' ') GOTO 800
	LFIL=LNBLNK(FILNAM)
	CALL GETARG (2,PRMFIL)
	IF (PRMFIL(1:1).EQ.' '.OR.PRMFIL(1:2).EQ.'X ') THEN
		WRITE (6,*) 'Model ID or PRM file is required input'
		GOTO 800
	ELSE
		LPRMFL=LNBLNK(PRMFIL)
	ENDIF
	CALL GETARG (3,INLIN)
	IF (INLIN(1:1).EQ.' ') THEN
		TEND=0.0
	ELSE
		TEND=REALV (INLIN,LNBLNK(INLIN),ERRIND)
		IF (ERRIND) GOTO 800
	ENDIF
C
C	GET PARMS FROM PARAMETER FILE AND MODELING.PRM
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
C
	CDTUIC='.\'
	LCDTUC=2
	MODUIC='.\'
	LMODUC=2
	FIRST=.TRUE.
C
   10	READ (1,'(A)',END=18) INLIN
	IF (INLIN(1:4).EQ.'CAL=') THEN
		CDTUIC=INLIN(5:)
		LCDTUC=LNBLNK(CDTUIC)
	ELSEIF (INLIN(1:4).EQ.'MOD=') THEN
		MODUIC=INLIN(5:)
		LMODUC=LNBLNK(MODUIC)
	ENDIF
	GOTO 10
  18	CLOSE (UNIT=1)
	IF (FIRST.AND.PRMFIL(1:1).NE.' ') THEN
		OPEN (UNIT=1,FILE=PRMFIL(1:LPRMFL)//'.PRM',STATUS='OLD',
     &		 ERR=810)
		FIRST=.FALSE.
		GOTO 10
	ENDIF
C
C	OPEN INPUT FILE AND READ INITIAL RECORDS.
C
	FILNAM=CDTUIC(1:LCDTUC)//PRMFIL(1:LPRMFL)//'\'//FILNAM(1:LFIL)
     &	 //'.CDA'
	LFIL=LCDTUC+LPRMFL+LFIL+5
C
	OPEN (UNIT=1,FILE=FILNAM,STATUS='OLD',ERR=830,ACTION='READ')
C
	READ (1,'(2X,I5,1X,A8,10X,A8)',ERR=840) N,RUNLBL,MODLBL
	IF (N.GT.MAXCHN) THEN
		WRITE (6,*) 'Increase MAXCHN'
		GOTO 890
	ENDIF
	LMODLB=LNBLNK(MODLBL)
CD	WRITE (6,*) 'MODLBL='//MODLBL(1:LMODLB)
C
	READ (1,11,ERR=840) (NAME(J),J=1,N)
   11	FORMAT (8A11)
CD	WRITE (6,*) '['//NAME(1)//'] ['//NAME(N)//']'
C
C	FIND FIRST AND LAST IR# CHANNEL.  IF NONE, TRY FOR R#
C
	IND=4
	TYPLBL='IntRate'
	LTYPLB=7
	N1=0
	DO 20 I=1,N
	IF (N1.EQ.0) THEN
		IF (NAME(I)(1:3).EQ.'IR#') N1=I
	ELSEIF (NAME(I)(1:3).NE.'IR#') THEN
		N2=I-1
		GOTO 21
	ENDIF
   20	CONTINUE
	IF (N1.EQ.0) THEN
		TYPLBL='Rate'
		LTYPLB=4
		IND=3
		DO 24 I=1,N
		IF (N1.EQ.0) THEN
			IF (NAME(I)(1:2).EQ.'R#') N1=I
		ELSEIF (NAME(I)(1:2).NE.'R#') THEN
			N2=I-1
			GOTO 21
		ENDIF
   24		CONTINUE
		IF (N1.EQ.0) THEN
			WRITE (6,*) 'This calculation has no ',
     &			 'INTRATE or RATE data.'
			WRITE (6,*) 'File = '//FILNAM(1:LFIL)
			CLOSE (UNIT=1)
			GOTO 890
		ENDIF
	ENDIF
	N2=N
   21	CONTINUE
C
C	READ T0 DATA
	READ (1,13,ERR=840) T,(DATA0(I),I=1,N)
   13	FORMAT (F10.2/(1PE10.3,7E11.3))
C
C	READ TO <EOF> OR T=TEND
C
	IF (TEND.EQ.0.0) THEN	
   30		READ (1,13,ERR=840,END=35) T,(DATA(I),I=1,N)
		GOTO 30
	ELSE
   32		READ (1,13,ERR=840,END=35) T,(DATA(I),I=1,N)
		IF (T.LT.TEND) GOTO 32
	ENDIF
   35	TEND=T
	CLOSE (UNIT=1)
C
C	SEE IF .MOD FILE CAN BE OPENED
C
	IF (LMODUC.GT.0) THEN
		FILNAM=MODUIC(1:LMODUC)//MODLBL(1:LMODLB)//'.MOD'
		LFIL=LMODUC+LMODLB+4
	ELSE
		FILNAM=MODLBL(1:LMODLB)//'.MOD'
		LFIL=LMODLB+4
	ENDIF
	OPEN (UNIT=1,FILE=FILNAM,STATUS='OLD',ERR=830)
C
C	OPEN MOD FILE AND SKIP RECORDS NOT USED
C
	READ (1,1) FORM
	IF (FORM.NE.FORMOK) THEN
		WRITE (6,*) 'File = ',FILNAM(1:LFIL),
     &	 	 ' has unrecognized format = "',FORM,'"'
		GOTO 890
	ENDIF
	READ(1,'(A20/12I6/20X,3I6)') INLIN,NS,I,
     &	 NSC,I,I,NRXN,NCOEFV,NCOC1,NCOC2,NPHOTK,LOCKBF,I,
     &	 I,NVTEMP,NVTCO
C
	IF (NRXN.NE.N2-N1+1) THEN
		WRITE (6,*) 'Number of reactions in .MOD and ',
     &		 '.CHD files disagree.'
		GOTO 890
	ENDIF
C
	NSKP=1
	IF (NSC.GT.0) NSKP=NSKP+NSKPRC(NSC,2)
	NSKP=NSKP+NSKPRC(NS-NSC,5)
	IF (NCOEFV.GT.0) NSKP=NSKP+NSKPRC(NCOEFV,3)
	IF (NCOC2.GE.NCOC1) NSKP=NSKP+NSKPRC(NCOC2-NCOC1+1,6)
	IF (NVTCO.GT.0) THEN
		NSKP=NSKP+NSKPRC(NVTEMP,6)+NSKPRC(NVTCO,16)
		DO 14 I=1,NVTCO
  14		NSKP=NSKP+NSKPRC(NVTEMP,6)
	ENDIF
	READ (1,1) (INLIN(1:1),I=1,NSKP)
    1	FORMAT (A)
	IF (NPHOTK.GT.0) THEN
		DO 42 I=1,NPHOTK
		READ (1,'(A/I5)') INLIN(1:1),NPWL
		NSKP=NSKPRC(NPWL,3)
		READ (1,1) (INLIN(1:1),J=1,NSKP)
   42		CONTINUE
	ENDIF
	NSKP=NSKPRC(LOCKBF,6)+(2*NSKPRC(NRXN,16))
	READ (1,1) (INLIN(1:1),I=1,NSKP)
C
C
C	OPEN OUTPUT FILE AND WRITE INITIAL RECORDS
C
	OPEN (UNIT=2,FILE='INTRATE.CSV',STATUS='UNKNOWN')
C
	WRITE (2,51) IRUN,RUNLBL(1:LNBLNK(RUNLBL)),MODLBL(1:LMODLB),
     &	 N2-N1+1,TEND,TYPLBL(1:LTYPLB)
   51	FORMAT ('CalcNO ,',I5/'Label  ,',A/'Model  ,',A/
     &   'Reactions,',I5/'Time,',F10.2//A,',RxnLbl,Reaction')
C
C	OUTPUT NONZERO RATES
	DO 50 I=N1,N2
C	READ RXN STRING
	READ (1,'(18X,I5,2X,L1/1024A1)') L,NOCONT,(CHARXN(IX),IX=1,L)
   53	IF (.NOT.NOCONT) THEN
		READ (1,'(2X,I5,2X,L1/A)') L1,NOCONT,INLIN
		IF (L.LT.MAXCHR) THEN
			IF (CHARXN(L).EQ.'&') THEN
				L=L-1
				DO 5301 IX=1,L1
 5301				CHARXN(MIN(MAXCHR,L+IX))=INLIN(IX:IX)
				L=L+L1
			ELSEIF (L.EQ.MAXCHR) THEN
				L=L+1	! ADDED STRING IGNORED
                        ELSE
				CHARXN(L+1)=' '
				L=L+1
				DO 5302 IX=1,L1
 5302				CHARXN(MIN(MAXCHR,L+IX))=INLIN(IX:IX)
				L=L+L1
                        ENDIF
			IF (L.GT.MAXCHR) THEN
				L=MAXCHR
				CHARXN(MAXCHR)='&'
			ENDIF
		ENDIF
		GOTO 53
	ENDIF
	IF (DATA(I).NE.0.0) THEN
		WRITE (2,521) DATA(I),NAME(I)(IND:7),(CHARXN(IX),IX=1,L)
  521		FORMAT (1PE10.3,',',A4,',',1024A1)
	ENDIF
   50	CONTINUE
C
C	OUTPUT CONCENTRATIONS
C
	DO 490 I=1,N1-1
	DATAI=DATA(I)-DATA0(I)
	IF (DATAI.NE.0.0) WRITE (2,52) DATAI,NAME(I)(1:LNBLNK(NAME(I)))
   52   FORMAT (1PE10.3,',Conc,',A)
  490   CONTINUE        
C
	CLOSE (UNIT=1)
	CLOSE (UNIT=2)
	WRITE (6,*) 'File = INTRATE.CSV created.'
C
	CALL EXIT (0)
C
C	ERRORS
C
  800	WRITE (6,*) 'Summarizes calculated integrated reaction rate',
     &	 ' results'
	WRITE (6,*) 'for calc files in CDA format.  Output to '
     &	 ,'INTRATE.CSV'
	WRITE (6,*)
	WRITE (6,*) 'Use: INTRATE calcfile prmfile [time]'
	GOTO 890
C
  810	WRITE (6,*) 'File = ',PRMFIL(1:LPRMFL),'.PRM does not exist.'
	GOTO 890
C
  830	WRITE (6,*) 'File = ',FILNAM(1:LFIL),' does not exist.'
	GOTO 890
C
  840	WRITE (6,*) 'Error reading file = ',FILNAM(1:LFIL)
C
  890	CALL EXIT (2)
	END
