	PROGRAM SUMCALC4
C	LIKE SUMCALC2 BUT chanid specified in input file.
C
C	** THIS VERSION FOR CALCS IN CDA FORMAT ONLY
C
C	SUMMARIZES RESULTS OF CALCULATIONS FOR STATISTICAL TABULATIONS
C	HALF HOURLY DATA STARTING AT T=30 FOR MOST RUNS
C	DATA EVERY 100 MINUTES STARTING AT T=480 FOR UNC RUNS
C	UNC RUNS HAVE RUNIDS WITH FIRST 2 CHARACTERS GIVEN IN UNCCHR ARRAY
C
C	P1 = INPUT FILE GIVING LIST OF RUN ID'S
C	P2 = OUTPUT FILE
C	P3 = EXT FILE GIVING CALCNOS (MODEL)
C
C
C	OUTTYP:	 0: MAX
C		-300: INITIAL (/I)
C		-200: FINAL (/F)
C		-400: AVERAGE (/A)
C		-500: INTEGRATED (/D)
C		-1: DAY 1 MAX
C		-2: DAY 2 MAX
C		>0: MAX TO HR.
C
	PARAMETER (MAXOUT=48)
	CHARACTER OUTNAM*8,OUTBUF*8
	CHARACTER TITLE*56,OUTLIN*255
	REAL OUTDAT(MAXOUT)
	LOGICAL ERRIND
C
	CHARACTER*2 UNCCHR(12)/"JA","FB","MR","AP","MY","JN",
     &	 "JL","AU","ST","OC","NV","DE"/
C
	REAL NODATA/-9.99E9/
C
	PARAMETER (MAXLIS=6000)
	INTEGER LOCDAT
C
        PARAMETER (MAXCCH=1200)
        INTEGER NCHS
        REAL CX(MAXCCH)
	CHARACTER NAME(MAXCCH)*16
C
	LOGICAL APND
	CHARACTER CALUIC*40,MODEL*8,RUNID*8,INFILE*40,OUTFIL*40
	CHARACTER INLIN*250,FILNAM*60
C
C	GET OPTIONS
C
	CALL GETARG (1,INFILE)
	LINFIL=LNBLNK(INFILE)
	CALL GETARG (2,OUTFIL)
	LOUTFL=LNBLNK(OUTFIL)
	IF (LOUTFL.LT.3) LOUTFL=3
	CALL GETARG (3,MODEL)
	LMODEL=LNBLNK(MODEL)
	IF (INFILE(1:1).EQ.'?'.OR.INFILE(1:1).EQ.' '.OR.
     &	 OUTFIL(1:1).EQ.' '.OR.MODEL(1:1).EQ.' ') THEN
		WRITE (6,*) 'Outputs summary of model calculations of',
     &		 ' maximum conc''s for species in runs.'
		WRITE (6,*) 'Use SUMCALC3 infile outfile[/A] model'
		WRITE (6,*) 'Following parameters specified in input file:'
		WRITE (6,*) 'RunID spec1 nHours'
		CALL EXIT
	ENDIF
C
C	GET CALC UIC
C
	CALUIC='.\'
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
   10	READ (1,1,END=11) INLIN
    1	FORMAT (A)
	IF (INLIN(1:4).EQ.'CAL=') THEN
		CALUIC=INLIN(5:)
	ENDIF
	GOTO 10
   11	CLOSE (UNIT=1)
C
C	APPEND MODELSET NAME TO CALC UIC
C
	LCALUC=LNBLNK(CALUIC)
	CALUIC=CALUIC(1:LCALUC)//MODEL(1:LMODEL)//'\'
	LCALUC=LCALUC+LMODEL+1
C
C	OPEN INPUT FILE FOR RUN ID'S
C	OPEN AND INITIALIZE OUTPUT FILE
C
	OPEN (UNIT=1,FILE=INFILE,STATUS='OLD',ERR=800)
C
  90	APND=OUTFIL(LOUTFL-1:LOUTFL).EQ.'/A'
	IF (APND) THEN
		OUTFIL=OUTFIL(1:LOUTFL-2)
		OPEN (UNIT=2,FILE=OUTFIL,STATUS='UNKNOWN',ACCESS='APPEND')
		WRITE (2,*)
	ELSE
		OPEN (UNIT=2,FILE=OUTFIL,STATUS='UNKNOWN')
	ENDIF
	CALL TMARK(INLIN)
	WRITE (2,14) MODEL(1:LMODEL),INLIN(1:16)
  14	FORMAT ('Model = ',A,'.  File created ',A//'RunID,Chan,Data')
C
C	READ NEXT RUN
C
  100	READ (1,1,END=900) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 100
	IF (INLIN(1:1).EQ.' ') THEN
		WRITE (2,*)
		GOTO 100
	ELSEIF (INLIN(1:7).EQ.'INTRUN ') THEN
		CALL PARSE0 (4,INLIN,80)
		CALL PARSE1 (2,RUNID,LRUNID,8,INLIN)
		CALL PARSE1 (3,OUTNAM,LOUTNM,8,INLIN)
		CALL PARSI2 (4,NOUT,0,ERRIND,INLIN)
	ELSE
		CALL PARSE0 (3,INLIN,80)
		CALL PARSE1 (1,RUNID,LRUNID,8,INLIN)
		CALL PARSE1 (2,OUTNAM,LOUTNM,8,INLIN)
		CALL PARSI2 (3,NOUT,0,ERRIND,INLIN)
	ENDIF
	IF (ERRIND) THEN
		NTIM=0
	ELSEIF (NTIM.GT.MAXOUT) THEN
		NTIM=MAXOUT
	ENDIF
C
C	OPEN CALC FILE
C
	FILNAM=CALUIC(1:LCALUC)//RUNID(1:LRUNID)//'.CDA'
	OPEN (UNIT=3,FILE=FILNAM,STATUS='OLD',ERR=113)
	GOTO 114
  113	WRITE (6,*) 'File = ',FILNAM(1:LCALUC+LRUNID+4),
     &	 ' does not exist.'
	WRITE (2,'(A)') RUNID(1:LRUNID)//',NoCSV'
	GOTO 100
  114	CONTINUE
C
C	READ HEADERS
C
  122	READ (3,'(2X,I5,45X,A)',ERR=832) NCHS,TITLE
	IF (NCHS.GT.MAXCCH) THEN
		WRITE (6,*) 'Too many channels (',NCHS,') for calc ',
     &		 RUNID(1:LRUNID)
		WRITE (6,*) 'INCREASE MAXCCH'
		CALL EXIT
	ENDIF
	READ (3,'(8A11)') (NAME(I),I=1,NCHS)
C
C	DETERMINE IF UNC RUN
C
	IT0=0
	IDT=30
	DO 1321 I=1,12
	IF (RUNID(1:2).EQ.UNCCHR(I)) THEN
		IT0=380
		IDT=100
		GOTO 1322
	ENDIF
 1321	CONTINUE
 1322	CONTINUE
C
C	LOCATE CHANNEL	OF INTEREST
C
	IF (OUTNAM(1:1).NE.' ') THEN
  		DO 132 J=1,NCHS
  		IF (NAME(J)(1:LOUTNM).EQ.OUTNAM(1:LOUTNM)) THEN
  			LOCDAT=J
  			GOTO 131
  		ENDIF
  132		CONTINUE
	ENDIF
C
C	CHANNEL NOT FOUND
C
		WRITE (2,1) RUNID(1:LRUNID)//',No '//OUTNAM(1:LOUTNM)
		GOTO 100
C
  131	CONTINUE
C
C	READ FIRST RECORD
C
	NT=0
	READ (3,2111,ERR=148,END=148) TIM,(CX(I),I=1,NCHS)
 2111	FORMAT (F10.2/(1PE10.3,7E11.3))
	IF (TIM.LT.-1.0E+10) GOTO 148
C
C	READ NEXT RECORD
C
	IND=1
	TIMNXT=30.
	TIMEND=30*NOUT
	DO 142 I=1,NOUT
  142	OUTDAT(I)=NODATA
C
  140	READ (3,2111,ERR=148,END=148) TIM,(CX(I),I=1,NCHS)
	IF (TIM.LT.-1.0E+10) GOTO 148
C
	IF (TIM.GT.TIMNXT) THEN
		OUTDAT(IND)=NODATA
		IND=IND+1
		TIMNXT=IND*30.
	ELSEIF (TIM.EQ.TIMNXT) THEN
		OUTDAT(IND)=CX(LOCDAT)
		IND=IND+1
		TIMNXT=IND*30.
C	ELSEIF (TIM.LT.TIMNXT) THEN
C		READ NEXT TIME
	ENDIF
	GOTO 140
C
C	OUTPUT DATA FOR RUN
C
  148	CLOSE (UNIT=3)
	OUTLIN=RUNID(1:LRUNID)//','//OUTNAM(1:LOUTNM)
	DO 150 I=1,NOUT
	IF (OUTDAT(I).EQ.NODATA) THEN
		OUTLIN=OUTLIN//','
	ELSE
		CALL FMTOU4(OUTBUF,OUTDAT(I))
		OUTLIN=OUTLIN(1:LNBLNK(OUTLIN))//','//OUTBUF
	ENDIF
  150	CONTINUE
	WRITE (2,1) OUTLIN(1:LNBLNK(OUTLIN))
	GOTO 100
C
C	DONE
C
  900	CLOSE (UNIT=1)
	CLOSE (UNIT=2)
	IF (APND) THEN
		WRITE (6,*) 'Appended to file = ',OUTFIL(1:LOUTFL)
	ELSE
		WRITE (6,*) 'File = ',OUTFIL(1:LOUTFL),' created.'
	ENDIF
	CALL EXIT
C
C	ERRORS
C
  800	WRITE (6,*) 'File = ',INFILE(1:LINFIL),' does not exist'
	GOTO 890
  832	WRITE (6,*) 'ERROR IN READING LABEL'
  839	WRITE (6,*) 'Calc file = ',FILNAM(1:LNBLNK(FILNAM)),
     &	 '; Calc ID = ',RUNID(1:LRUNID)
	WRITE (2,'(A)') RUNID(1:LRUNID),',BadCSV'
	GOTO 100
  890	CALL EXIT
	END
C
	FUNCTION INTVAL(CHARIN)
	CHARACTER*10 CHARIN
	LB=LNBLNK(CHARIN)
	IF (LB.EQ.1) THEN
		READ (CHARIN,'(I1)',ERR=9) INTVAL
	ELSEIF (LB.EQ.2) THEN
		READ (CHARIN,'(I2)',ERR=9) INTVAL
	ELSE
		INTVAL=0
	ENDIF
	RETURN
    9	INTVAL=0
	RETURN
	END
