	SUBROUTINE SDADJ (IND,SDFIL,SDRUIC)
C
C	LUMPINT SUBROUTINE.
C	ADJUSTS SPECTRAL DISTRIBUTIONS GIVEN #SDADJ INPUT ON UNIT = IN
C	USES UNIT=7.  OUTPUTS SD ON UNIT=4
C
C	IND = IF SUCCESS, SET TO 0
C	SDFIL = SPECTRAL DISTRIBUTION FILE
C	SDRUIC = SPECTRAL DISTRIBUTION UIC
C
	INTEGER IND
	CHARACTER SDFIL*8,SDRUIC*40
C
	INCLUDE 'LUMPSPEC.FOR'
C
	PARAMETER (MAXWLA=500)
	INTEGER NWLA
	REAL WLA(0:MAXWLA),SDA(0:MAXWLA),SDAIN(0:MAXWLA)
	COMMON /ADJSD/ WLA,SDA,NWLA
C
	PARAMETER (MAXWL=1200)
	INTEGER NWL
	REAL WL(MAXWL),SD(MAXWL),SD2(MAXWL)
C
	LOGICAL ERRIND
	CHARACTER INLIN*80,FILNAM*60
C
C	ABORT IF ADJUSTED DATA NOT READ
C
	IF (NWLA.EQ.0) THEN
		WRITE (ICRT,*) 'PRM ERR:  SDADJ CALLED WITH NWLA=0'
		IND=1
		RETURN
	ENDIF
C
C	IF SPECIAL CODE (" Use Run") USED FOR NAME, USE INPUT VALUES
C	W/O MODIFYING.
C
	IF (SDFIL.EQ.' Use Run') THEN
		WRITE (4,1) '.SD-'
		WRITE (4,211) (WLA(I),SDA(I),I=1,NWLA)
  211		FORMAT (0PF8.4,1PE11.3)
		WRITE (4,1) '#END'
		IND=0
		RETURN
	ENDIF
    1	FORMAT (A)
C
C	READ SPECTRAL DISTRUBUTION
C
	IF (SDRUIC(1:1).EQ.' ') THEN
		FILNAM=SDFIL(1:LNBLNK(SDFIL))//'.SDR'
	ELSE
		FILNAM=SDRUIC(1:LNBLNK(SDRUIC))//SDFIL(1:LNBLNK(SDFIL))//'.SDR'
	ENDIF
	OPEN (UNIT=7,FILE=FILNAM,STATUS='OLD',ERR=810)	! READONLY
	READ (7,1,END=820) INLIN
C
	NWL=0
  100	READ (7,1,END=110) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 100
	CALL PARSE0 (2,INLIN,80)
	CALL PARSR2 (1,WLI,0.0,ERRIND,INLIN)
	IF (ERRIND) GOTO 830
	IF (WLI.EQ.0.0) GOTO 110
	IF (NWL.EQ.MAXWL) THEN
		WRITE (ICRT,*) 'INCREASE MAXWL IN SDADJ.FOR'
		IND=4
		RETURN
	ENDIF
	NWL=NWL+1
	WL(NWL)=WLI
	CALL PARSER (2,SD(NWL),ERRIND,INLIN)
	IF (ERRIND) GOTO 830
	GOTO 100
  110	CLOSE (UNIT=7)
	IF (NWL.EQ.0) GOTO 820
C
C	ADJUST WAVELENGTHS BY LINEAR INTERPOLATION
C
C	LOWEST ADJUSTMENT MUST BE ZERO
C
	IF (SDA(1).NE.0.0) THEN
		WLA(0)=WLA(1)-(WLA(2)-WLA(1))
		SDA(0)=0.0
		I1=0
		NWLA1=NWLA+1
	ELSE
		I1=1
		NWLA1=NWLA
	ENDIF
C
C	MAKE SURE WL RANGES ARE CONSISTENT
C
	IF (WL(NWL).LE.WLA(1).OR.WL(1).GE.WLA(NWLA)) THEN
		WRITE (ICRT,*) 'SDADJ WAVELENGTHS OUT OF RANGE'
		IND=5
		RETURN
	ENDIF
C
C	FIND ALLIGNED VERSION OF INPUT SDIST
C
	CALL ARALIN (SDAIN(I1),NWL,WL,SD,NWLA1,WLA(I1),IND,0.)
	IF (IND.EQ.-1) THEN
		WRITE (ICRT,*) 'Bad WL order in ',FILNAM(1:LNBLNK(FILNAM))
		RETURN
	ELSEIF (IND.EQ.-1) THEN
		WRITE (ICRT,*) 'Bad WL order in #SDADJ input'
		RETURN
	ELSEIF (IND.LT.0) THEN
		WRITE (ICRT,*) 'ARALIN ERROR',I
		RETURN
	ENDIF
C
C	CONVERT THIS TO RATIOS OF DESIRED/ACTUAL AT ADJ WL'S
C	THIS IS ARRAY OF FUDGE FACTORS FOR SD. AT THESE WL'S.
C
	DO 120 I=I1,NWLA
	IF (SDAIN(I).NE.0.0) THEN
		SDA(I)=SDA(I)/SDAIN(I)
	ELSEIF (SDA(I).NE.0.0) THEN
		WRITE (ICRT,*) '#SDADJ Sdist is nonzero where S',
     &		 'D is zero in ',FILNAM(1:LNBLNK(FILNAM))
		IND=6
		RETURN
	ELSE
		SDA(I)=0.0
	ENDIF
  120	CONTINUE
C
C
C	DETERMINE FUDGE FACTORS AT SD WL'S BY INTERPOLATING THOSE AT
C	ADJ WL'S.
C
	CALL ARALIN (SD2,NWLA1,WLA(I1),SDA(I1),NWL,WL,IND,0.)
	IF (IND.LT.0) THEN
		WRITE (ICRT,*) 'PGM ERR IN SD2 CALC IN ADADJ. IND=',IND
		IND=8
		RETURN
	ENDIF
C
C	DONE
C
  210	CONTINUE
C
C	OUTPUT RESULTS ON UNIT 4
C
	WRITE (4,1) '.SD-'
	WRITE (4,1) '! Adjusted '//FILNAM(1:LNBLNK(FILNAM))
	WRITE (4,212) (WLA(I),SDA(I),I=1,NWLA)
  212	FORMAT ('! Adjustments:'/'!    wl    Fac'/
     &   ('!',2F8.4))
	WRITE (4,1) '!'
	WRITE (4,211) (WL(I),SD(I)*SD2(I),I=1,NWL)
	WRITE (4,1) '#END'
C
	IND=0
	RETURN
C
C	ENTRY TO INPUT ADJUSTED SDIST
C
	ENTRY SDADJ1 (IND)
	NWLA=0
  300	CALL INBUF ('SDADJ: ',7)
	IF (IOB160(1:4).NE.'#END') THEN
		IF (NWLA.EQ.MAXWLA) THEN
			WRITE (ICRT,*) 'INCREASE MAXWLA IN SDADJ.FOR'
			IND=1
			RETURN
		ENDIF
		NWLA=NWLA+1
		CALL PARSE0 (2,IOB160,80)
		CALL PARSER (1,WLA(NWLA),ERRIND,IOB160)
		IF (ERRIND) GOTO 840
		CALL PARSER (2,SDA(NWLA),ERRIND,IOB160)
		IF (ERRIND) GOTO 840
		IF (NWLA.EQ.1) GOTO 300
		IF (WLA(NWLA).LE.WLA(NWLA-1)) THEN
			WRITE (ICRT,*) 'Bad WL order'
			GOTO 840
		ENDIF
		GOTO 300
	ENDIF
	IF (NWLA.LT.2) THEN
		WRITE (ICRT,*) '#SDADJ input requires at least two wl''s'
		IND=6
		RETURN
	ENDIF
C
C	NORMALIZE TO MAXIMUM WL.
C
	SDMAX=0.0
	DO 310 I=1,NWLA
	IF (SDA(I).GT.SDMAX) SDMAX=SDA(I)
  310	CONTINUE
	IF (SDMAX.EQ.0.0) THEN
		WRITE (ICRT,*) 'All SD''s zero in #SDADJ input'
		IND=7
		RETURN
	ENDIF
	DO 311 I=1,NWLA
  311	SDA(I)=SDA(I)/SDMAX
	IND=0
	RETURN
C
C	ERRORS
C
  810	WRITE (ICRT,*) 'File = ',FILNAM(1:LNBLNK(FILNAM)),
     &	 ' does not exist.'
	GOTO 899
  820	WRITE (ICRT,*) 'No data in file = ',FILNAM(1:LNBLNK(FILNAM))
	GOTO 899
  830	WRITE (ICRT,*) 'Error reading Sdist data in '
     &	 ,FILNAM(1:LNBLNK(FILNAM))
	WRITE (ICRT,*) 'Bad line = ',INLIN(1:LNBLNK(INLIN))
	GOTO 899
  840	WRITE (ICRT,*) 'Error reading #SDADJ data.'
	WRITE (ICRT,*) 'Bad line = ',IOB160(1:LNBLNK(IOB160))
C
  899	IND=2
	RETURN
	END
