	SUBROUTINE ILMPSB (OUTU,TYPMAX,FXDMOD,TSTKOD)
C
C	LUMPING SUBROUTINE TO LUMPING.  READS COMPOSITION DATA USING
C	INBUF, OUTPUTS LUMPED COMPOSITIONS AND PARAMETERS
C	TO UNIT = OUTU (OPEN).  *NOTE* USES UNIT=12
C
C	RECOGNIZED PARAMETERS
C
C		NORENAME	SUPPRESSES .NAME OUTPUT
C				('NORENAME' IN .LPC FORCES THIS)
C		NOPARM		SUPPRESSES PARAMETER VALUE OUTPUT
C
C	THIS VERSION PASSES THROUGH UNRECOGNIZED INPUT
C
C	TYPMAX = MAXIMUM NO'S USED FOR EACH GROUP.  TYPMAX(10) SET TO
C		 ONE IF "ETHE" IS AN OUTPUT SPECIES
C
C	FXDMOD = .TRUE. IF LUMPED GROUP NUMBERS ARE TO BE SET
C		 AT THE GROUP NO. IN THE LPC FILE.  (TREATED AS .FALSE.
C		 IF TSTKOD=.TRUE.)
C
C	TSTKOD = .TRUE. IF THIS IS CALLED FOR "TEST" MIXTURES OR VOC'S.
C		 .FALSE. IF NORMAL LUMPING.
C
C	OUTRXN = .TRUE. IF ONLY PARAMETERS WITH PRODUCT DEFINED IN AAPROD
C		 ARE TO BE OUTPUT.
C
	INTEGER TYPMAX(10)
	LOGICAL FXDMOD,TSTKOD
C
C	INPUT TERMINATED BY <EOF> AND RECORDS STARTING WITH '.'.
C
C
	LOGICAL NOLUMP,NONEW
C	LOGICAL PRMCV
	INTEGER OUTU
	CHARACTER INLIN*80,NAMEIN*8,NAMCHR*4,PRMCHR*2
	DATA NONEW/.TRUE./
C
C	LUMPED ASSIGNMENT SPECIFICATIONS
C
	INCLUDE 'LUMPSPEC.FOR'
C
C	GRPSPE = NAME OF SPECIES LUMPED IN GROUP (IF ONLY ONE)
C	TYPKNT = ARRAY USED TO COUNT NUMBER OF THE SAME TYPE
C		 OF GROUP USED.
C	TYPBAS = BASE NUMBER FOR GROUP TYPES IN MECHANISM.
C	GRPFRE = FALSE IF GROUP USED.  USED FOR MULTIPLE CALLS.
C	LMPGRP = TRUE IF THIS GROUP IS LUMPED
C	PRMOUT = TRUE IF PARMS FOR THIS GROUP NEED TO BE OUTPUT
C	GRPNUM = THE ACTUAL LUMPED GROUP NUMBER USED FOR LUMPED SPECIES
C		 WITH THIS RATE CONSTANT RANGE
C	ASNUSD = THE GROUP NUMBER FOR THE RATE CONSTANT RANGE ACTUALLY
C		 USED FOR THIS GROUP (INVERSE OF GRPNUM)
C	
C
	CHARACTER*8 GRPSPE(MAXGRP)
	INTEGER TYPKNT(9),TYPBAS(9),GRPNUM(MAXGRP),ASNUSD(MAXGRP)
	LOGICAL RENAME,OUTPRM,ERRIND,VARYT,FIRST,GRPFRE(MAXGRP),
     &	 GRPDFD(MAXGRP),PRMOUT(MAXGRP),LMPGRP(MAXGRP),GN1IN
	DATA FIRST/.TRUE./GN1IN/.TRUE./
C
	CHARACTER GN1FILE*60,GN1VOC*8
	COMMON /GN1INFO/ GN1FILE
C
C	INITIALIZE OPTIONS.
C
	VOC1C=0.0
	IF (GN1IN.AND.GN1FILE(1:1).NE.' ') THEN
		OPEN (UNIT=12,FILE=GN1FILE,STATUS='OLD') ! READONLY
C		READ PAST PARMS.  VOC NAME EXPECTED TO BE NEXT NON-COMMENT
C		RECORD.
 170		READ (12,1,END=892) INLIN
   1		FORMAT (A)
		IF (INLIN(1:5).EQ.'PARMS') THEN
			READ (INLIN,'(5X,I5)',ERR=892) N
			IF (N.EQ.0) GOTO 172
			N=(N/8)+1
			READ (12,1) (INLIN(1:1),I=1,N)
		ELSE
			GOTO 170
		ENDIF
  172		READ (12,1,END=892) GN1VOC
		IF (GN1VOC(1:1).EQ.'!'.OR.GN1VOC(1:1).EQ.' ') GOTO 172
		CTEMP=4.40373E+17/TEMPR
		RT=0.0019872*TEMPR
		TOV300=TEMPR/300.0
	ELSEIF (GN1IN) THEN
		GN1VOC='!IGNORED'
		GN1IN=.FALSE.
	ENDIF
C
	IF (FIRST) THEN
		IF (NONEW) FIRST=.FALSE.
		NMODS0=NMODSP
		DO 2 I=1,NGRP
		GRPSPE(I)='        '
		GRPDFD(I)=.FALSE.
		GRPNUM(I)=0
		PRMOUT(I)=.TRUE.
		GRPFRE(I)=.TRUE.
    2		LMPGRP(I)=.FALSE.
C
		NOLUMP=.FALSE.
		RENAME=NAMEOK
		OUTPRM=.TRUE.
		VARYT=THIGH*TLOW.NE.0.0
C
C		FIND MINIMUM GROUP NO. USED FOR EACH TYPE OF LUMPED GROUP
C		(ONLY FOR "BASE" GROUPS)
C
		IF (.NOT.(TSTKOD.OR.FXDMOD)) THEN
			DO 11 I=1,9
			TYPKNT(I)=0
   11			TYPBAS(I)=10
			DO 12 IGRP=2,NGRP
			IF (GRPTYP(IGRP).GT.0) THEN
				READ (GRPNAM(IGRP),'(3X,Z1)') I
				I=I-1
				IF (I.LT.TYPBAS(GRPTYP(IGRP))) 
     &				 TYPBAS(GRPTYP(IGRP))=I
			ENDIF
   12			CONTINUE
		ENDIF
C
	ELSEIF (.NOT.FXDMOD) THEN
C
C		ON SECOND CALL IF NOT FXDMOD, NOLUMP FORCED
C
		NOLUMP=.TRUE.
C
	ENDIF
 1301	CONTINUE
C
C
C
C	INITIALIZE LUMPED GROUPS FOR THIS FILE.  NOTE THAT KOH
C	AND PARM ARRAYS CONTAIN TOTALS, WHICH WILL BE NORMALIZED
C	BY TOTAL AMOUNT IN GROUP TO GET AVERAGE AFTER INPUT DONE.
C	FIRST ONE OF BOTH ARE 'INERT' GROUPS.
C
C
	NNLS=0
C
	DO 10 I=1,NGRP
	TOTGRP(I)=0.0
	RKGRP(I)=0.0
	RCTGRP(I)=0.0
	DO 10 J=1,NAAPRM
   10	PRMGRP(J,I)=0.0
C
C	READ AND DECODE NEXT INPUT LINE.  IF IT CAN'T BE DECODED,
C	LOOP TO 180 TO OUTPUT LINE W/O CHANGE
C
	FAC=1.0
C  
  100	CALL INBUF ('LUMP: ',6)
	IF (IORET.EQ.2) GOTO 200
	IF (IOB160(1:1).EQ.'.') THEN
		GOTO 200
	ELSEIF (IOB160(1:1).EQ.' ') THEN
		GOTO 180
C
C	"NORENAME" ... PREVENTS .NAME OUTPUT
C
	ELSEIF (IOB160(1:8).EQ.'NORENAME') THEN
		RENAME=.FALSE.
		GOTO 100
C
C	"NOPARM" ... PREVENTS PARAMETER VALUE OUTPUT
C
	ELSEIF (IOB160(1:6).EQ.'NOPARM') THEN
		OUTPRM=.FALSE.
		GOTO 100
C
C	"NOLUMP" ... FORCES NO MORE THAN ONE DMS PER LUMPED GROUP.
C		     (KOH LIMITS GIVEN FOR LUMPED GROUPS ARE IGNORED)
C
C	"RESET" ... EACH .LUMP IS TREATED AS A NEW ONE.  (USED FOR 
C		    REACTIVITY .INS FILES, NOT APPROPRIATE FOR RUNS)
C
	ELSEIF (IOB160(1:5).EQ.'RESET') THEN
		FIRST=.TRUE.
		NONEW=.FALSE.
		GOTO 100
	ELSEIF (IOB160(1:6).EQ.'NOLUMP') THEN
		NOLUMP=.TRUE.
		GOTO 100
	ENDIF
C
C	GETS HERE IF NO SPECIAL COMMAND INPUT.
C	ASSUMED TO BE A NAME AND A VALUE
C
C	SPECIAL NAME:  #FAC value:	MULTIPLY ALL SUBSEQUENT VALUES BY
C					FACTOR INPUT.
C
	INLIN=IOB160(1:32)
C
	CALL PARSE0 (2,INLIN,80)
	NAMEIN='        '
	CALL PARSE1 (1,NAMEIN,L,8,INLIN)
	CALL PARSER (2,F,ERRIND,INLIN)
	IF (ERRIND) GOTO 180
C
C	#FAC f	FACTOR TO MULTIPLY ALL VALUES BY f
C
	IF (NAMEIN(1:4).EQ.'#FAC') THEN
		FAC=F
		GOTO 100
	ELSE
		F=F*FAC
	ENDIF
C
C	DEFER PROCESSING OF GN1VOC
C
	IF (NAMEIN.EQ.GN1VOC) THEN
		VOC1C=F
		GOTO 100
	ENDIF
C
C	SPECIES INPUT ASSUMED.  IGNORE SPECIES WITH ZERO LEVELS
C
	IF (F.EQ.0.0.AND.(.NOT.NOLUMP)) GOTO 100
C
C	SEE IF ANY MIXTURE SUBSTITUTIONS
C
	IF (NMIXS.NE.0) THEN
		DO 2201 IMIX=1,NMIXS
		IF (NAMEIN.EQ.MIXNAM(IMIX)) THEN
C
			IBMIX1=MIXI1(IMIX)
			NMIX1=NMIXI(IMIX)
			IMIX1=1
			NAMEIN=MIXCMP(IBMIX1)
			FMIX=F
			F=MIXFAC(IBMIX1)*FMIX
			GOTO 221
		ENDIF
 2201		CONTINUE
	ENDIF
	IMIX1=1
	NMIX1=1
	GOTO 221
C
C	LOOPS BACK TO HERE IF (IMIX1.LT.NMIX1) TO GET NEXT COMPONENT
C	IN MIXTURE TO PROCESS
C
 1002	IMIX1=IMIX1+1
	IBMIX1=IBMIX1+1
	NAMEIN=MIXCMP(IBMIX1)
	F=MIXFAC(IBMIX1)*FMIX
C
C	ENTRY POINT TO PROCESS NAMEIN, F INPUT.
C	FIRST REPLACE BY SUBSTITUTIONS, IF ANY.  (NOTE:  REPLACED SUCH
C	THAT TOTAL NUMBER OF CARBONS AND WEIGHT IS THE SAME.)
C	(CYCLES THROUGH UNTIL NO CHANGE.
C
  221	CONTINUE
	KSUB=0
 2221	DO 222 I=1,NSUB
	IF (NAMEIN.EQ.SUBNAM(I)) THEN
		KSUB=KSUB+1
		IF (KSUB.GT.4) THEN
			WRITE (6,*) 'Too many substitutions (>4) for '//NAMEIN
			WRITE (6,*) 'Check for recursive REPLACE input in LPC'
			CALL EXIT (2)
		ENDIF
		NAMEIN=SUBOUT(I)
		F=F*SUBFAC(I)
		GOTO 2221
	ENDIF
  222	CONTINUE
C
C	IF THIS IS ON LIST OF "EXPLICIT" MODEL SPECIES, THEN IT IS NOT
C	LUMPED.  LINE PASSED W/O PROCESSING.
C	IF IT IS "EXPLICIT" AND "ETHE", THEN TYPMAX(10) SET TO 1
C
	DO 226 I=1,NMODSP
	IF (NAMEIN.EQ.MODSP(I)) GOTO 230
  226	CONTINUE
C
C	DETERMINE WHICH MODEL SPECIES THIS IS (IF ANY)
C
	DO 229 IMOD=1,NAA
	IF (NAMEIN.EQ.AANAM(IMOD)) GOTO 240
  229	CONTINUE
C
C	NOT A MODEL SPECIES.  ADD IT TO LIST OF 'NON-LUMPED' SPECIES
C	NOTE THAT RKOH, IF GIVEN, IS IGNORED FOR SUCH SPECIES
C
  230	IF (NNLS.GT.0) THEN
		DO 234 I=1,NNLS
		IF (NAMEIN.EQ.NLSNAM(I)) THEN
			NLSLVL(I)=NLSLVL(I)+F
			GOTO 1001
		ENDIF
  234		CONTINUE
	ENDIF
	IF (NNLS.EQ.MAXNLS) STOP 'TOO MANY NON-LUMPED-PARM SPECIES'
C
C	ADD NEW NON-LUMPED SPECIES.  IF IT IS "ETHE", SET TYPMAX(10)=1
C
	NNLS=NNLS+1
	NLSNAM(NNLS)=NAMEIN
	IF (NAMEIN(1:4).EQ.'ETHE'.OR.NAMEIN(1:4).EQ.'C:C ') TYPMAX(10)=1
	NLSLVL(NNLS)=F
	GOTO 1001
C
C	THIS IS MODEL SPECIES NO. IMOD.  FIND GROUP IT GOES WITH.
C	IGRP IS GROUP NO. WITH SAME TYPE ID, AND WITH HIGHEST MINIMUM
C	KOH WHICH IS STILL LESS THAN THIS SPECIES' KOH.  IGRP=0 IF
C	SOME GROUP HAS SAME ID, BUT NONE HAVE MINIMUM KOH LESS THAN THIS
C	ONE.  IGRP=-1 IF NO GROUP HAS SAME TYPE ID
C
  240	RKOH=AAKOH(IMOD)
	KODE=AAGRP(IMOD)
	IF (TSTKOD) KODE=-KODE
	IGRP=-1
	IF (NOLUMP) THEN
		DO 241 I=2,NGRP
		IF (NAMEIN.EQ.GRPSPE(I)) THEN
			TOTGRP(I)=TOTGRP(I)+F
			IF (LMPGRP(I)) THEN
				IF (GRPIND(ASNUSD(I)).NE.0) THEN
					GRPSPE(I)="+"
				ENDIF
			ELSE
				RCTGRP(I)=RCTGRP(I)+F
			ENDIF
			GOTO 1001
		ELSEIF (KODE.EQ.GRPTYP(I).AND.GRPFRE(I)) THEN
			IGRP=I
			JGRP=I
			GRPFRE(I)=.FALSE.
			GOTO 2411
		ENDIF
  241		CONTINUE
		WRITE (ICRT,*) 'Too many type ',KODE,
     &		 ' species for NOLUMP option'
		WRITE (OUTU,1) '! Too many type ',KODE,
     &		 ' species for NOLUMP'
 2411		CONTINUE
	ELSE
		RKOHMX=-1.0
		DO 242 I=2,NGRP
		IF (KODE.EQ.GRPTYP(I)) THEN
			IF (IGRP.LT.0) IGRP=0
			IF (RKOH.GE.KOHMIN(I)) THEN
				IF (KOHMIN(I).GT.RKOHMX) THEN
					RKOHMX=KOHMIN(I)
					IGRP=I
				ENDIF
			ENDIF
		ENDIF
  242		CONTINUE
		IF (IGRP.GT.0) THEN
			JGRP=IGRP
			IF (GRPNUM(JGRP).EQ.0) THEN
				DO 243 J=JGRP,NGRP
				IF (GRPFRE(J)) THEN
					IGRP=J
					GRPNUM(JGRP)=IGRP
					ASNUSD(IGRP)=JGRP
					GRPFRE(IGRP)=.FALSE.
					LMPGRP(IGRP)=.TRUE.
					GOTO 2441
				ENDIF
  243				CONTINUE
				WRITE (ICRT,*)
     &			'Too many type ',KODE,' species.  Unable to lump.'
				IGRP=-1
 2441				CONTINUE
			ELSE
				IGRP=GRPNUM(JGRP)
			ENDIF
		ENDIF
	ENDIF
C
	IF (IGRP.LT.0) THEN
C
C		ERROR IF NO GROUP WITH THIS TYPE ID  PUT ERROR
C		MESSAGE IN OUTPUT FILE
C
		WRITE (OUTU,244) AANAM(IMOD)
		WRITE (ICRT,244) AANAM(IMOD)
  244		FORMAT ('! Error.  Undefined group for ',A,'.')
		CALL EXIT (2)
C
	ELSEIF (IGRP.GT.0) THEN
C
C		THIS IS LUMPED IN GROUP IGRP.  SUM UP AMOUNT,
C		KOH, PARMS.  F IS AMOUNT IN GROUP, WF IS AMOUNT
C		WEIGHED BY AMOUNT REACTED, AS DETERMINED BY
C		GRPIND AND/OR INTOH AND RKOH
C
		IF (LMPGRP(IGRP)) THEN
			IF (GRPIND(JGRP).EQ.1) THEN
				WF=F*(1.0-EXP(-RKOH*INTOH))
			ELSEIF (GRPIND(JGRP).EQ.2) THEN
				WF=F*RKOH
			ELSEIF (GRPIND(JGRP).EQ.3) THEN
				IF (RKOH.GT.DRKGRP(JGRP)) THEN
					WF=F*(1.0-EXP(-DRKGRP(JGRP)*INTOH))
				ELSE
					WF=F*(1.0-EXP(-RKOH*INTOH))
				ENDIF
			ELSE
				WF=F
			ENDIF
			RKGRP(IGRP)=RKGRP(IGRP)+WF*RKOH
			IF (GRPPNM(IGRP).NE.'  ') THEN
				DO 246 I=1,NAAPRM
  246				PRMGRP(I,IGRP)=PRMGRP(I,IGRP)
     &				 +WF*AAPARM(I,IMOD)
			ENDIF
		ELSE
			WF=F
			RKGRP(IGRP)=RKOH
			IF (GRPPNM(IGRP).NE.'  ') THEN
				DO 2461 I=1,NAAPRM
 2461				PRMGRP(I,IGRP)=AAPARM(I,IMOD)
			ENDIF
		ENDIF
		TOTGRP(IGRP)=TOTGRP(IGRP)+F
		RCTGRP(IGRP)=RCTGRP(IGRP)+WF
C
C		IF THIS GROUP HAS NO SPECIES LUMPED IN IT YET,
C		GIVE IT THIS SPECIES NAME.  IF IT HAS ONE THAT'S DIFFERENT,
C		MARK IT AS "MULTIPLE".
C
		IF (GRPSPE(IGRP)(1:1).EQ.' ') THEN
			GRPSPE(IGRP)=NAMEIN
		ELSEIF (GRPSPE(IGRP)(1:1).NE.'+') THEN
			IF (GRPSPE(IGRP).NE.NAMEIN) GRPSPE(IGRP)(1:1)='+'
		ENDIF
C
	ELSE
C
C		KOH LESS THAN MINIMUM FOR THIS GROUP.  THIS IS
C		'INERT', AND IT IS IGNORED.
C
		WRITE (OUTU,'(''! INERT = '',A)') NAMEIN
C
	ENDIF
C
 1001 	IF (IMIX1.LT.NMIX1) GOTO 1002
	GOTO 100
C
C
C	CONTROL REACHES HERE IF INPUT LINE CAN'T BE DECODED.
C	OUTPUT IT AS IS AND LOOP BACK FOR MORE.
C
  180	WRITE (OUTU,'(A)') IOB160(1:LNBLNK(IOB160))
	GOTO 100
C
C
C	END OF COMPOSITON INPUT PROCESSING.  DO LUMPING AND OUTPUT
C	RESULTS
C
C
C	OUTPUT "NON LUMPED" SPECIES.
C
  200	IF (NNLS.GT.0) THEN
		IF (LPRE.EQ.0) THEN
			WRITE (OUTU,'(A8,1PE12.4)') (NLSNAM(I),
     &			 NLSLVL(I),I=1,NNLS)
		ELSE
			J=8-LPRE
			WRITE (OUTU,'(A,A,1PE12.4)') (LPRECH(1:LPRE),
     &			 NLSNAM(I)(1:J),NLSLVL(I),I=1,NNLS)
		ENDIF
	ENDIF
C
C
C	CALCULATE AVERAGES FOR LUMPED GROUPS, AND OUTPUT TOTAL
C	AMOUNTS AND AVERAGE PARMS.
C
C	FOR GROUPS WITH KOH WEIGHED AVERAGING (GRPIND NE 0), THE
C	EFFECTIVE INITIAL CONCENTRATION IS CALCULATED FROM THE
C	TOTAL AMOUNT REACTED, THE GROUP RATE CONSTANT, AND THE
C	INTEGRATED OH.  THE GROUP RATE CONSTANT IS EITHER THE
C	DEFAULT RATE CONSTANT (DRKGRP) READ FROM THE LUMPING CONTROL
C	FILE, OR (IF DRKGRP=0) THE WEIGHED AVERAGE RATE CONSTANT
C	FOR THIS GROUP.
C
C	FOR GROUPS WITH "SIMPLE" AVERAGING (GRPIND=0), DRKGRP
C	IS IGNORED, AND THE GROUP RATE CONSTANT IS ALWAYS THE
C	WEIGHED AVERAGE.
C
C	IF PARAMETER CONVERSIONS TO BE DONE, DO IT NOW BEFORE PROCESSING 
C	LUMPED GROUPS.
C
C	THIS FEATURE IS NO LONGER SUPPORTED
C
C	PRMCV=PRMCNV(1:1).NE.' '.AND.NAAPRM.NE.0
C	IF (PRMCV) THEN
C
C		OPEN (UNIT=12,FILE='PRMCONV.IN',STATUS='UNKNOWN')
C		DO 280 IGRP=2,NGRP
C  280 		WRITE (12,'(I3/(A2,1PE15.4))') NAAPRM,(AAPNAM(I),
C     &		 PRMGRP(I,IGRP),I=1,NAAPRM)
C		CLOSE (UNIT=12)
C
C		INLIN=MECUIC(1:LNBLNK(MECUIC))//
C     &		 PRMCNV(1:LNBLNK(PRMCNV))
C		CALL SYSTEM (INLIN)
C		OPEN (UNIT=12,FILE='PRMCONV.OUT',STATUS='OLD',
C     &		 ERR=282)
C		GOTO 284
C  282			WRITE (ICRT,*) 'File = ',CHARNB(MECUIC)//
C     &			 CHARNB(PRMCNV),'.EXE does not exist.'
C			GOTO 890
C  284		CONTINUE
C	ENDIF
C
	DO 300 IGRP=2,NGRP
	WF=RCTGRP(IGRP)
	IF (LMPGRP(IGRP)) THEN
		JGRP=ASNUSD(IGRP)
		WFP=WF
		IF (WF.EQ.0.0) GOTO 300
		RKOH=RKGRP(IGRP)/WF
		RKGRP(IGRP)=RKOH
		IF (GRPIND(JGRP).EQ.2) THEN
			IF (DRKGRP(JGRP).NE.0.0) RKOH=DRKGRP(JGRP)
			F=WF/RKOH
C?			X=TOTGRP(IGRP)-F
		ELSEIF (GRPIND(JGRP).EQ.1.OR.GRPIND(JGRP).EQ.3) THEN
			IF (DRKGRP(JGRP).NE.0.0) RKOH=DRKGRP(JGRP)
			F=WF/(1.0-EXP(-RKOH*INTOH))
		ELSE
			F=TOTGRP(IGRP)
		ENDIF
		RCTGRP(IGRP)=F
	ELSE
		IF (WF.EQ.0.0) THEN
			IF (GRPSPE(IGRP)(1:1).EQ.' ') GOTO 300
			IF (GRPDFD(IGRP)) GOTO 300
		ENDIF
		F=TOTGRP(IGRP)
		RKOH=RKGRP(IGRP)
		WFP=1.
	ENDIF
C
C	IF FXDMOD NOT SET, THEN
C	DETERMINE AND INCREMENT SEQUENCE NUMBER FOR THIS TYPE OF GROUP.
C	GROUP NAME EXPECTED TO BE IN FORM xxxn, AND GROUP PARM NAME
C	IN FORM xn, WHERE n OVERWRITTEN WITH THE SEQUENCE NO.
C
	IF (FXDMOD.OR.TSTKOD) THEN
		NAMCHR=GRPNAM(IGRP)
		PRMCHR=GRPPNM(IGRP)
	ELSE
		J=TYPKNT(GRPTYP(IGRP))+1
		TYPKNT(GRPTYP(IGRP))=J
		J=J+TYPBAS(GRPTYP(IGRP))
		WRITE (NAMCHR,'(A3,Z1)') GRPNAM(IGRP)(1:3),J
		WRITE (PRMCHR,'(A1,Z1)') GRPPNM(IGRP)(1:1),J
	ENDIF
C
C	CHANGE LUMPED GROUP SPECIES NAME IF IT HAS ONLY ONE SPECIES, THEN
C	WRITE LUMPED GROUP CONCENTRATION
C
C	ALSO, IF RENAME USED, THIS BECOMES A NEW EXPLICIT MODEL SPECIES
C	FOR SUBSEQUENT LUMP CALLS.
C
	IF (RENAME) THEN
		IF (GRPSPE(IGRP)(1:1).NE.'+') THEN
			WRITE (OUTU,'(''.NAME '',A4,1X,A8)') NAMCHR,
     &			 GRPSPE(IGRP)
			IF (NMODSP.EQ.MMODSP) THEN
				WRITE (ICRT,*) 'INCREASE MMODSP',
     &				 ' IN LUMPSPEC.FOR'
				GOTO 899
			ENDIF
			NMODSP=NMODSP+1
			MODSP(NMODSP)=GRPSPE(IGRP)
			MODMW(NMODSP)=0.0	! NOT USED
			MODNC(NMODSP)=0		! NOT USED
			IF (F.NE.0.0) THEN
				IF (LPRE.EQ.0) THEN
					WRITE (OUTU,'(A8,1PE12.4)')
     &					 GRPSPE(IGRP),F
				ELSE
					WRITE (OUTU,'(A,A4,T9,1PE12.4)') 
     &					 LPRECH(1:LPRE),NAMCHR,F
				ENDIF
			ENDIF
		ELSEIF (F.NE.0.0) THEN
			IF (LPRE.EQ.0) THEN
				WRITE (OUTU,'(A4,4X,1PE12.4)') NAMCHR,F
			ELSE
				WRITE (OUTU,'(A,A4,T9,1PE12.4)') 
     &				 LPRECH(1:LPRE),NAMCHR,F
			ENDIF
		ENDIF
	ELSEIF (F.NE.0.0) THEN
		IF (LPRE.EQ.0) THEN
			WRITE (OUTU,'(A4,4X,1PE12.4)') NAMCHR,F
		ELSE
			WRITE (OUTU,'(A,A4,T9,1PE12.4)') LPRECH(1:LPRE),
     &			 NAMCHR,F
		ENDIF
	ENDIF
	GRPDFD(IGRP)=.TRUE.
C
C	WRITE LUMPED GROUP PARAMETERS
C
	IF (OUTPRM.AND.PRMOUT(IGRP)) THEN
		PRMOUT(IGRP)=.FALSE.
C
		IF (VARYT) THEN
			IF (DRKGRP(JGRP).NE.0.0) THEN
				WRITE (OUTU,3101) PRMCHR,'OH',
     &				 RKOH,DAGRP(JGRP),DEAGRP(JGRP),
     &				 DBGRP(JGRP)
			ELSE
				CALL ARRFIT3 (TLOW,TEMPR,THIGH,
     &				 PRMGRP(1,IGRP)/WFP,RKOH,
     &				 PRMGRP(2,IGRP)/WFP,A,EA)
				WRITE (OUTU,3101) PRMCHR,'OH',
     &				 RKOH,A,EA
			ENDIF
		ELSE
			WRITE (OUTU,3101) PRMCHR,'OH',RKOH
		ENDIF
 3101		FORMAT ('K(',2A2,') ',1P2E12.4,0P2F8.3)
C
		IF (NAAPRM.EQ.0) GOTO 300
C
C		IF (PRMCV) THEN
C			READ (12,'(A)',END=892) INLIN
C			IF (INLIN(1:3).NE.'OK ') GOTO 894
C			READ (12,'(E11.4)',ERR=896) (PRMGRP(I,IGRP),
C     &			 I=1,NAAPRM)
C		ENDIF
C
		DO 310 I=1,NAAPRM
		IF (PRMGRP(I,IGRP).EQ.0.0) GOTO 310
		IF (AAPRKI(I)) THEN
			IF (AAPNAM(I)(1:1).EQ.'*') GOTO 310
			IF (VARYT) THEN
				CALL ARRFIT3 (TLOW,TEMPR,THIGH,
     &				 PRMGRP(I+1,IGRP)/WFP,PRMGRP(I,IGRP)/WFP,
     &				 PRMGRP(I+2,IGRP)/WFP,A,EA)
				WRITE (OUTU,3101) PRMCHR,
     &				 AAPNAM(I),PRMGRP(I,IGRP)/WFP,A,EA
			ELSE
				WRITE (OUTU,3101) PRMCHR,
     &				 AAPNAM(I),PRMGRP(I,IGRP)/WFP
			ENDIF
		ELSEIF (.NOT.(OUTRXN.AND.AAPROD(I)(1:1).EQ.' ')) THEN
			WRITE (OUTU,'(A2,A6,1PE12.4,1X)')
     &			 PRMCHR,AAPNAM(I),PRMGRP(I,IGRP)/WFP
C			WRITE (OUTU,'(A2,A6,1PE12.4,1X,''! '',A)')
C     &			 PRMCHR,AAPNAM(I),PRMGRP(I,IGRP)/WFP,AAPROD(I)
		ENDIF
  310		CONTINUE
C
C		IF (PRMCV) THEN
C			READ (12,'(I3)',ERR=896) N
C			IF (N.EQ.0) GOTO 300
C			DO 312 I=1,N
C			READ (12,'(A6,E11.4)',ERR=896) INLIN(1:6),F
C			IF (F.NE.0.0) WRITE (OUTU,'(A2,A6,1PE12.4)') 
C     &			 PRMCHR,INLIN(1:6),F/WF
C  312			CONTINUE
C		ENDIF
C
	ENDIF
C
  300	CONTINUE
C
C	OUTPUT SPECIAL VOC CONC, AND COPY PARAMETERS FROM GN1
C	FILE, IF APPLICABLE
C
	IF (GN1IN) THEN
		WRITE (OUTU,175) GN1FILE(1:LNBLNK(GN1FILE)),
     &		 GN1VOC(1:LNBLNK(GN1VOC))
  175		FORMAT ('!'/'! Parameters from ',A/'.NAME GENX ',A)
  176		READ(12,1,END=177) INLIN
		IF (INLIN(1:1).EQ.'!'.OR.INLIN(1:1).EQ.' '.OR.
     &	 INLIN(1:3).EQ.'MW '.OR.INLIN(1:3).EQ.'NC ') GOTO 176
		IF (INLIN(1:5).EQ.'PROD ') THEN
			GN1IN=.FALSE.
		ELSE
			IF (INLIN(1:2).EQ.'K(') THEN
				CALL PARSE0 (4,INLIN,80)
				CALL PARSER (2,F,ERRIND,INLIN)
				IF (ERRIND) GOTO 176
				CALL PARSER (3,EA,ERRIND,INLIN)
				IF ((.NOT.ERRIND).AND.EA.NE.0.0) F=F*EXP(-EA/RT)
				CALL PARSER (4,B,ERRIND,INLIN)
				IF ((.NOT.ERRIND).AND.B.NE.0.0) F=F*(TOV300**B)
				IF (TOPPM) F=CTEMP*F
			ELSE
				CALL PARSE0 (2,INLIN,80)
				CALL PARSER (2,F,ERRIND,INLIN)
				IF (ERRIND) GOTO 176
			ENDIF
			CALL PARSE1 (1,NAMEIN,I,8,INLIN)
			IF (GN1IN) THEN
				IF (NAMEIN(1:2).EQ.'K(') THEN
					WRITE (OUTU,178) 'K(GX'//NAMEIN(3:8),F
  178					FORMAT (A8,1PE11.3)
				ELSE
					WRITE (OUTU,178) 'GX'//NAMEIN(1:6),F
				ENDIF
			ELSE
				WRITE (OUTU,178) NAMEIN,F
			ENDIF
		ENDIF
		GOTO 176
  177		CLOSE (UNIT=12)
		GN1IN=.FALSE.
	ENDIF
	IF (VOC1C.NE.0.0) THEN
		WRITE (OUTU,178) GN1VOC,VOC1C
	ENDIF
C
C	IF (PRMCV) CLOSE (UNIT=12,STATUS='DELETE')
C
C	DONE PROCESSING LUMPING FOR THIS FILE.  UPDATE MAXIMUM TYPES
C	USED
C
	IF (.NOT.NONEW) NMODSP=NMODS0
C
	IF (FXDMOD.OR.TSTKOD) RETURN
C
	DO 400 I=1,9
	IF (TYPKNT(I).GT.TYPMAX(I)) TYPMAX(I)=TYPKNT(I)
  400	CONTINUE
C
	RETURN
C
C	ABORT
C
C  890	WRITE (ICRT,*) 'Parameter conversion failed.'
C	GOTO 899
C  892	WRITE (ICRT,*) 'Unexpected <EOF> when reading parameter',
C     &	 ' conversion output file.'
C	GOTO 898
C  894	WRITE (ICRT,*) 'Parameter conversion error.'
C	WRITE (ICRT,*) 'Record read = ',CHARNB(INLIN)
C	GOTO 898
C  896	WRITE (ICRT,*) 'Error reading parameter conversion output.'
C
C  898	WRITE (ICRT,*) 'PRMCONV option used = ',CHARNB(PRMCNV)
C
  892	WRITE (ICRT,*) 'Error or unexpected <EOF> reading ',
     &	GN1FILE(1:LNBLNK(GN1FILE))
C
  899	OPEN (UNIT=1,FILE='STATUS.TMP',STATUS='UNKNOWN')
	CLOSE (UNIT=1,STATUS='DELETE')
	CALL EXIT (2)
	END
