	PROGRAM PHK
C
C	PROGRAM TO CALCULATE AND DISPLAY PHOTOLYSIS RATES
C	USING ABS,QY DATA IN [100,50]name.PHF FILES, AND
C	USING SPECTRAL DISTRIBUTION DATA IN [100,15]name.SDR
C	FILES.  ALSO CALCULATES PHOTKS FOR SOLAR SPECTRAL DIST.
C
C	USE:	PHK     	... FOR INTERACTIVE USE
C		PHK file	... TO TAKE INPUT FROM file.PHK
C
	INCLUDE 'PHOTSPCS.FOR'
C
	LOGICAL LOGOUT,SECNDS,SDSEC,KEYIN,ERRIND
	CHARACTER SDLBL*16,AQLBL*16,ACTFIL*20
	INTEGER*2 MONNUM(12)
	CHARACTER MONTH(12)*3,TULBL*4,INLIN*80,BUF*40
	REAL*4 LAT,DEC,SINLD,COSLD,TDAWN
	INTEGER INUNIT
C
	DATA MONTH/'JAN','FEB','MAR','APR','MAY','JUN'
     &	 ,'JUL','AUG','SEP','OCT','NOV','DEC'/,
     &	 MONNUM /285,316,344,10,40,71,101,132,163,193,224,254/,
     &	 LAT/34.06/,DEC/23.50/,SINLD/0.22332/,
     &	 COSLD/0.75974/,TDAWN/291.622/,LOGOUT/.FALSE./,
     &	 SECNDS/.FALSE./TULBL/'/min'/
C
	DATA INDU2/0/
C
	CALL GETARG (1,INLIN)
	L=LNBLNK(INLIN)
		WRITE (6,*) INLIN(1:L)
	IF (L.GT.1) THEN
		INLIN=INLIN(1:L)
		INLIN(L+1:L+4)='.PHK'
		OPEN (UNIT=1,FILE=INLIN,STATUS='OLD',ERR=9100)
		INUNIT=1
		KEYIN=.FALSE.
	ELSE
		INUNIT=IKEY
		WRITE (ICRT,*) 'Photolysis Rate Calculation Program.'
		WRITE (ICRT,*) 'Type HELP for list of commands.'
		KEYIN=.TRUE.
	ENDIF
C
C	DEFAULT SPEX CORRECTON = 2 (1983)
C
	SPXCOR=2
	NOQY=.FALSE.
C
C	GET UIC'S FOR .PHF AND .SDR FILES
C
	OPEN (UNIT=UNIT1,FILE='MODELING.PRM',STATUS='OLD',ERR=139)
	PHFUIC=' '
	SDRUIC=' '
  130	READ (UNIT1,1,END=138) INLIN
    1	FORMAT (A)
	L=LNBLNK(INLIN)
	IF (L.LE.4) THEN
		GOTO 130
	ELSEIF (INLIN(1:4).EQ.'PHF=') THEN
		PHFUIC=INLIN(5:L)
		LPHFUC=L-4
	ELSEIF (INLIN(1:4).EQ.'SDR=') THEN
		SDRUIC=INLIN(5:L)
		LSDRUC=L-4
	ENDIF
	GOTO 130
C
  138	CLOSE (UNIT=UNIT1)
C
  139	CONTINUE
C
 1000	IF (KEYIN) WRITE (ICRT,'(1X,A,$)') 'PHK> '
	READ (INUNIT,1,END=9900) INLIN
C
 1012	FORMAT (//' LEGAL COMMANDS:'/
     &   /' SD=name ... USE SPECTRAL DISTRIBUTION IN FILE [sdruic]'
     &     ,'name.SDR'
     &   /' JS=name .... USE JSPECTRA SPECTRAL DISTRIBUTION IN FILE',
     &     ' name.JSF'
     &   /' Z=angle ... USE SOLAR SPECTRAL DIST WITH ZENITH ANGLE '
     &    ,'= angle'
     &   /' LAT=latitude ... GIVE LATITUDE (DEG.) FOR SOLAR PHOT.'
     &    ,'  (DEFAULT = 34.06, LA)'
     &   /' DEC=declination ... GIVE SOLAR DECLINATION (DEG.)'
     &    ,'  (DEFAULT = 23.5, SUMMER)'
     &   /' DATE=month day ... DATE FOR SOLAR PHOT.'
     &   /' TIME=hhmm ... CLOCK TIME FOR SOLAR PHOT.'
     &   /' PF=name ... CALCULATE PHOT RATE FOR REACTION WITH ABS,',
     &   ' QY DATA IN'/' ',12X,'FILE [phkuic]name.PHK'
     &   /' PF=name ACTOUT[=splfile] ... ACTION SPECTRUM TO .SPL FILE.'
     &   /'  (ACTOUT FEATURE REMOVED DUE TO BUG)'
     &   /' ACTPLT ... SHOW CURRENT ACTION SPECTRUM(A)'
     &   /' LS ... LIST SPECTRAL DIST.'
     &   /' SECONDS ... CHANGE TIME UNITS TO SECONDS'
     &   /' MINUTES ... CHANGE TIME UNITS BACK TO MINUTES (DEFAULT)'
     &   /' LAVG ... LIST AVERAGE ABS*QY FOR WAVELENGTH INTERVALS WHERE'
     &    ,' SOLAR SDIST DEFINED.'
     &   /' LOG ... WRITE OUTPUT TO FILE = PHK.OUT IN ADDITION TO '
     &    ,'TERMINAL.'
     &   /' OUT=file ... OUTPUT TO FILE IN ADDITION TO TERMINAL.'
     &   /' SDROUT=sdrfile ... OUTPUT SPECTRAL DISTRIBUTION TO FILE.'
     &   /' NOLOG or CLOSE ... CLOSE OUTPUT FILE.'
     &   /' SPEXCOR=code ... SPEX Corr:  1 = 1976, '
     &    ,'2 = 1983, 3 = UNC LiCor'
     &   /' NOQY ... SET ALL QY=1 (MAX PHOTK CALC)'
     &   /' USEQY .. CANCEL "NOQY" OPTION'
     &   /' QUIT ... EXIT PROGRAM.')
C
	IF (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'!') THEN
		GOTO 1000
C
	ELSEIF (INLIN(1:2).EQ.'QU') THEN
		GOTO 9900
C
	ELSEIF (INLIN(1:3).EQ.'SD='.OR.INLIN(1:3).EQ.'JS=') THEN
C
C		READ SDIST
C
		SDLBL=INLIN(1:16)
		CALL SDIST (SDLBL,SDSEC)
C
C		SDSEC=T IF SDIST INPUT IN SEC-1.  MAKE CONSISTENT WITH THE
C		VALUE OF "SECNDS", WHICH IS T IF THEY'RE SUPOSSED TO BE IN
C		SEC-1.  IF SDIST NOT IN SEC-1, IT IS IN MIN-1, THE DEFAULT.
C
		IF (SECNDS) THEN
			IF (.NOT.SDSEC) THEN
				DO 1101 I=1,NSWL-1
				ASDIST(I)=ASDIST(I)/60.0
				BSDIST(I)=BSDIST(I)/60.0
 1101				SDISTR(I)=SDISTR(I)/60.0
				SDISTR(NSWL)=SDISTR(NSWL)/60.0
			ENDIF
		ELSE
			IF (SDSEC) THEN
				DO 1102 I=1,NSWL-1
				ASDIST(I)=ASDIST(I)*60.0
				BSDIST(I)=BSDIST(I)*60.0
 1102				SDISTR(I)=SDISTR(I)*60.0
				SDISTR(NSWL)=SDISTR(NSWL)*60.0
			ENDIF
		ENDIF
C
	ELSEIF (INLIN(1:2).EQ.'LS') THEN
C
C		'LS' ... LIST SPECTRAL DIST.
C
		IF (NSWL.EQ.0) GOTO 1000
		IF (SDAREA) THEN
			WRITE (ICRT,1702) SDLBL,TULBL,(SWL(I),SWL(I+1),
     &			 SDISTR(I),I=1,NSWL)
			IF (LOGOUT) THEN
				WRITE (OUTU,1702) SDLBL,TULBL,
     &				 (SWL(I),SWL(I+1),SDISTR(I),I=1,NSWL)
				WRITE (OUTU,1704) SDLBL,TULBL,
     &				 (0.5*(SWL(I)+SWL(I+1)),SDISTR(I)/
     &				 (SWL(I+1)-SWL(I)),I=1,NSWL)
			ENDIF
 1702			FORMAT (' '/' Spectral Distribution for ',A,
     &                   ' in units of photons/cm2',A4,':'/' '/
     &                   ' ',3('  (   microns    sdist   )')/
     &                   (' ',3('  (',0PF5.3,'-',F5.3,1PE11.3,')',:)))
		ELSE
			WRITE (ICRT,1704) SDLBL,TULBL,(SWL(I),
     &			 SDISTR(I),I=1,NSWL)
			IF (LOGOUT) WRITE (OUTU,1704) SDLBL,TULBL,
     &			 (SWL(I),SDISTR(I),I=1,NSWL)
 1704			FORMAT (' '/' Spectral Distribution for ',A,
     &                   ' in units of photons/cm2',A4,'/micron:'/' '/
     &                   ' ',4('  (microns sdist. )')/(' ',4('  (',
     &                   0PF5.3,1PE10.3,')',:)))
		ENDIF
C
	ELSEIF (INLIN(1:7).EQ.'SDROUT=') THEN
C
C		'SDROUT' ... OUTPUT SPECTRAL DIST IN FILE.
C
		IF (NSWL.EQ.0) THEN
			WRITE (ICRT,*) 'No sdist. in memory'
			GOTO 1000
		ENDIF
		L=LNBLNK(INLIN)
		IF (L.EQ.7) THEN
			WRITE (ICRT,*) 'No SDR file specified'
			GOTO 1000
		ENDIF
		L=L+4
		INLIN(L-3:L)='.SDR'
		OPEN (UNIT=UNIT1,FILE=INLIN(8:L),
     &		 STATUS='UNKNOWN')
		IF (SDAREA) THEN
			WRITE (UNIT1,1) 'Spectral distribution for '//
     &			 SDLBL(1:LNBLNK(SDLBL))//'.  Output by PHK.'
			WRITE (UNIT1,1) '! Converted from AREA units.'
			IF (SWL(NSWL+1).LE.SWL(NSWL)) THEN
				J=NSWL-1
			ELSE
				J=NSWL
			ENDIF
			DO 1706 I=1,J
			F=SDISTR(I)/(SWL(I+1)-SWL(I))
C 1706			WRITE (UNIT1,1707) SWL(I),F,SWL(I+1)-0.0001,F ! EXACT
 1706			WRITE (UNIT1,1707) 0.5*(SWL(I)+SWL(I+1)),F
 1707			FORMAT (0PF7.5,1PE10.3)
		ELSE
			WRITE (UNIT1,1705) SDLBL(1:LNBLNK(SDLBL)),(SWL(I),
     &			 SDISTR(I),I=1,NSWL)
 1705			FORMAT ('Spectral Distribution for ',A,
     &                   '.  Output by PHK.'/(0PF7.5,1PE10.3))
		ENDIF
		CLOSE (UNIT=UNIT1)
		WRITE (ICRT,*) 'File = ',INLIN(8:L),' created.'
C
	ELSEIF (INLIN(1:4).EQ.'LAVG') THEN
C
C		'LAVG' ... LIST AVERAGES OF ABS*QY IF 'AREA' METHOD USED.
C
		IF (SDAREA.AND.NSWL.GT.0.AND.NWL.GT.0) THEN
			CALL PFALIN (AP(1,2),NWL,PWL,AP,NSWL,SWL)
			WRITE (ICRT,1712) AQLBL,(SWL(I),SWL(I+1),
     &			 AP(I,2),I=1,NSWL)
 1712			FORMAT (' '/' Average ABS*QY for ',2A8,
     &                   ' in units of',' cm2/molecule (base e):'/' '/
     &                   ' ',3('  (   microns      avg   )')/
     &                   (' ',3('  (',0PF5.3,'-',F5.3,1PE11.3,')',:)))
			IF (LOGOUT) WRITE (OUTU,1712) AQLBL,(SWL(I),
     &			 SWL(I+1),AP(I,2),I=1,NSWL)
		ELSE
			WRITE (ICRT,*) 'sdist fluxes or phot. rxn ',
     &			 'not defined.'
		ENDIF
C
	ELSEIF (INLIN(1:2).EQ.'Z=') THEN
C
C		Z=
C
		INLIN(2:2)=' '
		CALL PARSE0 (2,INLIN,80)
		INLIN(2:2)='='
		CALL PARSE1 (2,BUF,L,40,INLIN)
		IF (BUF(1:1).EQ.' ') GOTO 1001
		CALL PARSER (2,Z,ERRIND,INLIN)
		IF (ERRIND) GOTO 1001
		L=LNBLNK(INLIN)
		SDLBL='                '
		SDLBL=INLIN(1:MIN0(L,16))
		IF (Z.LT.0.0.OR.Z.GE.90.0) GOTO 1001
		COSZ=COS(1.745329E-2*Z)
C		CALL SOLAR (COSZ,O3STRT,DAYFAC)
		CALL SOLAR (COSZ)
		GOTO 1185
C
	ELSEIF (INLIN(1:2).EQ.'LA') THEN
C
C		LAT
C
		CALL PARSE0 (2,INLIN,80)
		CALL PARSE1 (2,BUF,L,40,INLIN)
		IF (BUF(1:1).EQ.' ') GOTO 1001
		CALL PARSER (2,Z,ERRIND,INLIN)
		IF (ERRIND) GOTO 1001
		IF (ABS(Z).GT.90.0) GOTO 1001
		LAT=Z
		GOTO 1150
C
	ELSEIF (INLIN(1:2).EQ.'DE') THEN
C
C		DEC
C
		CALL PARSE0 (2,INLIN,80)
		CALL PARSE1 (2,BUF,L,40,INLIN)
		IF (BUF(1:1).EQ.' ') GOTO 1001
		CALL PARSER (2,Z,ERRIND,INLIN)
		IF (ERRIND) GOTO 1001
		IF (ABS(Z).GT.90.0) GOTO 1001
		DEC=Z
		GOTO 1150
C
	ELSEIF (INLIN(1:4).EQ.'DATE') THEN
C
C		DATE
C
		CALL PARSE0 (3,INLIN,80)
		CALL PARSE1 (3,BUF,L,40,INLIN)
		IF (BUF(1:1).EQ.' ') GOTO 1001
		CALL PARSEI (3,IDAY,ERRIND,INLIN)
		IF (ERRIND) GOTO 1001
		CALL PARSE1 (2,BUF,L,40,INLIN)
		IF (BUF(1:1).EQ.' ') GOTO 1001
		DO 1144 I=1,12
		IF (BUF(1:3).EQ.MONTH(I)) GOTO 1146
 1144		CONTINUE
		GOTO 1001
 1146		DAYANG=1.71789E-2*FLOAT(MONNUM(I)+IDAY)
		DEC=23.5*SIN(DAYANG)
		WRITE (ICRT,
     &		 '('' Solar declination ='',F6.2,'' degrees.'')') DEC
C		DAYFAC=0.99944-0.033345*SIN(DAYANG-0.235)
C		WRITE (ICRT,
C     &	    '('' Extraterrestial intensity correction factor ='',F6.3)')
C     &		 DAYFAC
		GOTO 1150
C
	ELSEIF (INLIN(1:4).EQ.'TIME') THEN
C
C		TIME
C
		CALL PARSE0 (2,INLIN,80)
		CALL PARSE1 (2,BUF,L,40,INLIN)
		IF (BUF(1:1).EQ.' ') GOTO 1001
		CALL PARSEI (2,ITIME,ERRIND,INLIN)
		IF (ERRIND) GOTO 1001
		IF (ITIME.LT.0) GOTO 1001
		IF (ITIME.GT.2400) GOTO 1001
		I=MOD(ITIME,100)
		IF (I.GE.60) GOTO 1001
		Z=FLOAT(I+(60*(ITIME/100)))
		IF (Z.GT.720.0) Z=1440.0-Z
		IF (Z.LT.TDAWN) GOTO 1165
		COSZ=SINLD-COS(4.363323E-3*Z)*COSLD
		Z=57.29578*ACOS(COSZ)
		WRITE (SDLBL,'(''Calc Z ='',F6.2,2X)') Z
		WRITE (ICRT,'(''+'',A)') SDLBL(1:14)
C		CALL SOLAR (COSZ,O3STRT,DAYFAC)
		CALL SOLAR (COSZ)
		GOTO 1185
C
	ELSEIF (INLIN(1:3).EQ.'PF=') THEN
C
C		PF=
C
		CALL PARSE0 (2,INLIN,80)
		CALL PARSE1 (1,AQLBL,LNAM,16,INLIN)
		CALL PARSE1 (2,BUF,L,40,INLIN)
C
		Z=PHOTK(AQLBL(4:),I)
		IF (I.NE.0) GOTO 1000
C
		IF (NSWL.GT.0.AND.NWL.GT.0) THEN
			WRITE (ICRT,2102) SDLBL,AQLBL,Z,AVGWL
			IF (LOGOUT) WRITE (OUTU,2102) SDLBL,AQLBL,Z,
     &			 AVGWL
 2102			FORMAT (' ',A11,', ',A11,':  PHOT K =',1PG12.4,
     &                   5X,'AVG WL =',0PF6.3)
		ENDIF
		IF (Z.EQ.0.0) GOTO 1000
		IF (BUF(1:6).EQ.'ACTOUT') THEN
			WRITE (ICRT,*) 'ACTOUT FEATURE DISABLED'
			WRITE (ICRT,*) 'PROGRAM BUG'
			GOTO 1000
C
C			'ACTOUT' ... OUTPUT ACTION SPECTRUM TO FILE
C
			IF (L.LT.8) THEN
				IF (INDU2.EQ.0) THEN
					L=10
					BUF(7:10)='=TMP'
				ENDIF
			ELSE
				INDU2=0
			ENDIF
			IF (INDU2.EQ.0) THEN
				ACTFIL=BUF(8:L)//'.SPL'
				LACTFL=L-3
				OPEN (UNIT=UNIT2,FILE=ACTFIL,
     &				 STATUS='UNKNOWN')
				WRITE (UNIT2,1) '#TITLE Action Spectra'
				WRITE (UNIT2,1) '#XLABEL WL'
				WRITE (UNIT2,1) '#YLABEL J*Abs*QY/Photk'
				WRITE (UNIT2,1) '#LAB 2'
			ELSE
				OPEN (UNIT=UNIT2,FILE=ACTFIL(1:LACTFL),
     &				 STATUS='OLD',ACCESS='APPEND')
			ENDIF
			INDU2=INDU2+1
			WRITE (UNIT2,'(/I1,1X,A8,1X,A)') 
     &			 MOD(INDU2-1,7)+1,AQLBL(4:),SDLBL(1:LNBLNK(SDLBL))
C				
			IF (SDAREA) THEN
				IF (SWL(NSWL+1).LE.SWL(NSWL)) THEN
					J=NSWL-1
				ELSE
					J=NSWL
				ENDIF
				F1=1.0
				DO 1806 I=1,J
				F=SDISTR(I)*AP(I,2)/(SWL(I+1)-SWL(I))/Z
				IF (F1.EQ.0.0.AND.F.EQ.0.0) THEN
					WLL=SWL(I+1)-0.0001
					GOTO 1806
				ELSEIF (F1.EQ.0.0) THEN
					WRITE (UNIT2,1707) WLL,F1
				ENDIF
				WLL=SWL(I+1)-0.0001
				WRITE (UNIT2,1707) SWL(I),F,WLL,F
				F1=F
 1806				CONTINUE
			ELSE
				F1=1.0
				DO 1808 I=1,NSWL
				IF (F1.EQ.0.0.AND.ACTBUF(I).EQ.0.0) 
     &				 THEN
					WLL=SWL(I)
					GOTO 1808
				ELSEIF (F1.EQ.0.0) THEN
					WRITE (UNIT2,1707) WLL,F1
				ENDIF
				F1=ACTBUF(I)/Z
				WLL=SWL(I)
				WRITE (UNIT2,1707) WLL,F1
 1808				CONTINUE
			ENDIF
			CLOSE (UNIT=UNIT2)
			IF (INDU2.EQ.1) THEN
				WRITE (ICRT,*) 'File = ',
     &			 	 ACTFIL(1:LACTFL),' created.'
			ELSE
				WRITE (ICRT,*) 'Added to',
     &				 ' file = ',ACTFIL(1:LACTFL)
			ENDIF
		ENDIF
C
	ELSEIF (INLIN(1:4).EQ.'NORM') THEN
C
C		NORM
C
		IF (NSWL.EQ.0) GOTO 1001
		CALL PARSE0 (3,INLIN,80)
		CALL PARSE1 (2,BUF,L,40,INLIN)
		IF (BUF(1:1).EQ.' ') GOTO 1001
		CALL PARSER (3,Z,ERRIND,INLIN)
		IF (ERRIND) GOTO 1001
		IF (Z.LE.0.0) GOTO 1001
		X=PHOTK(BUF,IND)
		IF (IND.NE.0) GOTO 1001
		IF (X.EQ.0.0) GOTO 1290
		X=Z/X
		DO 1210 I=1,NSWL-1
		SDISTR(I)=X*SDISTR(I)
		ASDIST(I)=X*ASDIST(I)
 1210		BSDIST(I)=X*BSDIST(I)
		SDISTR(NSWL)=X*SDISTR(NSWL)
		WRITE (ICRT,1220) X
 1220		FORMAT (' Sdist normalized.  Factor = ',1PG12.3)
		GOTO 1000
 1290		WRITE (ICRT,1292)
 1292		FORMAT (' ATTEMPTED TO NORMALIZE USING ZERO OR '
     &           ,'UNDEFINED PHOT K.')
C
	ELSEIF (INLIN(1:2).EQ.'HE') THEN
		WRITE (ICRT,1012)
C
	ELSEIF (INLIN(1:4).EQ.'LOG ') THEN
		OPEN (UNIT=OUTU,FILE='PHK.OUT',STATUS='UNKNOWN')
		LOGOUT=.TRUE.
	ELSEIF (INLIN(1:4).EQ.'OUT=') THEN
		IF (INLIN(5:5).EQ.' ') INLIN(5:80)='PHK.OUT'
		L=LNBLNK(INLIN)
		WRITE (ICRT,*) 'Output to ',INLIN(5:L)
		OPEN (UNIT=OUTU,FILE=INLIN(5:L),STATUS='UNKNOWN')
		LOGOUT=.TRUE.
	ELSEIF (INLIN(1:5).EQ.'NOLOG'.OR.INLIN(1:5).EQ.'CLOSE') THEN
		CLOSE (UNIT=OUTU)
		LOGOUT=.FALSE.
C
	ELSEIF (INLIN(1:8).EQ.'SECONDS ') THEN
		IF (.NOT.SECNDS.AND.NSWL.NE.0) THEN
			IF (SDAREA) THEN
				DO 1171 I=1,NSWL
 1171				SDISTR(I)=SDISTR(I)/60.0
			ELSE
				DO 1172 I=1,NSWL-1
				ASDIST(I)=ASDIST(I)/60.0
				BSDIST(I)=BSDIST(I)/60.0
 1172				SDISTR(I)=SDISTR(I)/60.0
				SDISTR(NSWL)=SDISTR(NSWL)/60.0
			ENDIF
		ENDIF
		SECNDS=.TRUE.
		TULBL='/sec'
	ELSEIF (INLIN(1:8).EQ.'MINUTES ') THEN
		IF (SECNDS.AND.NSWL.NE.0) THEN
			IF (SDAREA) THEN
				DO 1173 I=1,NSWL
 1173				SDISTR(I)=SDISTR(I)*60.0
			ELSE
				DO 1174 I=1,NSWL-1
				ASDIST(I)=ASDIST(I)*60.0
				BSDIST(I)=BSDIST(I)*60.0
 1174				SDISTR(I)=SDISTR(I)*60.0
				SDISTR(NSWL)=SDISTR(NSWL)*60.0
			ENDIF
		ENDIF
		SECNDS=.FALSE.
		TULBL='/min'
C
	ELSEIF (INLIN(1:6).EQ.'ACTPLT') THEN
		WRITE (ICRT,*) 'NOT SUPPORTED DUE TO BUG'
C		CALL SYSTEM ('SPL '//ACTFIL(1:LACTFL-4))
C
	ELSEIF (INLIN(1:8).EQ.'SPEXCOR=') THEN
		READ (INLIN(9:9),'(I1)',ERR=1001) SPXCOR
		IF (SPXCOR.LE.0) GOTO 1001
C
C
	ELSEIF (INLIN(1:4).EQ.'NOQY') THEN
		WRITE (ICRT,*) 'ALL QUANTUM YIELDS SET TO 1 FOR MAX PHOTK CALC'
		NOQY=.TRUE.

	ELSEIF (INLIN(1:5).EQ.'USEQY') THEN
		WRITE (ICRT,*) 'NOQY OPTION DISABLED'
		NOQY=.FALSE.
C
	ELSE
		WRITE (ICRT,*) 'Unrecognized command.'
	ENDIF
	GOTO 1000
C
 1001	WRITE (ICRT,*) 'Error in decoding command.'
	GOTO 1000
C
C
C	PROCESS NEW LAT OR DEC.
C
 1150	NSWL=0
	SINLD=SIN(1.745329E-2*LAT)*SIN(1.745329E-2*DEC)
	COSLD=COS(1.745329E-2*LAT)*COS(1.745329E-2*DEC)
	IF (COSLD.EQ.0.0) GOTO 1155
	F=-SINLD/COSLD
	IF (ABS(F).GE.1.0) GOTO 1155
	TDAWN=720.0-(ACOS(F)*229.183)
	I=IFIX(TDAWN)/60
	I=100*I+(IFIX(TDAWN)-60*I)
	WRITE (ICRT,1152) I
 1152	FORMAT (' Sunrise at',I5,' standard time')
	GOTO 1000
 1155	WRITE (ICRT,*) 'No light at any time.'
	TDAWN=1441.0
	GOTO 1000
C
 1165	WRITE (ICRT,*) 'No light.'
	NSWL=0
	GOTO 1000
C
C	NEW SOLAR SDIST
C
 1185	IF (SECNDS) THEN
		DO 1186 I=1,NSWL
 1186		SDISTR(I)=SDISTR(I)/60.0
	ENDIF
	GOTO 1000
C
C
C	ERRORS
C
 9100	WRITE (ICRT,*) 'File = ',INLIN(1:LNBLNK(INLIN)),' does not exist.'
C
C	DONE
C
 9900	IF (INDU2.NE.0) CLOSE (UNIT=UNIT2)
	CALL EXIT
	END
