      SUBROUTINE INSCOD(LEN,ISUB)
C
C      TAKES INPUT FROM IOB160.  ONLY PROCESSES ONE LINE.  LEN IS LENGTH OF
C      STRING IN IOB160.
C
C        TYPE           BASE ASSUMED
C     "C species name"       0          ANY SPECIES
C     "K reaction label"     1          RATE CONSTANT (ADJ. FOR CONST.)
C     "R reaction label"     2          REACTION RATE
C     "# coef name"          3          VARIABLE COEF.
C     "D species name"       4          ACTIVE OR B.O. DERIVATIVE
C     [species name]         0          SAME AS "C species name"
C     'coef name'            3          SAME AS "# coef name"
C
C     ISUB=1 for inserted Initial code (CONSTR routine)
C     Legal operand types: C, #
C
C     ISUB=2 for inserted DIFFUN code
C     Legal operand types: C (active or constant species only), #, K
C
C     ISUB=3 for inserted Print/Save code (SXTRA routine)
C     Legal operand types: C, #, K, R, D
C
	INCLUDE 'PSPECS.FOR'
C
	CHARACTER*1 IC1,OPCHR(5),ENDCHR
C
	INTEGER BASENO(5)
C
     	DATA OPCHR/'C','#','K','R','D'/
C
C	            CBASE COBASE KBASE RBASE DYBASE
C
	DATA BASENO / 0,    3,     1,    2,    4 /
C
	LOGICAL CONTLN
	DATA CONTLN/.FALSE./
C
C
C      IGNORE  LEADING BLANKS AND TAB CHARACTERS
C
       IC=0
       OUTBUF=' '
       LOUTBF=0
  100  IC=IC+1
       IF (IC.GT.LEN) RETURN
       IC1=BYT160(IC)
       IF (IC1.EQ.' ') GOTO 100
       IF (IC1.EQ.'	') GOTO 100	!TAB
       GOTO 210
C
C      LOOK AT NEXT CHAR OF INSTRUCTION
C
  200 IC=IC+1
      IF (IC.GT.LEN) GOTO 900
C                                     ! OUTPUT OUTBUF
      IC1=BYT160(IC)
      IF (IC1.EQ.'&') GOTO 900
  210 IF (IC1.EQ.'''') THEN
              ENDCHR=''''
              IOP=2
              GOTO 500
C                                     ! PROCESS COEF
      ELSEIF (IC1.EQ.'"') THEN
              GOTO 300
C                     		      ! GET TYPE AND OPERAND
      ELSEIF (IC1.EQ.'[') THEN
              IOP=1
              ENDCHR=']'
C                                     ! PROCESS SPECIES NAME
              GOTO 400
      ELSE
C             COPY CHARACTER INTO OUTPUT BUFFER
              LOUTBF=LOUTBF+1
              IF (LOUTBF.GT.132) STOP '.INS CODE LINE TOO LONG'
              OUTBUF(LOUTBF:LOUTBF)=IC1
              GOTO 200
      ENDIF
C
C     GET OPERAND OF THE FORM:
C        "C species"               IOP= 1
C        "# coefficient"                2
C        "K rxnlabel"                   3
C        "R rxnlabel"                   4
C        "D species"                    5
C
  300 IC=IC+1
      IF (IC.GT.LEN) GOTO 9901
C                             	     ! ERROR
      IC1=BYT160(IC)
      DO 305 IOP=1,5
      IF (OPCHR(IOP).EQ.IC1) GOTO 310
  305 CONTINUE
      GOTO 9902
C              			     ! ERROR: UNRECOGNIZED OPERAND CHAR
C
  310 IF (ISUB.EQ.1 .AND. IOP.GE.3) GOTO 9903
      IF (ISUB.EQ.2 .AND. IOP.GE.4) GOTO 9904
      IC=IC+1
      IF (IC.GT.LEN) GOTO 9901
C                                        ! ERROR
      IF (BYT160(IC).NE.' ') GOTO 9905
C                                        ! ERROR: BLANK EXPECTED AFTER OP CHAR
      IF (IOP.EQ.1 .OR. IOP.EQ.5) THEN
C                                       ! C OR D
              ENDCHR='"'
              GOTO 400
C                                     ! PROCESS SPECIES NAME
C
      ELSEIF (IOP.EQ.2) THEN
              ENDCHR='"'
              GOTO 500
C                                     ! PROCESS COEFFICIENT
C
      ELSE
C                         ! (IOP.EQ.3 .OR. IOP.EQ.4) FOR K OR R
C             PROCESS RXN LABEL
              IOBF16=' '
              DO 320 J=1,4
              IC=IC+1
              IF (IC.GT.LEN) GOTO 9901
              IC1=BYT160(IC)
              IF (IC1.EQ.'"') GOTO 330
              IOBF16(J:J)=IC1
 320          CONTINUE
              IC=IC+1
              IF (IC.GT.LEN) GOTO 9901
              IC1=BYT160(IC)
              IF (IC1.NE.'"') GOTO 9906
C                                           ! ERROR: RXN LABEL TOO LONG
C
C             DETERMINE WHICH RXN
C
 330          IF (IOBF16.EQ.' ') GOTO 9907
C                                           ! ERROR: NO RXN LABEL AFTER K OR R
              DO 340 IX=1,NRXN
              IF (IOBF16.EQ.RXNLBL(IX)) THEN
                    IF (IOP.EQ.3) THEN
                           IF (RXTYP(IX).EQ.2 .OR. RXTYP(IX).EQ.3)
     &                       GOTO 9908
C                                           ! ERROR: RXN HAS NO K
                    ENDIF
                    WRITE (OUTBUF(LOUTBF+1: ),332) BASENO(IOP),IX
 332                FORMAT ('A',I1,'(',I5,')')
                    LOUTBF=LOUTBF+9
                    IF (LOUTBF.GT.132) STOP '.INS CODE LINE TOO LONG'
                    GOTO 200
              ENDIF
 340          CONTINUE
              GOTO 9909
C                                            ! ERROR: RXN NOT FOUND
       ENDIF
C
C      PROCESS SPECIES NAME (OPERAND TYPE C OR D)
C
 400   IOBF16=' '
       DO 420 J=1,16
       IC=IC+1
       IF (IC.GT.LEN) GOTO 9901
       IC1=BYT160(IC)
       IF (IC1.EQ.ENDCHR) GOTO 430
       IOBF16(J:J)=IC1
 420   CONTINUE
       IC=IC+1
       IF (IC.GT.LEN) GOTO 9901
       IC1=BYT160(IC)
       IF (IC1.NE.ENDCHR) GOTO 9912
C                                       ! ERROR: SPECIES NAME TOO LONG
C
C  -     WHICH SPECIES NO.?
  430  IF (IOBF16.EQ.' ') GOTO 9915
C                                       ! ERROR: MISSING SPECIES NAME
       DO 431 I=1,NS
       IF (NAME(I).EQ.IOBF16) THEN
              IF (ISUB.EQ.2) THEN
C                    ONLY CONSTANT, ACTIVE, OR DUMMY SPECIES ALLOWED FOR DIFFUN CODE
                     IF (I.GT.NSC2) THEN
                           IF (I.LT.NB1 .OR. I.GT.NA2) GOTO 9913
C                                                                    !ERROR
                     ENDIF
              ENDIF
              WRITE (OUTBUF(LOUTBF+1: ),432) BASENO(IOP),I
 432          FORMAT ('A',I1,'(',I5,')')
              LOUTBF=LOUTBF+9
              IF (LOUTBF.GT.132) STOP '.INS CODE LINE TOO LONG'
              GOTO 200
       ENDIF
  431  CONTINUE
       GOTO 9917
C                                       ! ERROR: SPECIES NOT FOUND
C
C      PROCESS COEFFICIENT
C
 500   IOBF16=' '
       DO 520 J=1,8
       IC=IC+1
       IF (IC.GT.LEN) GOTO 9901
       IC1=BYT160(IC)
       IF (IC1.EQ.ENDCHR) GOTO 530
       IOBF16(J:J)=IC1
 520   CONTINUE
       IC=IC+1
       IF (IC.GT.LEN) GOTO 9901
       IC1=BYT160(IC)
       IF (IC1.NE.ENDCHR) GOTO 9914
C                                       ! ERROR: COEF NAME TOO LONG
C
C  -     WHICH COEF. NO.?
  530  IF (IOBF16.EQ.' ') GOTO 9916
C                                       ! ERROR: COEF NAME MISSING
       CALL MOVRIT(16,IOBF16)
CD      WRITE (OUT,*) 'AFTER MOVRIT, IOBF16= ',IOBF16
       READ (IOBF16,531,ERR=540) X
  531  FORMAT (F16.0)
C  -     DECODED, SO THIS IS A CONSTANT COEF
       IF (NCOC2.GE.NCOC1) THEN
		DO 532 I=NCOC1,NCOC2
		IF (X.EQ.COEF(I)) GOTO 550
  532		CONTINUE
       ENDIF
C  -     ADD NEW CONSTANT COEF
       NCOC2=NCOC2+1
       IF (NCOC2.GT.MAXCO) THEN
		J=1+MAXCO-NCOC1
		WRITE (OUT,*) 'TOO MANY CONSTANT COEFFICIENTS.  MAX =',J
		STOP 'TOO MANY CONSTANT COEFFICIENTS (INSCOD)'
       ENDIF
       COEF(NCOC2)=X
CD      WRITE (OUT,533) NCOC2,COEF(NCOC2)
CD 533  FORMAT (' IN VCOEF: NCOC2=',I5,'  COEF= ',F16.0)
       I=NCOC2
       GOTO 550
C
C  -     DIDN'T DECODE TO A NUMBER, SO THIS IS A VARIABLE COEF
  540  CALL MOVLFT (IOBF16)
       IF (NCOEFV.GT.0) THEN
	        DO 541 I=1,NCOEFV
 	        IF (IOBF16(1:8).EQ.COEFNM(I)) GOTO 550
  541  		CONTINUE
       ENDIF
C  -     ADD NEW VARIABLE COEF
       NCOEFV=NCOEFV+1
       IF (NCOEFV.EQ.NCOC1) THEN
		J=NCOC1-1
		WRITE (OUT,*) 'TOO MANY VARIABLE COEFFICIENTS.  MAX =',J
		STOP 'TOO MANY VARIABLE COEFFICIENTS'
       ENDIF
       COEFNM(NCOEFV)=IOBF16(1:8)
       COEF(NCOEFV)=0.0
CD      WRITE (OUT,542) NCOEFV,COEFNM(NCOEFV),COEF(NCOEFV)
CD 542  FORMAT (' IN VCOEF: NCOEFV=',I5,' COEFNM=',A8,'COEF= ',F16.0)
       I = NCOEFV
C
 550   WRITE (OUTBUF(LOUTBF+1: ),552) BASENO(IOP),I
 552   FORMAT ('A',I1,'(',I5,')')
       LOUTBF=LOUTBF+9
       IF (LOUTBF.GT.132) STOP '.INS CODE LINE TOO LONG'
       GOTO 200
C
C      OUTPUT INSTRUCTION TO FILE OF FORTRAN CODE
C
  900  L2=MIN0(64,LOUTBF)
       IF (CONTLN) THEN
               CALL CHKKOD (1)
               WRITE (CODEU,902) OUTBUF(1:L2)
  902          FORMAT (5X,'& ',A)
       ELSE
               CALL CHKKOD (0)
               WRITE (CODEU,901) OUTBUF(1:L2)
  901          FORMAT (6X,A)
       ENDIF
       CONTLN=IC1.EQ.'&'
  910  IF (L2.GE.LOUTBF) RETURN
       L1=L2+1
       L2=MIN0(L2+64,LOUTBF)
       CALL CHKKOD (1)
       WRITE (CODEU,902) OUTBUF(L1:L2)
       GOTO 910
C
C      ERRORS
C
 9901  WRITE (OUT,8801)
 8801  FORMAT (' INPUT ERROR.  EOL WHEN DECODING OPERAND FOR',
     &   ' INSERTED CODE.')
       GOTO 9990
 9902  WRITE (OUT,8802) IC1
 8802  FORMAT (' INPUT ERROR.  UNRECOGNIZED OPERAND CHARACTER: ',A1)
       GOTO 9990
 9903  WRITE (OUT,8803) IC1
 8803  FORMAT (' INPUT ERROR.  ILLEGAL OPERAND FOR INSERTED ',
     &   'CONSTR CODE. OPERAND TYPE=',A1)
       GOTO 9990
 9904  WRITE (OUT,8804) IC1
 8804  FORMAT (' INPUT ERROR.  ILLEGAL OPERAND FOR INSERTED ',
     &   'DIFFUN CODE. OPERAND TYPE=',A1)
       GOTO 9990
 9905  WRITE (OUT,8805) IC1
 8805  FORMAT (' INPUT ERROR.  BLANK EXPECTED AFTER OPERAND CHAR: ',A1)
       GOTO 9990
 9906  WRITE (OUT,8806) IOBF16(1:4)
 8806  FORMAT (' INPUT ERROR.  RXN LABEL TOO LONG OR CLOSING " MISSING'
     &   ,'.  FIRST PART OF LABEL=',A4)
       GOTO 9990
 9907  WRITE (OUT,8807) OPCHR(IOP)
 8807  FORMAT (' INPUT ERROR.  NO RXN LABEL AFTER OPERAND CHAR ',A1)
       GOTO 9990
 9908  WRITE (OUT,8808) IOBF16(1:4)
 8808  FORMAT (' INPUT ERROR.  REACTION NO. ',A4,' HAS NO K')
       GOTO 9990
 9909  WRITE (OUT,8809) IOBF16(1:4)
 8809  FORMAT (' INPUT ERROR.  REACTION NO. ',A4,' NOT FOUND')
       GOTO 9990
 9912  WRITE (OUT,8812) ENDCHR,IOBF16
 8812  FORMAT (' INPUT ERROR.  SPECIES NAME TOO LONG OR CLOSING ',A1,
     &   ' MISSING.  FIRST PART OF NAME=',A16)
       GOTO 9990
 9913  WRITE (OUT,8813) IOBF16
 8813  FORMAT (' INPUT ERROR.  SPECIES FOR INSERTED DIFFUN ',
     &   'CODE MUST BE ACTIVE OR CONSTANT.  ILLEGAL SPECIES =',A16)
       GOTO 9990
 9914  WRITE (OUT,8814) ENDCHR,IOBF16(1:8)
 8814  FORMAT (' INPUT ERROR.  COEF NAME TOO LONG OR CLOSING ',A1,
     &   ' MISSING.  FIRST PART OF NAME=',A8)
       GOTO 9990
 9915  IF (ENDCHR.EQ.'"') THEN
             WRITE (OUT,8815) OPCHR(IOP)
 8815        FORMAT (' INPUT ERROR.  MISSING SPECIES NAME AFTER OPERAND'
     &       ,' CHAR ',A1)
       ELSE
             WRITE (OUT,8715)
 8715        FORMAT (' INPUT ERROR.  MISSING SPECIES NAME AFTER ''[''.')
       ENDIF
       GOTO 9990
 9916  IF (ENDCHR.EQ.'"') THEN
             WRITE (OUT,8816) OPCHR(IOP)
 8816        FORMAT (' INPUT ERROR.  MISSING COEF NAME AFTER OPERAND ',
     &        'CHAR ',A1)
       ELSE
             WRITE (OUT,8716)
 8716        FORMAT (' INPUT ERROR.  MISSING COEF NAME AFTER ''.')
       ENDIF
       GOTO 9990
 9917  WRITE (OUT,8817) IOBF16
 8817  FORMAT (' INPUT ERROR.  SPECIES ',A16,' NOT FOUND')
C
 9990  NERR=NERR+1
        WRITE (ICRT,8892) IOB160(1:LEN)
 8892  FORMAT (' ERROR IN INSERTED CODE.  INPUT LINE GIVEN BELOW:'
     &  /' ',A)
C
       RETURN
       END
