      SUBROUTINE PNHRXN
C
C      PRODUCE CODES FOR INTEGRATION SUBROUTINES
C
       INCLUDE 'PSPECS.FOR'
C
       LOGICAL U2OPEN
C
C     SPECIES ORDERING ASSUMED:  CONSTANT, BUILDUP, DUMMY, ACTIVE,
C     STEADY-STATE
C
       U2OPEN=.FALSE.
C
C     PRODUCE CODES FOR CONSTR, BLDUP, DIFFUN, PEDERV, AND SXTRA.
C     PEDERV OPTION REMOVED IN THIS VERSION.
C     NOTE VCOEF REQUIRES INPUT OF MACHINE INSTRUCTIONS.
C
C	INITIALIZE ASMD
C
	CALL ASMINI
C
C
	IF (FORM3.EQ.1) THEN
		WRITE (UNIT3,1013) 'REAL'
 1013		FORMAT ('      SUBROUTINE CONSTR (A0,A5,A1,A3,TIME,TEMP)'/
     &			'C     SUBROUTINE CONSTR (C ,A ,RK,CO,TIME,TEMP)'/
     &			'      ',A,' A0(*),A5(*),A1(*),A3(*),R0,R1')
	ELSEIF (FORM3.EQ.2) THEN
		WRITE (UNIT3,1013) 'DOUBLE PRECISION'
	ELSE
		WRITE (UNIT3,1012) 'CONSTR'
	ENDIF
 1012	FORMAT (6X,'SUBROUTINE ',A,' (A0,A1,A2,A3,A4,A5,A6,TIME,TEMP)'
     &	 /6X,'REAL A0(*),A1(*),A2(*),A3(*),A4(*),A5(*),A6(*)'
     &   /6X,'REAL R0,R1,R2')
       WRITE (UNIT3,*) '      LOGICAL FIRST/.FALSE./'
C
       IF (VCOCAL(1).OR.VCOCAL(4)) THEN
C                                           ! '.#C1' OR 'INS INIT'
              WRITE (OUT,1001)
 1001         FORMAT (/' INITIAL CONSTR CODE INSERTED:')
       ENDIF
       IF (VCOCAL(1)) THEN
C                                            ! '.#C1'
               ASSIGN 1004 TO IGO
               IND=1
               GOTO 2000
       ENDIF
 1004  IF (VCOCAL(4)) THEN
C                                            ! '.INS INIT'
               ASSIGN 1005 TO IGO
               IND=4
               GOTO 2000
       ENDIF
 1005  IF (NGRPS.GT.0) CALL CONSTR
       CALL SECTN
C
	IF (FORM3.EQ.1) THEN
		WRITE (UNIT3,1014) 'REAL'
 1014		FORMAT ('      SUBROUTINE BLDUP (A1,A2,A3,A4,A7,TIME,TEMP)'/
     &			'C     SUBROUTINE BLDUP (RK,R ,CO,FR,LR,TIME,TEMP)'/
     &			'      ',A,' A1(*),A2(*),A3(*),A4(*),A7(*),R0,R1')
	ELSEIF (FORM3.EQ.2) THEN
		WRITE (UNIT3,1014) 'DOUBLE PRECISION'
	ELSE
		WRITE (UNIT3,1012) 'BLDUP'
	ENDIF
C
       IF (NB.GT.0) CALL BLDUP
       CALL SECTN
C
	IF (FORM3.EQ.1) THEN
		WRITE (UNIT3,1015) 'REAL'
 1015		FORMAT (
     &		 '      SUBROUTINE DIFUN (A0,A5,A6,A1,A2,A3,A4,A7,',
     &			 'TIME,TEMP)'/
     &		 'C     SUBROUTINE DIFUN (C ,A ,S ,RK,R ,CO,FR,LR,',
     &			 'TIME,TEMP)'/
     &		 '      ',A,' A0(*),A5(*),A6(*),A1(*),A2(*),A3(*)',
     &			',A4(*),A7(*),'/
     &		 '     & R0,R1')
	ELSEIF (FORM3.EQ.2) THEN
		WRITE (UNIT3,1015) 'DOUBLE PRECISION'
	ELSE
		WRITE (UNIT3,1012) 'DIFUN'
	ENDIF
C
       IF (VCOCAL(2).OR.VCOCAL(5)) THEN
               WRITE (OUT,1201)
 1201          FORMAT (/' INITIAL DIFFUN CODE INSERTED:')
       ENDIF
C
C	DEFINE SUM-OF-SPECIES COEFFICIENTS, IF ANY
C	USES YBASE=5,CBASE=0 (SEE PARAMETERS IN DIFFUN.FOR)
C
	IF (NSUM.GT.0) THEN
	    DO 70 ISUM=1,NSUM
		IOBF16=SUMCOE(ISUM)
		DO 73 I=ND1,ND2
		    IF (IOBF16(1:8).EQ.NAME(I)) THEN
			IND=I
			GOTO 74
		    ENDIF
   73		CONTINUE
		WRITE (OUT,*) 'BAD SUM INPUT. ',IOBF16(1:8)
     &		,' NOT A DUMMY SPECIES'
		WRITE (ICRT,*) 'BAD SUM INPUT. ',IOBF16(1:8)
     &		,' NOT A DUMMY SPECIES'
   74		CONTINUE
		DO 71 I=1,NSUMSP(ISUM)
		    IOBF16=SUMSPE(ISUM,I)
		    DO 72 J=NA1,NA2
			IF (IOBF16(1:8).EQ.NAME(J)) THEN
			    IF (I.EQ.1) THEN
				CALL LOAD(0,J-N0,5)
			    ELSE
				CALL ADD(0,J-N0,5)
			    ENDIF
			    GOTO 71
			ENDIF
   72		    CONTINUE
		    WRITE (OUT,*) 'BAD SUM INPUT FOR ',NAME(IND),
     &		     ': ',IOBF16(1:8),' NOT ACTIVE SPECIES'
		    WRITE (ICRT,*) 'BAD SUM INPUT FOR ',NAME(IND),
     &		     ': ',IOBF16(1:8),' NOT ACTIVE SPECIES'
		    NERR=NERR+1
  71		CONTINUE
		CALL STORE(0,IND,0)
  70	    CONTINUE
	ENDIF
C
       IF (VCOCAL(2)) THEN
C                                            ! '.#D1'
               ASSIGN 1204 TO IGO
               IND=2
               GOTO 2000
       ENDIF
 1204  CONTINUE
C
       IF (VCOCAL(5)) THEN
C                                            ! '.INS DIFF'
               ASSIGN 1205 TO IGO
               IND=5
               GOTO 2000
       ENDIF
 1205  CONTINUE
       CALL DIFFUN
C
       CALL SECTN
C
C      WRITE DUMMY PEDERV ENTRY
	WRITE (UNIT3,1012) 'PEDERV'
       CALL SECTN
C
	WRITE (UNIT3,1012) 'SXTRA'
C
       IF (VCOCAL(3).OR.VCOCAL(6)) THEN
               WRITE (OUT,1301)
 1301          FORMAT (/' PRINT/SAVE CODE INSERTED:')
       ENDIF
       IF (VCOCAL(3)) THEN
C                                      ! '.#PS'
               ASSIGN 1304 TO IGO
               IND=3
               GOTO 2000
       ENDIF
 1304  IF (VCOCAL(6)) THEN
C                                      ! '.INS SAVE'
               ASSIGN 1305 TO IGO
               IND=6
               GOTO 2000
       ENDIF
 1305  CALL SECTN
C
C      DONE
C
 1900  IF (U2OPEN) CLOSE (UNIT=UNIT2,STATUS='DELETE')
C
       CALL SUBEND
C
	WRITE (OUT,6) NC1
   6   	FORMAT (/' CODE PREPARED.  LENGTH=',I5,' STATEMENTS')
	IF (DIFNUM.GT.0) WRITE (OUT,7) DIFNUM
   7	FORMAT (' CODE HAD TO BE SPLIT INTO',I3,' SECTIONS')
	IF (DIFNUM.GT.99) THEN
		STOP 'NO MORE THAN 99 OUTPUT SECTIONS ALLOWED.'
	ENDIF
C
C      NOW NS MEANS TOTAL SPECIES AGAIN
       RETURN
C -------------------------------------------------------------------
C      INTERNAL SUBROUTINE TO READ COMMANDS FOR VCOEF
C
 2000  IF (.NOT.U2OPEN) THEN
              IOB160=' '
              CALL FILNAM (NLEN,IOB160,TMPUIC,'VCOPRP.TMP ',' ')
              OPEN (UNIT=UNIT2,FILE=IOB160,STATUS='OLD')
              U2OPEN=.TRUE.
       ELSE
              REWIND UNIT2
       ENDIF
C
 2010	IOB160=' '
	READ (UNIT2,2011,END=2090) J,IOB160
 2011	FORMAT (I1,A)
	IF (J.EQ.IND) THEN
		L=LENSTR(IOB160,160)
		WRITE (OUT,2021) (BYT160(I),I=1,L)
 2021		FORMAT (' ',6X,80A1,:/(' ',4X,'& ',80A1))
		IF (IND.LE.3) THEN
			CALL VCOEF(L,IND)
		ELSE
			CALL INSCOD(L,IND-3)
		ENDIF
	ENDIF
	GOTO 2010
C
 2090	GOTO IGO,(1004,1005,1204,1205,1304,1305)
C -------------------------------------------------------------------
       END
