	PROGRAM PRP
C
C	RUNS PREP FOR A MECHANISM.  USES MODELING.PRM
C	TO FIND MOD DIRECTORY.  .PRP FILE MUST BE IN DEFAULT DIRECTORY
C
C	USES "INTCL.BAT" TO COMPILE AND LINK
C
C	P1 = MODEL NAME
C	P2 = INTCL OPTIONS.
C
C	MODELING.PRM DATA
C
C	MOD=		WHERE .MOD FILES GO
C
	LOGICAL ANS,SAVE
	CHARACTER INLIN*80,MODEL*8,MODUIC*40,FILNAM*60,OPTION*60
	CHARACTER SRCUIC*60,INTLIB*60,SUBLIB*60
C
C
C	GET MODEL NAME FROM COMMAND LINE
C
	CALL GETARG (1,MODEL)
	IF (MODEL(1:1).EQ.' ') THEN
		WRITE (6,*) 'Use:  PRP modelname [SAVE]'
		WRITE (6,*) '      SAVE ... save Fortran file'
		CALL EXIT (2)
	ENDIF
	CALL GETARG (2,OPTION)
	SAVE=.FALSE.
	IF (OPTION(1:5).EQ.'SAVE ') THEN
		SAVE=.TRUE.
	ELSEIF (OPTION(1:1).NE.' ') THEN
		WRITE (6,*) 'Unrecognized option: '''
     &		 //OPTION(1:LNBLNK(OPTION))//''''
	ENDIF
	LMOD=LNBLNK(MODEL)
C
C	GET DIR'S FROM MODELING.PRM
C
	MODUIC=' '
	LMODUC=0
	LSRCUC=0
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
   10	READ (1,'(A)',END=18) INLIN
	L=LNBLNK(INLIN)
	IF (INLIN(1:4).EQ.'MOD=') THEN
		MODUIC=INLIN(5:)
		LMODUC=L-4
	ELSEIF (INLIN(1:7).EQ.'SOURCE=') THEN
		SRCUIC=INLIN(8:)
		LSRCUC=L-7
	ENDIF
	GOTO 10
   18	CLOSE (UNIT=1)
C
C	SEE IF ".PRP" FILE EXISTS
C
	INQUIRE (FILE=MODEL(1:LMOD)//'.PRP',EXIST=ANS)
C
	IF (.NOT.ANS) THEN
		WRITE (6,*) 'File = ',MODEL(1:LMOD),'.PRP',
     &		 ' does not exist.'
		CALL EXIT (2)
	ENDIF
C
C	SEE IF INT AND SUBS LIBRARIES EXIST
C
	IF (LSRCUC.EQ.0) THEN
		INTLIB='INT.LIB'
		LINTLB=7
		SUBLIB='SUBS.LIB'
		LSUBLB=8
	ELSE
		INTLIB=SRCUIC(1:LSRCUC)//'INT/INT.LIB'
		LINTLB=LSRCUC+11
		SUBLIB=SRCUIC(1:LSRCUC)//'SUBS.LIB'
		LSUBLB=LSRCUC+8
		INQUIRE (FILE=INTLIB(1:LINTLB),EXIST=ANS)
		IF (.NOT.ANS) THEN
			WRITE (6,*) 'Bad or missing SOURCE= in MODELING.PRM'
     &			 //' missing program library file(s):'
			WRITE (6,*) INTLIB(1:LINTLB)
			WRITE (6,*) SUBLIB(1:LSUBLB)
			CALL EXIT (2)
		ENDIF
	ENDIF
C	DELETE OLD MODEL OUTPUT FILES
C
	IF (LMODUC.NE.0) THEN
		FILNAM=MODUIC(1:LMODUC)
		LFIL=LMODUC+LMOD
		FILNAM(LMODUC+1:LFIL)=MODEL
	ELSE
		FILNAM=MODEL(1:LMOD)
		LFIL=LMOD
	ENDIF
C
	FILNAM(LFIL+1:LFIL+4)='.OBJ'
	OPEN (UNIT=1,FILE=FILNAM,STATUS='UNKNOWN')
	CLOSE (UNIT=1,STATUS='DELETE')
C
	FILNAM(LFIL+1:LFIL+4)='.EXE'
	OPEN (UNIT=1,FILE=FILNAM,STATUS='UNKNOWN')
	CLOSE (UNIT=1,STATUS='DELETE')
C
	FILNAM(LFIL+1:LFIL+4)='.FOR'
	OPEN (UNIT=1,FILE=FILNAM,STATUS='UNKNOWN')
	CLOSE (UNIT=1,STATUS='DELETE')
C
C	SOURCE UIC MUST BE SPECIFIED IN MODELING.PRM FOR THIS
C	VERSION TO RUN
C
C	RUN PREP.  FAILED IF NO .FOR FILE.
C
	WRITE (6,*) 'Preparing ',MODEL(1:LMOD),'.FOR and ',
     &	 MODEL(1:LMOD),'.MOD'
	WRITE (INLIN,111) 'PREP ',MODEL
  111	FORMAT (A,A,A,A)
	CALL SYSTEM(INLIN)
C
	INQUIRE (FILE=MODEL(1:LMOD)//'.MOD',EXIST=ANS)
	IF (.NOT.ANS) THEN
		WRITE (6,*) 'Prep failed.  See ',MODEL(1:LMOD),'.PRO.'
		CALL EXIT (2)
	ENDIF
C
C
C	COMPILE AND LINK.  FAILED IF NO .EXE FILE
C
	WRITE (6,*) 'Compiling and linking '//MODEL(1:LMOD)//'.EXE'
	CALL SYSTEM ('gfortran '//FILNAM(1:LFIL+4)//' '//
     &	 INTLIB(1:LINTLB)//' '//SUBLIB(1:LSUBLB)//
     &	 ' -o '//FILNAM(1:LFIL)//'.EXE')
C
	INQUIRE (FILE=FILNAM(1:LFIL)//'.EXE',EXIST=ANS)	
	IF (ANS) THEN
		WRITE (6,*) 'Model prepared.'
		IF (SAVE) THEN
			WRITE (6,*) 'Files = '//MODEL(1:LMOD)//
     &			 '.PRO, .MOD, .FOR and .EXE created.'
		ELSE
C			DELETE .FOR FILE
			OPEN (UNIT=1,FILE=FILNAM,STATUS='UNKNOWN')
			CLOSE (UNIT=1,STATUS='DELETE')
			WRITE (6,*) 'Files = '//MODEL(1:LMOD)//
     &			 '.PRO, .MOD and .EXE created.'
		ENDIF
		CALL EXIT (0)
	ELSE
		WRITE (6,*) 'Compile failed. No .EXE file created.'
		WRITE (6,*) 'Files = '//MODEL(1:LMOD)//
     &		 '.PRO, .MOD and .FOR created.'
		CALL EXIT (1)
	ENDIF
	END
