	PROGRAM CLCTOCSV
C
C	CONVERTS DATA IN .CLC FILES TO CSV FORMAT
C	CHECKS FOR DUPLICATES AND USES LATEST VERSION
C	FLAGS "ADJUSTED PRODUCT" ENTRIES
C
C	USE: CLCTOCSV scenid
C
C	INPUT FROM scenid.CLC FILE IN CLC= DIRECTORY IN MODELING.PRM
C	OUTPUT TO scenid.CSV FILE IN LOCAL DIRECTORY.
C
	PARAMETER (MAXDMS=2000)
	REAL IR(MAXDMS),MR(MAXDMS),PCTCHG(MAXDMS),ADDED(MAXDMS),
     &	 KR(MAXDMS)
	CHARACTER SCENID*8,CLCUIC*40,INLIN*512,NAMEIN*8,
     &	 DMSNAM(MAXDMS)*8,APIND(MAXDMS)*2
	LOGICAL ERRIND
C
C
C	GET SCENID FROM COMMAND LINE
C
	CALL GETARG (1,SCENID)
	IF (SCENID(1:1).EQ.' '.OR.SCENID(1:1).EQ.'?') THEN
		WRITE (6,*) 'CONVERTS DATA IN .CLC FILES TO CSV FORMAT'
		WRITE (6,*) 'USE: CLCTOCSV scenid'
		WRITE (6,*) 'INPUT FROM scenid.CLD FILE IN CLC= DIRECTORY',
     &		' IN MODELING.PRM'
		WRITE (6,*) 'OUTPUT TO scenid.CSV FILE IN LOCAL DIRECTORY.'
		CALL EXIT
	ENDIF
	LSCNID=LNBLNK(SCENID)
C
C	GET INPUT UIC FROM MODELING.PRM AND OPEN INPUT FILE.
C
	CLCUIC='.\'
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
   10	READ (1,1,END=19) INLIN
    1	FORMAT (A)
	IF (INLIN(1:4).EQ.'CLC=') THEN
		CLCUIC=INLIN(5:)
	ENDIF
	GOTO 10
   19	CLOSE (UNIT=1)
C
	OPEN (UNIT=1,FILE=CLCUIC(1:LNBLNK(CLCUIC))//SCENID(1:LSCNID)
     &	 //'.CLC',STATUS='OLD',ERR=20)
	GOTO 21
   20	WRITE (6,*) 'File=',CLCUIC(1:LNBLNK(CLCUIC))//SCENID(1:LSCNID)//
     &	 '.CLC does not exist.'
	CALL EXIT
   21	CONTINUE
C
C	READ INPUT LINES.  IGNORE LINES WITH BLANK, "BASE", OR "!"
C
	NDMS=0
C
 1000	READ (1,'(A8,20X,A)',END=1999) NAMEIN,INLIN
	IF (NAMEIN(1:1).EQ.' '.OR.NAMEIN(1:1).EQ.'!'.OR.
     &	 NAMEIN.EQ.'BASE    ') GOTO 1000
C
	CALL PARSE0 (7,INLIN,80)
	CALL PARSER (7,X,ERRIND,NAMEIN)
C
	IDMS=0
	IF (NDMS.NE.0) THEN
		DO 1001 I=1,NDMS
		IF (NAMEIN.EQ.DMSNAM(I)) THEN
			IF (ERRIND) THEN
				IF (APIND(I).EQ.',') THEN
					IDMS=I
					GOTO 1002
				ENDIF
			ELSEIF (APIND(I).EQ.'1,') THEN
				IDMS=I
				GOTO 1002
			ENDIF
		ENDIF
 1001		CONTINUE
	ENDIF
 1002	CONTINUE

	IF (IDMS.EQ.0) THEN
		IF (NDMS.EQ.MAXDMS) STOP 'INCREASE MAXDMS'
		NDMS=NDMS+1
		DMSNAM(NDMS)=NAMEIN
    		IF (ERRIND) THEN
    			APIND(NDMS)=','
    		ELSE
    			APIND(NDMS)='1,'
    		ENDIF
		IDMS=NDMS
	ENDIF
C
	CALL PARSER (1,IR(IDMS),ERRIND,INLIN)
	IF (ERRIND) GOTO 800
	CALL PARSER (2,MR(IDMS),ERRIND,INLIN)
	IF (ERRIND) GOTO 800
	CALL PARSER (3,PCTCHG(IDMS),ERRIND,INLIN)
	IF (ERRIND) GOTO 800
	CALL PARSER (5,ADDED(IDMS),ERRIND,INLIN)
	IF (ERRIND) GOTO 800
	CALL PARSER (6,KR(IDMS),ERRIND,INLIN)
	IF (ERRIND) GOTO 800
	GOTO 1000
C
  800	WRITE (6,*) 'Bad input line for ',NAMEIN
	WRITE (6,*) 'Data = ',INLIN(1:LNBLNK(INLIN))
	STOP 'ABORTED'
C
C	END OF INPUT.  OUTPUT DATA
C
 1999	CLOSE (UNIT=1)
	OPEN (UNIT=1,FILE=SCENID(1:LSCNID)//'.CSV',STATUS='UNKNOWN')
	CALL CHDATE (NAMEIN)
	IF (NAMEIN(7:7).EQ.':') NAMEIN(7:7)='0'
	WRITE (1,2001) SCENID(1:LSCNID),NAMEIN(1:LNBLNK(NAMEIN)),
     &	 (DMSNAM(IDMS)(1:LNBLNK(DMSNAM(IDMS))),
     &	 APIND(IDMS)(1:LNBLNK(APIND(IDMS))),IR(IDMS),
     &	 MR(IDMS),KR(IDMS),PCTCHG(IDMS)/100.0,ADDED(IDMS),IDMS=1,NDMS)
 2001	FORMAT(A,',,',A//'DMS,AP,IncRct,MechRct,KinRct,Chg,Added'/
     &   (A,',',A,1PE10.3,',',0PF8.4,',',F6.4,',',F6.4,',',F8.4))
C
	CLOSE (UNIT=1)
	WRITE (6,*) 'File=',SCENID(1:LSCNID),'.CSV created.'
	WRITE (6,*) 'DMS processed:',NDMS
	CALL EXIT
	END