	SUBROUTINE INCRCT (THCID,CDTU,CLCU,CLDU,IND,
     &	 TSTHC,RCTFAC,O3KODE,NMXC,MXCONC,BASDAT,CORFAC,TSTNC,TSTMWT,
     &	 TSTID)
C
C	SUMMARIZES RESULTS OF INCREMENTAL REACTIVITY CALCULATIONS.
C	COMPARES TEST CALC WITH BASE CALC.  NO NORMALIZATION.
C
C	ARGUMENTS (UNIT NUMBERS FOR OPEN FILES)
C		THCID = TESTHC ID
C		CDTU = UNIT NO. FOR .CDA FILE FOR CALC
C		CLCU = UNIT NO. .CLC FILE TO APPEND.
C		CLDU = UNIT NO. .CLD FILE TO APPEND.
C		IND  = STATUS.  -1 = ERROR.
C		TSTHC =  TESTHC ADDED
C		RCTFAC = FRACTION TESTHC REACTED
C		O3KODE = 0 USE O3MAX FOR REACTIVITY (ON CLCU)
C			 1 USE O3-NO FOR REACTIVITY (ON CLCU)
C		NMXC = NO. MAX CONC'S TO SAVE (INCL O3)
C		MXCONC = MAX, TIME MAX, FINAL, SUM CONC'S
C		BASDAT = BASE RESULT (TYPE DEPENDS ON O3KODE)
C		CORFAC = CORRECTION FACTOR FROM .BAS FILE
C		TSTNC = TESTHC #CARBONS TO PUT IN .CLC FILE (IF MWT NONZERO)
C		TSTMW = TESTHC MWT TO PUT IN .CLC FILE (IF NONZERO)
C		TSTID = TESTHC IDENTITY TO PUT IN .CLC FILE (IF MWT NONZERO)
C
	CHARACTER THCID*8,TSTID*60
	INTEGER CDTU,CLCU,CLDU,IND,O3KODE,NMXC
	REAL TSTHC,RCTFAC,BASDAT,CORFAC
	REAL MXCONC(4,NMXC)
C
C	THIS VERSION GETS ALL BASE CASE DATA FROM CALLING ROUTINE.
C
C	DOES NOT CHECK FOR VALIDITY OF LABELS, SINCE IT DOESN'T
C	HAVE ACCESS TO BASE CASE LABEL.
C
C	CURRENTLY IMPLEMENTED:
C		O3-NO MAXIMUM OR O3MAX
C
C	DATA FOR READING CDT FILES
C
	PARAMETER (MAXCHN=250,MAXNPT=120)
	CHARACTER*16 NAME(MAXCHN)
	REAL DATBUF(MAXCHN),O3DAT(MAXNPT),TSTIO3,TSTIOH,IO3DAT(MAXNPT)
	COMMON /SCRTCHD/ DATBUF,O3DAT,IO3DAT
	COMMON /SCRTCHC/ NAME
C
	REAL PCTCHG
	CHARACTER INLIN*80,NAMEIN*8
C
C	INITIALIZE
C
C	IF FACTOR REACTED IS NOT KNOWN EXACTLY, USE REACTIVITY FACTOR
C	OF ONE.  (NEGITIVE FACTOR INDICATES AN ESTIMATE USED.)
C
	IF (RCTFAC.LT.0.0) THEN
		RFACT=1.0
	ELSE
		RFACT=RCTFAC
	ENDIF
C
C
C	READ CDT FILES.
C
C	READ IN 'HEADER' RECORDS
C
	READ (CDTU,'(2X,I5)',END=811,ERR=810) NCHN
	IF (NCHN.GT.MAXCHN) THEN
		WRITE (6,*) 'INCREASE MAXCHN IN BASRCT, INCRCT, LOGCHG'
		IND=-1
		RETURN
	ENDIF
	READ (CDTU,'(8A11)',ERR=810) (NAME(I),I=1,NCHN)
C
C	FIND WHICH CHANNELS ARE OF INTEREST.
C
	INDO3=0
	INDNO=0
	INDIO3=0
	INDIOH=0
C
	DO 1210 I=1,NCHN
	NAMEIN=NAME(I)(1:8)
	IF (NAMEIN(1:3).EQ.'O3 ') THEN
		INDO3=I
	ELSEIF (NAMEIN(1:3).EQ.'NO ') THEN
		INDNO=I
	ELSEIF (NAMEIN(1:6).EQ.'INTO3 ') THEN
		INDIO3=I
	ELSEIF (NAMEIN(1:6).EQ.'INTOH ') THEN
		INDIOH=I
	ENDIF
 1210	CONTINUE
	IF (INDO3.EQ.0) THEN
		WRITE (6,*) 'Calc has no O3 data.'
		GOTO 900
	ELSEIF (INDNO.EQ.0.AND.O3KODE.EQ.1) THEN
		WRITE (6,*) 'Calc has no NO data.'
		GOTO 900
	ENDIF
C
C
C	READ DATA FROM CALC FILE.  SAVE O3/O3-NO AND INTO3 DATA.
C
	NPT=0
C
 1220	READ (CDTU,1221,END=1250,ERR=810) TSTDAT,(DATBUF(I),I=1,NCHN)
 1221	FORMAT (F10.2/(1PE10.3,7E11.3))
	NPT=NPT+1
	IF (NPT.GT.MAXNPT) THEN
		WRITE (6,*) 'INCREASE MAXNPT IN INCRCT'
		GOTO 810
	ENDIF
	IF (O3KODE.EQ.1) THEN
		O3DAT(NPT)=DATBUF(INDO3)-DATBUF(INDNO)
		IF (NPT.EQ.1) THEN
			O3MNO1=O3DAT(1)
			O3DAT(1)=0.0
			O3NOMX=0.0
		ELSE
			O3DAT(NPT)=O3DAT(NPT)-O3MNO1
C	** NOTE: COMMENT OUT IF/ENDIF IF HONO CALC
			IF (O3DAT(NPT).GT.O3NOMX) THEN
				O3NOMX=O3DAT(NPT)
			ENDIF
		ENDIF
	ELSE
		O3DAT(NPT)=DATBUF(INDO3)
	ENDIF
	IF (INDIO3.NE.0) IO3DAT(NPT)=DATBUF(INDIO3)
	GOTO 1220
C
C	DONE READING DATA
C
C		
 1250	CLOSE (UNIT=CDTU)
C
	IF (INDIO3.NE.0) THEN
		TSTIO3=DATBUF(INDIO3)
	ELSE
		TSTIO3=0.0
	ENDIF
	IF (INDIOH.NE.0) THEN
		TSTIOH=DATBUF(INDIOH)
	ELSE
		TSTIOH=0.0
	ENDIF
C
C	CALC INC RCT DATA AND SAVE ON CLCU
C
	IF (O3KODE.EQ.1) THEN
		TSTDAT=O3NOMX
	ELSE
		TSTDAT=MXCONC(1,1)
	ENDIF
	RTI=(TSTDAT-BASDAT)/(TSTHC*CORFAC)
	IF (BASDAT.NE.0.0) THEN
		PCTCHG=100.0*(TSTDAT-BASDAT)/BASDAT
	ELSE
		PCTCHG=100.
	ENDIF
	IF (TSTMWT.EQ.0.0) THEN
		WRITE (CLCU,1300) THCID,MXCONC(1,1),TSTDAT/CORFAC,RTI,
     &	 	RTI/RFACT,PCTCHG,TSTHC,RFACT
	ELSE
		RMECH=RTI/RFACT
		WRITE (CLCU,1300) THCID,MXCONC(1,1),TSTDAT/CORFAC,RTI,
     &		 RMECH,PCTCHG,TSTHC,RFACT,TSTNC,TSTMWT,TSTID
		WRITE (6,1305) THCID,TSTID(1:LNBLNK(TSTID)),
     &		 RTI*48.0/TSTMWT,
     &		 TSTMWT,RTI,RTI/AMAX1(TSTNC,1.0),TSTNC,RMECH,RFACT
 1305		FORMAT (/' Incremetal reactivity data for ',A8,1X,A/
     &            1X,F10.4,' Gm O3 / Gm VOC (MWt=',F7.2,')'/
     &            1X,F10.4,' Mol O3 / Mol VOC'/
     &            1X,F10.4,' Mol O3 / Mol C VOC (nC=',F4.0,')'/
     &            1X,F9.3,'  Mol O3 / Mol VOC reacted (mechanistic ',
     &           'reactivity)'/
     &            1X,F10.4,' Fraction reacted (kinetic reactivity)'/)
	ENDIF
 1300	FORMAT (A8,2F10.6,1PE11.3,0PF9.4,F8.2,6X,1PE11.3,0PF7.4,8X,
     &   F4.0,F7.2,1X,A)
	CLOSE (UNIT=CLCU)
C
C
C	WRITE ADDITIONAL DETAILED DATA ON CLDU IF APPLICABLE
C
	IF (CLDU.EQ.0) RETURN
C
	IF (NMXC.EQ.1) THEN
		WRITE (CLDU,2097) THCID,TSTHC,RFACT,MXCONC(1,1),
     &		 TSTIO3,TSTIOH
	ELSE
		WRITE (CLDU,2097) THCID,TSTHC,RFACT,MXCONC(1,1),
     &		 TSTIO3,TSTIOH,(MXCONC(1,I),I=2,NMXC),
     &		 (MXCONC(3,I),I=1,NMXC),(MXCONC(4,I),I=1,NMXC)
	ENDIF
 2097	FORMAT (/A8,1P120E12.5)
	WRITE (CLDU,2098) (O3DAT(I),I=1,NPT),TSTNC,TSTMWT
	IF (INDIO3.NE.0) WRITE (CLDU,2098) (IO3DAT(I),I=1,NPT)
 2098	FORMAT (8X,1P18E12.5)
C
C
C	DONE
C
	IND=0
	RETURN
C
C	ERRORS
C
  810	WRITE (6,*) 'Error reading calculation data'
	CLOSE (UNIT=CDTU)
	GOTO 900
  811	WRITE (6,*) 'EOF reading first record of calculation data'	
	CLOSE (UNIT=CDTU)
  900	IND=-1
	CLOSE (UNIT=CLCU)
	IF (CDTU.NE.0) CLOSE (UNIT=CDTU)
	RETURN
	END
