	SUBROUTINE LOGCHG (IND,IUNIT,CALCID,LFIL,FILNAM)
C
C	SUBROUTINE TO REACTCAL USED TO PROCESS RESULTS OF EXPLICIT
C	ADDITION OR SUBSTITUTION CALCULATION.  
C	READ THE .BAS FILE TO GET THE BASE INFO, READ THE .CDA
C	FILE TO GET THE RESULTS, AND LOG RESULTS IN FILE "FILNAM"
C	FOR THIS SUBSTITUTION/ADDITION
C
C	IND: TRUE= LOG BASE LOG, FALSE=READ CALC FILE
C	IUNIT = UNIT NO FOR .CDA OR .BAS FILE (OPEN, CLOSED WHEN DONE)
C	CALCID = 42-CHAR STRING IDENTIFYING CALC.
C	FILNAM = LOG FILE NAME
C	LFIL = LENGTH OF NAME
C
	LOGICAL IND
	INTEGER IUNIT
	CHARACTER CALCID*42,FILNAM*80
C
C	DATA FOR READING CDT FILES
C
	PARAMETER (MAXCHN=300)
	CHARACTER*16 NAME(MAXCHN)
	REAL T,DATBUF(MAXCHN)
	COMMON /SCRTCHD/ DATBUF
	COMMON /SCRTCHC/ NAME
C
	LOGICAL ANS
	CHARACTER INLIN*80
C
C
	O3MAX=0.0
	O3DOSE=0.0
C
	IF (IND) THEN
C
C		GET BASE CASE INFO FROM IUNIT.  READS IT TO END OF
C		FILE, SO IT CAN BE APPENDED TO.
C
  200		READ (IUNIT,'(A)',END=210) INLIN
		IF (INLIN(1:6).EQ.'MAXO3 ') THEN
			READ (INLIN,'(6X,F10.6)') O3MAX
		ELSEIF (INLIN(1:8).EQ.'INTD-O3 ') THEN
			READ (INLIN,'(8X,F11.6)') O3DOSE
		ENDIF
		GOTO 200
  210		CONTINUE
C
	ELSE
C
C		READ REACTCAL.CDA FILE.
C
		READ (IUNIT,'(2X,I5)',ERR=810) NCHN
		IF (NCHN.GT.MAXCHN) THEN
			WRITE (6,*) 'INCREASE MAXCHN IN BASRCT, '
     &			 //'INCRCT, LOGCHG'
			RETURN
		ENDIF
		READ (IUNIT,'(8A11)',ERR=810)
     &		 (NAME(I),I=1,NCHN)
C
C		FIND WHICH CHANNELS ARE OF INTEREST.
		INDO3=0
		DO 1210 J=1,NCHN
		IF (NAME(J)(1:3).EQ.'O3 ') THEN
			INDO3=J
		ENDIF
 1210		CONTINUE
		IF (INDO3.EQ.0) THEN
			WRITE (6,*) 'Calc has no O3 data.'
			GOTO 900
		ENDIF
C
C		READ IN THE DATA.
C
		TLAST=-9999.0
 1220		READ (IUNIT,1221,END=1250,ERR=810) T,
     &		 (DATBUF(I),I=1,NCHN)
 1221		FORMAT (F10.2/(1PE10.3,7E11.3))
		IF (DATBUF(INDO3).GT.O3MAX) O3MAX=DATBUF(INDO3)
		IF (TLAST.NE.-9999.0) O3DOSE=O3DOSE+
     &		 (DATBUF(INDO3)+O3LAST)*(T-TLAST)
		O3LAST=DATBUF(INDO3)
		TLAST=T
		GOTO 1220
C		
 1250		O3DOSE=0.5*O3DOSE
	ENDIF
	CLOSE (UNIT=IUNIT)
C
C	LOG RESULTS IN 'ADDSUB.LOG'
C
	INQUIRE (FILE=FILNAM(1:LFIL),EXIST=ANS)
	IF (.NOT.ANS) THEN
		OPEN (UNIT=IUNIT,FILE=FILNAM(1:LFIL),STATUS='NEW')
		WRITE (IUNIT,*) 'ScenID  ,TestVOC ,Type,Amount,SubFa',
     &		 'c,Calc ,O3max   ,O3dose'
		WRITE (6,*) 'File = ',FILNAM(1:LFIL),' created.'
	ELSE
		OPEN (UNIT=IUNIT,FILE=FILNAM(1:LFIL),STATUS='OLD',
     &		 ACCESS='APPEND')
		WRITE (6,*) 'File = ',FILNAM(1:LFIL),' updated.'
	ENDIF
	WRITE (IUNIT,1251) CALCID,O3MAX,O3DOSE
 1251	FORMAT (A36,',',4X,',',F7.4,',',F8.2)
	CLOSE (UNIT=IUNIT)
	RETURN
C
C
  810	WRITE (6,*) 'Error when reading .CDA data.'
  900	CALL EXIT (2)
	END
