	PROGRAM MROPTM
C
C	FINDS POINT OF HIGHEST NOx REACTIVITY AND ADDS IT TO BAS FILE
C	AS NOx-SNS.
C
C	RUNS INT
C
C	THIS VERSION -- ONLY VARIES NOX
C
	PARAMETER (MAXCAL=50)
C
	INTEGER LCLCUC
	CHARACTER CLCUIC*60,SCNID*8,BASFIL*80
	COMMON /CMCINT/ LCLCUC
	COMMON /CMDCOM/ SCNID,CLCUIC
C
C
	CHARACTER INLIN*80
C
C
C	READ SCENARIO ID
C
	CALL GETARG (1,SCNID)
	IF (SCNID(1:1).EQ.' ') GOTO 800
	LSCNID=LNBLNK(SCNID)
C
C	OPEN LOG FILE
C
	LOGU=8
	OPEN (UNIT=LOGU,FILE='MROPTN.LOG',STATUS='UNKNOWN',
     &	 ACCESS='APPEND')
C
C	INITIALIZE: GET CLC UIC
C
	CLCUIC=' '
	BASFIL=SCNID(1:LSCNID)//'.BAS'
C
	OPEN (UNIT=3,FILE='MODELING.PRM',STATUS='UNKNOWN')
   10	READ (3,1,END=12) INLIN
    1	FORMAT (A)
	IF (INLIN(1:4).EQ.'CLC=') THEN
		LF=LNBLNK(INLIN)
		BASFIL=INLIN(5:LF)//SCNID(1:LSCNID)//'.BAS'
		CLCUIC=INLIN(5:LF)
		LCLCUC=LF-4
	ENDIF
	GOTO 10
   12	CLOSE (UNIT=3)
C
C	DN=0.001
C

C	INITIAL CALCULATIONS:  NOx factors=0.025 and 0.035
C
	FNOX1=0.025
	FNOX2=0.035
	CALL DNCALC (FNOX1,DNOX1,IND)

	IF (IND.NE.0) GOTO 999
	CALL DNCALC (FNOX2,DNOX2,IND)
	IF (IND.NE.0) GOTO 999
	IF (DNOX2.EQ.DNOX1) THEN
		FNOX3=FNOX2
		DNOX3=DNOX2
		FNOX2=0.5*(FNOX1+FNOX3)
		CALL DNCALC (FNOX2,DNOX2,IND)
	ELSEIF (DNOX2.GT.DNOX1) THEN
		FNOX3=0.045
		CALL DNCALC (FNOX3,DNOX3,IND)
	ELSE
		FNOX3=FNOX2
		DNOX3=DNOX2
		FNOX2=FNOX1
		DNOX2=DNOX1
		FNOX1=0.015
		CALL DNCALC (FNOX1,DNOX1,IND)
	ENDIF
	IF (IND.NE.0) GOTO 999
C
C	AT THIS POINT, 3 CALCULATIONS ARE DONE.  FIGURE NEXT ONE
C	ORDER IS NOX1, NOX2, NOX3.
C
 100	CONTINUE
	IF (DNOX1.GT.DNOX2) THEN
C		1 > 2: GO DOWN EQUAL STEP
		FNOX3=FNOX2
		DNOX3=DNOX2
		FNOX2=FNOX1
		DNOX2=DNOX1
		FNOX1=FNOX2-(FNOX3-FNOX2)
		IF (FNOX1.LE.0.0) FNOX1=0.5*FNOX2
		CALL DNCALC (FNOX1,DNOX1,IND)
	ELSEIF (DNOX3.GT.DNOX2) THEN
C		3 > 2: GO UP EQUAL STEP
		FNOX1=FNOX2
		DNOX1=DNOX2
		FNOX2=FNOX3
		DNOX2=DNOX3
		FNOX3=FNOX2+(FNOX2-FNOX1)
		CALL DNCALC (FNOX3,DNOX3,IND)
	ELSEIF (DNOX3.GT.DNOX1) THEN
C		2 LARGEST, BETWEEN 2 AND 3
		IF (FNOX3-FNOX2.LT.0.001) THEN
			FNOX=FNOX2
			DNOX=DNOX2
			GOTO 200
		ENDIF
		FNOX1=FNOX2
		DNOX1=DNOX2
		FNOX2=0.5*(FNOX1+FNOX3)
		CALL DNCALC (FNOX2,DNOX2,IND)
	ELSE
C		2 LARGEST, BETWEEN 1 AND 2
		IF (FNOX2-FNOX1.LT.0.001) THEN
			FNOX=FNOX2
			DNOX=DNOX2
			GOTO 200
		ENDIF
		FNOX3=FNOX2
		DNOX3=DNOX2
		FNOX2=0.5*(FNOX1+FNOX3)
		CALL DNCALC (FNOX2,DNOX2,IND)
	ENDIF
	IF (IND.NE.0) GOTO 999
	GOTO 100
C
C	SUCCESS
C
  200	WRITE (LOGU,201) SCNID,FNOX,DNOX
  201	FORMAT (A8,2F10.5)
	WRITE (6,202) SCNID,FNOX,DNOX
  202	FORMAT ('Done: ',A8,' NOx=',F10.4,' d(O3)/d(NOx)=',F10.3)
	WRITE (6,*) 'Results appended to MROPTN.LOG'
	CLOSE (UNIT=LOGU)
C
C	WRITE TO SCENARIO.BAS FILE
C
	OPEN (UNIT=1,FILE=BASFIL,STATUS='OLD',ACCESS='APPEND')
	WRITE (1,203) FNOX,DNOX
  203	FORMAT ('NOx-LNX',F12.6,24X,F12.6)
	CLOSE (UNIT=1)
	WRITE (6,*) 'Results added to '//BASFIL(1:LNBLNK(BASFIL))//'.'
C
	CALL EXIT (0)
C
C	FAILED
C
 999	WRITE (6,*) 'Int failed'
	WRITE (LOGU,2029) SCNID
 2029	FORMAT (A8,' Failed')
	CLOSE (UNIT=LOGU)
	CALL EXIT (2)
C
C	ERRORS
C
  800	WRITE (6,*) 'Use:  MROPTN SCNID'
	WRITE (6,*) 'Where "SCNID" is a base case scenario',
     &	 ' already run (.BAS file exists).'
	CALL EXIT (1)
  810	WRITE (6,*) 'aborted.'
	CALL EXIT (2)
	END
C
	SUBROUTINE DNCALC (NOX,DNOX,IND)
C	CALCULATES NOX REACTIVITY USING REACTCAL
C
	REAL NOX
C
	INTEGER LCLCUC
	CHARACTER CLCUIC*60,SCNID*8
	COMMON /CMCINT/ LCLCUC
	COMMON /CMDCOM/ SCNID,CLCUIC
C
	CHARACTER CMDLIN*80
C
C	DELETE TMP BAS, CLC, CLD FILES
C
	OPEN (UNIT=3,FILE=CLCUIC(1:LCLCUC)//'TMP.BAS',
     &	 STATUS='OLD',ERR=10)
	CLOSE (UNIT=3,STATUS='DELETE')
   10	OPEN (UNIT=3,FILE=CLCUIC(1:LCLCUC)//'TMP.CLD',
     &	 STATUS='OLD',ERR=11)
	CLOSE (UNIT=3,STATUS='DELETE')
   11	OPEN (UNIT=3,FILE=CLCUIC(1:LCLCUC)//'TMP.CLC',
     &	 STATUS='OLD',ERR=12)
	CLOSE (UNIT=3,STATUS='DELETE')
   12	CONTINUE

	CMDLIN=' '
	WRITE (CMDLIN,20) NOX,SCNID
   20	FORMAT ('REACTCAL TMP N=',F7.5,' ',A8)
	CALL SYSTEM (CMDLIN)
	CALL SYSTEM ('REACTCAL TMP NOX')
C
	OPEN (UNIT=3,FILE=CLCUIC(1:LCLCUC)//'TMP.CLC',
     &	 STATUS='OLD',ERR=90)
	READ (3,30,ERR=92) DNOX
   30	FORMAT (/////28X,E11.3)
	CLOSE (UNIT=3)
	IND=0
	RETURN
C
C	ERRORS
C
  90	WRITE (6,*) 'REACTCAL FAILED. CAN''T OPEN '
     &	 //CLCUIC(1:LCLCUC)//'TMP.CLC'
	IND=1
	RETURN
  92	WRITE (6,*) 'ERROR READING DATA IN '//CLCUIC(1:LCLCUC)//
     &	 'TMP.CLC'
	IND=2
	RETURN
	END